/* Box.c generated by valac 0.42.0, the Vala compiler
 * generated from Box.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>


#define TYPE_BOX_LOCATION (box_location_get_type ())

#define TYPE_BOX_COMPLEMENTS (box_complements_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	BOX_LOCATION_OUTSIDE,
	BOX_LOCATION_INSIDE,
	BOX_LOCATION_TOP_SIDE,
	BOX_LOCATION_LEFT_SIDE,
	BOX_LOCATION_RIGHT_SIDE,
	BOX_LOCATION_BOTTOM_SIDE,
	BOX_LOCATION_TOP_LEFT,
	BOX_LOCATION_BOTTOM_LEFT,
	BOX_LOCATION_TOP_RIGHT,
	BOX_LOCATION_BOTTOM_RIGHT
} BoxLocation;

typedef enum  {
	BOX_COMPLEMENTS_NONE,
	BOX_COMPLEMENTS_VERTICAL,
	BOX_COMPLEMENTS_HORIZONTAL,
	BOX_COMPLEMENTS_BOTH
} BoxComplements;

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _Dimensions {
	gint width;
	gint height;
};



GType box_location_get_type (void) G_GNUC_CONST;
GType box_complements_get_type (void) G_GNUC_CONST;
BoxComplements box_complements_derive (gboolean horizontal_complement,
                                       gboolean vertical_complement);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
#define BOX_HAND_GRENADES 12
void box_init (Box *self,
               gint left,
               gint top,
               gint right,
               gint bottom);
void box_from_rectangle (GdkRectangle* rect,
                         Box* result);
void box_from_allocation (GtkAllocation* alloc,
                          Box* result);
void box_from_points (GdkPoint* corner1,
                      GdkPoint* corner2,
                      Box* result);
void box_from_center (GdkPoint* center,
                      gint width,
                      gint height,
                      Box* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
gboolean box_is_valid (Box *self);
gboolean box_equals (Box *self,
                     Box* box);
void box_adjust_width (Box *self,
                       gint width);
void box_adjust_height (Box *self,
                        gint height);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void box_get_scaled (Box *self,
                     Dimensions* scaled,
                     Box* result);
void box_get_dimensions (Box *self,
                         Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self,
                                  Dimensions* scaled,
                                  gdouble* width_ratio,
                                  gdouble* height_ratio);
void box_get_scaled_similar (Box *self,
                             Dimensions* original,
                             Dimensions* scaled,
                             Box* result);
void box_get_offset (Box *self,
                     gint xofs,
                     gint yofs,
                     Box* result);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
void box_get_points (Box *self,
                     GdkPoint* top_left,
                     GdkPoint* bottom_right);
void box_get_rectangle (Box *self,
                        GdkRectangle* result);
void box_get_center (Box *self,
                     GdkPoint* result);
void box_rotate_clockwise (Box *self,
                           Dimensions* space,
                           Box* result);
void box_rotate_counterclockwise (Box *self,
                                  Dimensions* space,
                                  Box* result);
void box_flip_left_to_right (Box *self,
                             Dimensions* space,
                             Box* result);
void box_flip_top_to_bottom (Box *self,
                             Dimensions* space,
                             Box* result);
gboolean box_intersects (Box *self,
                         Box* compare);
void box_get_reduced (Box *self,
                      gint amount,
                      Box* result);
void box_get_expanded (Box *self,
                       gint amount,
                       Box* result);
gboolean box_contains (Box *self,
                       GdkPoint* point);
BoxComplements box_resized_complements (Box *self,
                                        Box* resized,
                                        Box* horizontal,
                                        gboolean* horizontal_enlarged,
                                        Box* vertical,
                                        gboolean* vertical_enlarged);
BoxComplements box_shifted_complements (Box *self,
                                        Box* shifted,
                                        Box* horizontal_this,
                                        Box* vertical_this,
                                        Box* horizontal_shifted,
                                        Box* vertical_shifted);
void box_rubber_band (Box *self,
                      GdkPoint* point,
                      Box* result);
gchar* box_to_string (Box *self);
gchar* dimensions_to_string (Dimensions *self);
static gboolean box_in_zone (gdouble pos,
                      gint zone);
static gboolean box_in_between (gdouble pos,
                         gint top,
                         gint bottom);
static gboolean box_near_in_between (gdouble pos,
                              gint top,
                              gint bottom);
BoxLocation box_approx_location (Box *self,
                                 gint x,
                                 gint y);


GType
box_location_get_type (void)
{
	static volatile gsize box_location_type_id__volatile = 0;
	if (g_once_init_enter (&box_location_type_id__volatile)) {
		static const GEnumValue values[] = {{BOX_LOCATION_OUTSIDE, "BOX_LOCATION_OUTSIDE", "outside"}, {BOX_LOCATION_INSIDE, "BOX_LOCATION_INSIDE", "inside"}, {BOX_LOCATION_TOP_SIDE, "BOX_LOCATION_TOP_SIDE", "top-side"}, {BOX_LOCATION_LEFT_SIDE, "BOX_LOCATION_LEFT_SIDE", "left-side"}, {BOX_LOCATION_RIGHT_SIDE, "BOX_LOCATION_RIGHT_SIDE", "right-side"}, {BOX_LOCATION_BOTTOM_SIDE, "BOX_LOCATION_BOTTOM_SIDE", "bottom-side"}, {BOX_LOCATION_TOP_LEFT, "BOX_LOCATION_TOP_LEFT", "top-left"}, {BOX_LOCATION_BOTTOM_LEFT, "BOX_LOCATION_BOTTOM_LEFT", "bottom-left"}, {BOX_LOCATION_TOP_RIGHT, "BOX_LOCATION_TOP_RIGHT", "top-right"}, {BOX_LOCATION_BOTTOM_RIGHT, "BOX_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
		GType box_location_type_id;
		box_location_type_id = g_enum_register_static ("BoxLocation", values);
		g_once_init_leave (&box_location_type_id__volatile, box_location_type_id);
	}
	return box_location_type_id__volatile;
}


BoxComplements
box_complements_derive (gboolean horizontal_complement,
                        gboolean vertical_complement)
{
	BoxComplements result = 0;
	gboolean _tmp0_ = FALSE;
	if (horizontal_complement) {
		_tmp0_ = vertical_complement;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = BOX_COMPLEMENTS_BOTH;
		return result;
	} else {
		if (horizontal_complement) {
			result = BOX_COMPLEMENTS_HORIZONTAL;
			return result;
		} else {
			if (vertical_complement) {
				result = BOX_COMPLEMENTS_VERTICAL;
				return result;
			}
		}
	}
	result = BOX_COMPLEMENTS_NONE;
	return result;
}


GType
box_complements_get_type (void)
{
	static volatile gsize box_complements_type_id__volatile = 0;
	if (g_once_init_enter (&box_complements_type_id__volatile)) {
		static const GEnumValue values[] = {{BOX_COMPLEMENTS_NONE, "BOX_COMPLEMENTS_NONE", "none"}, {BOX_COMPLEMENTS_VERTICAL, "BOX_COMPLEMENTS_VERTICAL", "vertical"}, {BOX_COMPLEMENTS_HORIZONTAL, "BOX_COMPLEMENTS_HORIZONTAL", "horizontal"}, {BOX_COMPLEMENTS_BOTH, "BOX_COMPLEMENTS_BOTH", "both"}, {0, NULL, NULL}};
		GType box_complements_type_id;
		box_complements_type_id = g_enum_register_static ("BoxComplements", values);
		g_once_init_leave (&box_complements_type_id__volatile, box_complements_type_id);
	}
	return box_complements_type_id__volatile;
}


void
box_init (Box *self,
          gint left,
          gint top,
          gint right,
          gint bottom)
{
	memset (self, 0, sizeof (Box));
	left = CLAMP (left, 0, G_MAXINT);
	top = CLAMP (top, 0, G_MAXINT);
	if (right <= left) {
		right = left + 1;
	}
	if (bottom <= top) {
		bottom = top + 1;
	}
	(*self).left = left;
	(*self).top = top;
	(*self).right = right;
	(*self).bottom = bottom;
}


void
box_from_rectangle (GdkRectangle* rect,
                    Box* result)
{
	GdkRectangle _tmp0_;
	gint _tmp1_;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	Box _tmp12_ = {0};
	g_return_if_fail (rect != NULL);
	_tmp0_ = *rect;
	_tmp1_ = _tmp0_.x;
	_tmp2_ = *rect;
	_tmp3_ = _tmp2_.y;
	_tmp4_ = *rect;
	_tmp5_ = _tmp4_.x;
	_tmp6_ = *rect;
	_tmp7_ = _tmp6_.width;
	_tmp8_ = *rect;
	_tmp9_ = _tmp8_.y;
	_tmp10_ = *rect;
	_tmp11_ = _tmp10_.height;
	box_init (&_tmp12_, _tmp1_, _tmp3_, (_tmp5_ + _tmp7_) - 1, (_tmp9_ + _tmp11_) - 1);
	*result = _tmp12_;
	return;
}


void
box_from_allocation (GtkAllocation* alloc,
                     Box* result)
{
	GtkAllocation _tmp0_;
	gint _tmp1_;
	GtkAllocation _tmp2_;
	gint _tmp3_;
	GtkAllocation _tmp4_;
	gint _tmp5_;
	GtkAllocation _tmp6_;
	gint _tmp7_;
	GtkAllocation _tmp8_;
	gint _tmp9_;
	GtkAllocation _tmp10_;
	gint _tmp11_;
	Box _tmp12_ = {0};
	g_return_if_fail (alloc != NULL);
	_tmp0_ = *alloc;
	_tmp1_ = _tmp0_.x;
	_tmp2_ = *alloc;
	_tmp3_ = _tmp2_.y;
	_tmp4_ = *alloc;
	_tmp5_ = _tmp4_.x;
	_tmp6_ = *alloc;
	_tmp7_ = _tmp6_.width;
	_tmp8_ = *alloc;
	_tmp9_ = _tmp8_.y;
	_tmp10_ = *alloc;
	_tmp11_ = _tmp10_.height;
	box_init (&_tmp12_, _tmp1_, _tmp3_, (_tmp5_ + _tmp7_) - 1, (_tmp9_ + _tmp11_) - 1);
	*result = _tmp12_;
	return;
}


void
box_from_points (GdkPoint* corner1,
                 GdkPoint* corner2,
                 Box* result)
{
	GdkPoint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_;
	gint _tmp3_;
	GdkPoint _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	GdkPoint _tmp8_;
	gint _tmp9_;
	GdkPoint _tmp10_;
	gint _tmp11_;
	GdkPoint _tmp12_;
	gint _tmp13_;
	GdkPoint _tmp14_;
	gint _tmp15_;
	Box _tmp16_ = {0};
	g_return_if_fail (corner1 != NULL);
	g_return_if_fail (corner2 != NULL);
	_tmp0_ = *corner1;
	_tmp1_ = _tmp0_.x;
	_tmp2_ = *corner2;
	_tmp3_ = _tmp2_.x;
	_tmp4_ = *corner1;
	_tmp5_ = _tmp4_.y;
	_tmp6_ = *corner2;
	_tmp7_ = _tmp6_.y;
	_tmp8_ = *corner1;
	_tmp9_ = _tmp8_.x;
	_tmp10_ = *corner2;
	_tmp11_ = _tmp10_.x;
	_tmp12_ = *corner1;
	_tmp13_ = _tmp12_.y;
	_tmp14_ = *corner2;
	_tmp15_ = _tmp14_.y;
	box_init (&_tmp16_, MIN (_tmp1_, _tmp3_), MIN (_tmp5_, _tmp7_), MAX (_tmp9_, _tmp11_), MAX (_tmp13_, _tmp15_));
	*result = _tmp16_;
	return;
}


void
box_from_center (GdkPoint* center,
                 gint width,
                 gint height,
                 Box* result)
{
	GdkPoint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_;
	gint _tmp3_;
	GdkPoint _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
	g_return_if_fail (center != NULL);
	_tmp0_ = *center;
	_tmp1_ = _tmp0_.x;
	_tmp2_ = *center;
	_tmp3_ = _tmp2_.y;
	_tmp4_ = *center;
	_tmp5_ = _tmp4_.x;
	_tmp6_ = *center;
	_tmp7_ = _tmp6_.y;
	box_init (&_tmp8_, _tmp1_ - (width / 2), _tmp3_ - (height / 2), _tmp5_ + (width / 2), _tmp7_ + (height / 2));
	*result = _tmp8_;
	return;
}


gint
box_get_width (Box *self)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	_tmp0_ = (*self).right;
	_tmp1_ = (*self).left;
	_vala_assert (_tmp0_ >= _tmp1_, "right >= left");
	_tmp2_ = (*self).right;
	_tmp3_ = (*self).left;
	result = (_tmp2_ - _tmp3_) + 1;
	return result;
}


gint
box_get_height (Box *self)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	_tmp0_ = (*self).bottom;
	_tmp1_ = (*self).top;
	_vala_assert (_tmp0_ >= _tmp1_, "bottom >= top");
	_tmp2_ = (*self).bottom;
	_tmp3_ = (*self).top;
	result = (_tmp2_ - _tmp3_) + 1;
	return result;
}


gboolean
box_is_valid (Box *self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
	_tmp3_ = (*self).left;
	if (_tmp3_ >= 0) {
		gint _tmp4_;
		_tmp4_ = (*self).top;
		_tmp2_ = _tmp4_ >= 0;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		gint _tmp5_;
		gint _tmp6_;
		_tmp5_ = (*self).right;
		_tmp6_ = (*self).left;
		_tmp1_ = _tmp5_ >= _tmp6_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gint _tmp7_;
		gint _tmp8_;
		_tmp7_ = (*self).bottom;
		_tmp8_ = (*self).top;
		_tmp0_ = _tmp7_ >= _tmp8_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gboolean
box_equals (Box *self,
            Box* box)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
	Box _tmp4_;
	gint _tmp5_;
	g_return_val_if_fail (box != NULL, FALSE);
	_tmp3_ = (*self).left;
	_tmp4_ = *box;
	_tmp5_ = _tmp4_.left;
	if (_tmp3_ == _tmp5_) {
		gint _tmp6_;
		Box _tmp7_;
		gint _tmp8_;
		_tmp6_ = (*self).top;
		_tmp7_ = *box;
		_tmp8_ = _tmp7_.top;
		_tmp2_ = _tmp6_ == _tmp8_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		gint _tmp9_;
		Box _tmp10_;
		gint _tmp11_;
		_tmp9_ = (*self).right;
		_tmp10_ = *box;
		_tmp11_ = _tmp10_.right;
		_tmp1_ = _tmp9_ == _tmp11_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gint _tmp12_;
		Box _tmp13_;
		gint _tmp14_;
		_tmp12_ = (*self).bottom;
		_tmp13_ = *box;
		_tmp14_ = _tmp13_.bottom;
		_tmp0_ = _tmp12_ == _tmp14_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


void
box_adjust_width (Box *self,
                  gint width)
{
	gint center_x = 0;
	gint _tmp0_;
	gint _tmp1_;
	_tmp0_ = (*self).left;
	_tmp1_ = (*self).right;
	center_x = (_tmp0_ + _tmp1_) / 2;
	(*self).left = center_x - (width / 2);
	(*self).right = center_x + (width / 2);
}


void
box_adjust_height (Box *self,
                   gint height)
{
	gint center_y = 0;
	gint _tmp0_;
	gint _tmp1_;
	_tmp0_ = (*self).top;
	_tmp1_ = (*self).bottom;
	center_y = (_tmp0_ + _tmp1_) / 2;
	(*self).top = center_y - (height / 2);
	(*self).bottom = center_y + (height / 2);
}


void
box_get_scaled (Box *self,
                Dimensions* scaled,
                Box* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gint l = 0;
	gint _tmp4_;
	gdouble _tmp5_;
	gint t = 0;
	gint _tmp6_;
	gdouble _tmp7_;
	gint r = 0;
	gint _tmp8_;
	Dimensions _tmp9_;
	gint _tmp10_;
	gint b = 0;
	gint _tmp11_;
	Dimensions _tmp12_;
	gint _tmp13_;
	Box box = {0};
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_ = FALSE;
	Dimensions _tmp19_;
	gint _tmp20_;
	g_return_if_fail (scaled != NULL);
	box_get_dimensions (&(*self), &_tmp0_);
	_tmp1_ = *scaled;
	dimensions_get_scale_ratios (&_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
	x_scale = _tmp2_;
	y_scale = _tmp3_;
	_tmp4_ = (*self).left;
	_tmp5_ = x_scale;
	l = (gint) round (((gdouble) _tmp4_) * _tmp5_);
	_tmp6_ = (*self).top;
	_tmp7_ = y_scale;
	t = (gint) round (((gdouble) _tmp6_) * _tmp7_);
	_tmp8_ = l;
	_tmp9_ = *scaled;
	_tmp10_ = _tmp9_.width;
	r = (_tmp8_ + _tmp10_) - 1;
	_tmp11_ = t;
	_tmp12_ = *scaled;
	_tmp13_ = _tmp12_.height;
	b = (_tmp11_ + _tmp13_) - 1;
	_tmp14_ = l;
	_tmp15_ = t;
	_tmp16_ = r;
	_tmp17_ = b;
	box_init (&box, _tmp14_, _tmp15_, _tmp16_, _tmp17_);
	_tmp19_ = *scaled;
	_tmp20_ = _tmp19_.width;
	if (box_get_width (&box) == _tmp20_) {
		_tmp18_ = TRUE;
	} else {
		Dimensions _tmp21_;
		gint _tmp22_;
		_tmp21_ = *scaled;
		_tmp22_ = _tmp21_.height;
		_tmp18_ = box_get_height (&box) == _tmp22_;
	}
	_vala_assert (_tmp18_, "box.get_width() == scaled.width || box.get_height() == scaled.height");
	*result = box;
	return;
}


void
box_get_scaled_similar (Box *self,
                        Dimensions* original,
                        Dimensions* scaled,
                        Box* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gint l = 0;
	gint _tmp3_;
	gdouble _tmp4_;
	gint t = 0;
	gint _tmp5_;
	gdouble _tmp6_;
	gint r = 0;
	gint _tmp7_;
	gdouble _tmp8_;
	gint b = 0;
	gint _tmp9_;
	gdouble _tmp10_;
	gint _tmp11_;
	Dimensions _tmp12_;
	gint _tmp13_;
	gint _tmp16_;
	Dimensions _tmp17_;
	gint _tmp18_;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	Box _tmp25_ = {0};
	g_return_if_fail (original != NULL);
	g_return_if_fail (scaled != NULL);
	_tmp0_ = *scaled;
	dimensions_get_scale_ratios (original, &_tmp0_, &_tmp1_, &_tmp2_);
	x_scale = _tmp1_;
	y_scale = _tmp2_;
	_tmp3_ = (*self).left;
	_tmp4_ = x_scale;
	l = (gint) round (((gdouble) _tmp3_) * _tmp4_);
	_tmp5_ = (*self).top;
	_tmp6_ = y_scale;
	t = (gint) round (((gdouble) _tmp5_) * _tmp6_);
	_tmp7_ = (*self).right;
	_tmp8_ = x_scale;
	r = (gint) round (((gdouble) _tmp7_) * _tmp8_);
	_tmp9_ = (*self).bottom;
	_tmp10_ = y_scale;
	b = (gint) round (((gdouble) _tmp9_) * _tmp10_);
	_tmp11_ = r;
	_tmp12_ = *scaled;
	_tmp13_ = _tmp12_.width;
	if (_tmp11_ >= _tmp13_) {
		Dimensions _tmp14_;
		gint _tmp15_;
		_tmp14_ = *scaled;
		_tmp15_ = _tmp14_.width;
		r = _tmp15_ - 1;
	}
	_tmp16_ = b;
	_tmp17_ = *scaled;
	_tmp18_ = _tmp17_.height;
	if (_tmp16_ >= _tmp18_) {
		Dimensions _tmp19_;
		gint _tmp20_;
		_tmp19_ = *scaled;
		_tmp20_ = _tmp19_.height;
		b = _tmp20_ - 1;
	}
	_tmp21_ = l;
	_tmp22_ = t;
	_tmp23_ = r;
	_tmp24_ = b;
	box_init (&_tmp25_, _tmp21_, _tmp22_, _tmp23_, _tmp24_);
	*result = _tmp25_;
	return;
}


void
box_get_offset (Box *self,
                gint xofs,
                gint yofs,
                Box* result)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Box _tmp4_ = {0};
	_tmp0_ = (*self).left;
	_tmp1_ = (*self).top;
	_tmp2_ = (*self).right;
	_tmp3_ = (*self).bottom;
	box_init (&_tmp4_, _tmp0_ + xofs, _tmp1_ + yofs, _tmp2_ + xofs, _tmp3_ + yofs);
	*result = _tmp4_;
	return;
}


void
box_get_dimensions (Box *self,
                    Dimensions* result)
{
	Dimensions _tmp0_ = {0};
	dimensions_init (&_tmp0_, box_get_width (&(*self)), box_get_height (&(*self)));
	*result = _tmp0_;
	return;
}


void
box_get_points (Box *self,
                GdkPoint* top_left,
                GdkPoint* bottom_right)
{
	GdkPoint _vala_top_left = {0};
	GdkPoint _vala_bottom_right = {0};
	gint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_ = {0};
	gint _tmp3_;
	gint _tmp4_;
	GdkPoint _tmp5_ = {0};
	_tmp0_ = (*self).left;
	_tmp1_ = (*self).top;
	_tmp2_.x = _tmp0_;
	_tmp2_.y = _tmp1_;
	_vala_top_left = _tmp2_;
	_tmp3_ = (*self).right;
	_tmp4_ = (*self).bottom;
	_tmp5_.x = _tmp3_;
	_tmp5_.y = _tmp4_;
	_vala_bottom_right = _tmp5_;
	if (top_left) {
		*top_left = _vala_top_left;
	}
	if (bottom_right) {
		*bottom_right = _vala_bottom_right;
	}
}


void
box_get_rectangle (Box *self,
                   GdkRectangle* result)
{
	GdkRectangle rect = {0};
	gint _tmp0_;
	gint _tmp1_;
	memset (&rect, 0, sizeof (GdkRectangle));
	_tmp0_ = (*self).left;
	rect.x = _tmp0_;
	_tmp1_ = (*self).top;
	rect.y = _tmp1_;
	rect.width = box_get_width (&(*self));
	rect.height = box_get_height (&(*self));
	*result = rect;
	return;
}


void
box_get_center (Box *self,
                GdkPoint* result)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GdkPoint _tmp4_ = {0};
	_tmp0_ = (*self).left;
	_tmp1_ = (*self).right;
	_tmp2_ = (*self).top;
	_tmp3_ = (*self).bottom;
	_tmp4_.x = (_tmp0_ + _tmp1_) / 2;
	_tmp4_.y = (_tmp2_ + _tmp3_) / 2;
	*result = _tmp4_;
	return;
}


void
box_rotate_clockwise (Box *self,
                      Dimensions* space,
                      Box* result)
{
	gint l = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint t = 0;
	gint _tmp3_;
	gint r = 0;
	Dimensions _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint b = 0;
	gint _tmp7_;
	Box _tmp8_ = {0};
	g_return_if_fail (space != NULL);
	_tmp0_ = *space;
	_tmp1_ = _tmp0_.width;
	_tmp2_ = (*self).bottom;
	l = (_tmp1_ - _tmp2_) - 1;
	_tmp3_ = (*self).left;
	t = _tmp3_;
	_tmp4_ = *space;
	_tmp5_ = _tmp4_.width;
	_tmp6_ = (*self).top;
	r = (_tmp5_ - _tmp6_) - 1;
	_tmp7_ = (*self).right;
	b = _tmp7_;
	box_init (&_tmp8_, l, t, r, b);
	*result = _tmp8_;
	return;
}


void
box_rotate_counterclockwise (Box *self,
                             Dimensions* space,
                             Box* result)
{
	gint l = 0;
	gint _tmp0_;
	gint t = 0;
	Dimensions _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint r = 0;
	gint _tmp4_;
	gint b = 0;
	Dimensions _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
	g_return_if_fail (space != NULL);
	_tmp0_ = (*self).top;
	l = _tmp0_;
	_tmp1_ = *space;
	_tmp2_ = _tmp1_.height;
	_tmp3_ = (*self).right;
	t = (_tmp2_ - _tmp3_) - 1;
	_tmp4_ = (*self).bottom;
	r = _tmp4_;
	_tmp5_ = *space;
	_tmp6_ = _tmp5_.height;
	_tmp7_ = (*self).left;
	b = (_tmp6_ - _tmp7_) - 1;
	box_init (&_tmp8_, l, t, r, b);
	*result = _tmp8_;
	return;
}


void
box_flip_left_to_right (Box *self,
                        Dimensions* space,
                        Box* result)
{
	gint l = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint r = 0;
	Dimensions _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
	g_return_if_fail (space != NULL);
	_tmp0_ = *space;
	_tmp1_ = _tmp0_.width;
	_tmp2_ = (*self).right;
	l = (_tmp1_ - _tmp2_) - 1;
	_tmp3_ = *space;
	_tmp4_ = _tmp3_.width;
	_tmp5_ = (*self).left;
	r = (_tmp4_ - _tmp5_) - 1;
	_tmp6_ = (*self).top;
	_tmp7_ = (*self).bottom;
	box_init (&_tmp8_, l, _tmp6_, r, _tmp7_);
	*result = _tmp8_;
	return;
}


void
box_flip_top_to_bottom (Box *self,
                        Dimensions* space,
                        Box* result)
{
	gint t = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint b = 0;
	Dimensions _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
	g_return_if_fail (space != NULL);
	_tmp0_ = *space;
	_tmp1_ = _tmp0_.height;
	_tmp2_ = (*self).bottom;
	t = (_tmp1_ - _tmp2_) - 1;
	_tmp3_ = *space;
	_tmp4_ = _tmp3_.height;
	_tmp5_ = (*self).top;
	b = (_tmp4_ - _tmp5_) - 1;
	_tmp6_ = (*self).left;
	_tmp7_ = (*self).right;
	box_init (&_tmp8_, _tmp6_, t, _tmp7_, b);
	*result = _tmp8_;
	return;
}


gboolean
box_intersects (Box *self,
                Box* compare)
{
	gboolean result = FALSE;
	gint left_intersect = 0;
	gint _tmp0_;
	Box _tmp1_;
	gint _tmp2_;
	gint top_intersect = 0;
	gint _tmp3_;
	Box _tmp4_;
	gint _tmp5_;
	gint right_intersect = 0;
	gint _tmp6_;
	Box _tmp7_;
	gint _tmp8_;
	gint bottom_intersect = 0;
	gint _tmp9_;
	Box _tmp10_;
	gint _tmp11_;
	gboolean _tmp12_ = FALSE;
	gint _tmp13_;
	gint _tmp14_;
	g_return_val_if_fail (compare != NULL, FALSE);
	_tmp0_ = (*self).left;
	_tmp1_ = *compare;
	_tmp2_ = _tmp1_.left;
	left_intersect = MAX (_tmp0_, _tmp2_);
	_tmp3_ = (*self).top;
	_tmp4_ = *compare;
	_tmp5_ = _tmp4_.top;
	top_intersect = MAX (_tmp3_, _tmp5_);
	_tmp6_ = (*self).right;
	_tmp7_ = *compare;
	_tmp8_ = _tmp7_.right;
	right_intersect = MIN (_tmp6_, _tmp8_);
	_tmp9_ = (*self).bottom;
	_tmp10_ = *compare;
	_tmp11_ = _tmp10_.bottom;
	bottom_intersect = MIN (_tmp9_, _tmp11_);
	_tmp13_ = right_intersect;
	_tmp14_ = left_intersect;
	if (_tmp13_ >= _tmp14_) {
		gint _tmp15_;
		gint _tmp16_;
		_tmp15_ = bottom_intersect;
		_tmp16_ = top_intersect;
		_tmp12_ = _tmp15_ >= _tmp16_;
	} else {
		_tmp12_ = FALSE;
	}
	result = _tmp12_;
	return result;
}


void
box_get_reduced (Box *self,
                 gint amount,
                 Box* result)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Box _tmp4_ = {0};
	_tmp0_ = (*self).left;
	_tmp1_ = (*self).top;
	_tmp2_ = (*self).right;
	_tmp3_ = (*self).bottom;
	box_init (&_tmp4_, _tmp0_ + amount, _tmp1_ + amount, _tmp2_ - amount, _tmp3_ - amount);
	*result = _tmp4_;
	return;
}


void
box_get_expanded (Box *self,
                  gint amount,
                  Box* result)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Box _tmp4_ = {0};
	_tmp0_ = (*self).left;
	_tmp1_ = (*self).top;
	_tmp2_ = (*self).right;
	_tmp3_ = (*self).bottom;
	box_init (&_tmp4_, _tmp0_ - amount, _tmp1_ - amount, _tmp2_ + amount, _tmp3_ + amount);
	*result = _tmp4_;
	return;
}


gboolean
box_contains (Box *self,
              GdkPoint* point)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkPoint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	g_return_val_if_fail (point != NULL, FALSE);
	_tmp3_ = *point;
	_tmp4_ = _tmp3_.x;
	_tmp5_ = (*self).left;
	if (_tmp4_ >= _tmp5_) {
		GdkPoint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		_tmp6_ = *point;
		_tmp7_ = _tmp6_.x;
		_tmp8_ = (*self).right;
		_tmp2_ = _tmp7_ <= _tmp8_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GdkPoint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		_tmp9_ = *point;
		_tmp10_ = _tmp9_.y;
		_tmp11_ = (*self).top;
		_tmp1_ = _tmp10_ >= _tmp11_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GdkPoint _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		_tmp12_ = *point;
		_tmp13_ = _tmp12_.y;
		_tmp14_ = (*self).bottom;
		_tmp0_ = _tmp13_ <= _tmp14_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


BoxComplements
box_resized_complements (Box *self,
                         Box* resized,
                         Box* horizontal,
                         gboolean* horizontal_enlarged,
                         Box* vertical,
                         gboolean* vertical_enlarged)
{
	Box _vala_horizontal = {0};
	gboolean _vala_horizontal_enlarged = FALSE;
	Box _vala_vertical = {0};
	gboolean _vala_vertical_enlarged = FALSE;
	BoxComplements result = 0;
	gboolean horizontal_complement = FALSE;
	Box _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean vertical_complement = FALSE;
	Box _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gboolean _tmp72_;
	gboolean _tmp73_;
	g_return_val_if_fail (resized != NULL, 0);
	horizontal_complement = TRUE;
	_tmp0_ = *resized;
	_tmp1_ = _tmp0_.top;
	_tmp2_ = (*self).top;
	if (_tmp1_ < _tmp2_) {
		Box _tmp3_;
		gint _tmp4_;
		Box _tmp5_;
		gint _tmp6_;
		Box _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		_tmp3_ = *resized;
		_tmp4_ = _tmp3_.left;
		_tmp5_ = *resized;
		_tmp6_ = _tmp5_.top;
		_tmp7_ = *resized;
		_tmp8_ = _tmp7_.right;
		_tmp9_ = (*self).top;
		box_init (&_vala_horizontal, _tmp4_, _tmp6_, _tmp8_, _tmp9_);
		_vala_horizontal_enlarged = TRUE;
	} else {
		Box _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		_tmp10_ = *resized;
		_tmp11_ = _tmp10_.top;
		_tmp12_ = (*self).top;
		if (_tmp11_ > _tmp12_) {
			gint _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			Box _tmp16_;
			gint _tmp17_;
			_tmp13_ = (*self).left;
			_tmp14_ = (*self).top;
			_tmp15_ = (*self).right;
			_tmp16_ = *resized;
			_tmp17_ = _tmp16_.top;
			box_init (&_vala_horizontal, _tmp13_, _tmp14_, _tmp15_, _tmp17_);
			_vala_horizontal_enlarged = FALSE;
		} else {
			Box _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			_tmp18_ = *resized;
			_tmp19_ = _tmp18_.bottom;
			_tmp20_ = (*self).bottom;
			if (_tmp19_ < _tmp20_) {
				gint _tmp21_;
				Box _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				_tmp21_ = (*self).left;
				_tmp22_ = *resized;
				_tmp23_ = _tmp22_.bottom;
				_tmp24_ = (*self).right;
				_tmp25_ = (*self).bottom;
				box_init (&_vala_horizontal, _tmp21_, _tmp23_, _tmp24_, _tmp25_);
				_vala_horizontal_enlarged = FALSE;
			} else {
				Box _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
				_tmp26_ = *resized;
				_tmp27_ = _tmp26_.bottom;
				_tmp28_ = (*self).bottom;
				if (_tmp27_ > _tmp28_) {
					Box _tmp29_;
					gint _tmp30_;
					gint _tmp31_;
					Box _tmp32_;
					gint _tmp33_;
					Box _tmp34_;
					gint _tmp35_;
					_tmp29_ = *resized;
					_tmp30_ = _tmp29_.left;
					_tmp31_ = (*self).bottom;
					_tmp32_ = *resized;
					_tmp33_ = _tmp32_.right;
					_tmp34_ = *resized;
					_tmp35_ = _tmp34_.bottom;
					box_init (&_vala_horizontal, _tmp30_, _tmp31_, _tmp33_, _tmp35_);
					_vala_horizontal_enlarged = TRUE;
				} else {
					box_init (&_vala_horizontal, 0, 0, 0, 0);
					_vala_horizontal_enlarged = FALSE;
					horizontal_complement = FALSE;
				}
			}
		}
	}
	vertical_complement = TRUE;
	_tmp36_ = *resized;
	_tmp37_ = _tmp36_.left;
	_tmp38_ = (*self).left;
	if (_tmp37_ < _tmp38_) {
		Box _tmp39_;
		gint _tmp40_;
		Box _tmp41_;
		gint _tmp42_;
		gint _tmp43_;
		Box _tmp44_;
		gint _tmp45_;
		_tmp39_ = *resized;
		_tmp40_ = _tmp39_.left;
		_tmp41_ = *resized;
		_tmp42_ = _tmp41_.top;
		_tmp43_ = (*self).left;
		_tmp44_ = *resized;
		_tmp45_ = _tmp44_.bottom;
		box_init (&_vala_vertical, _tmp40_, _tmp42_, _tmp43_, _tmp45_);
		_vala_vertical_enlarged = TRUE;
	} else {
		Box _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
		_tmp46_ = *resized;
		_tmp47_ = _tmp46_.left;
		_tmp48_ = (*self).left;
		if (_tmp47_ > _tmp48_) {
			gint _tmp49_;
			gint _tmp50_;
			Box _tmp51_;
			gint _tmp52_;
			gint _tmp53_;
			_tmp49_ = (*self).left;
			_tmp50_ = (*self).top;
			_tmp51_ = *resized;
			_tmp52_ = _tmp51_.left;
			_tmp53_ = (*self).bottom;
			box_init (&_vala_vertical, _tmp49_, _tmp50_, _tmp52_, _tmp53_);
			_vala_vertical_enlarged = FALSE;
		} else {
			Box _tmp54_;
			gint _tmp55_;
			gint _tmp56_;
			_tmp54_ = *resized;
			_tmp55_ = _tmp54_.right;
			_tmp56_ = (*self).right;
			if (_tmp55_ < _tmp56_) {
				Box _tmp57_;
				gint _tmp58_;
				gint _tmp59_;
				gint _tmp60_;
				gint _tmp61_;
				_tmp57_ = *resized;
				_tmp58_ = _tmp57_.right;
				_tmp59_ = (*self).top;
				_tmp60_ = (*self).right;
				_tmp61_ = (*self).bottom;
				box_init (&_vala_vertical, _tmp58_, _tmp59_, _tmp60_, _tmp61_);
				_vala_vertical_enlarged = FALSE;
			} else {
				Box _tmp62_;
				gint _tmp63_;
				gint _tmp64_;
				_tmp62_ = *resized;
				_tmp63_ = _tmp62_.right;
				_tmp64_ = (*self).right;
				if (_tmp63_ > _tmp64_) {
					gint _tmp65_;
					Box _tmp66_;
					gint _tmp67_;
					Box _tmp68_;
					gint _tmp69_;
					Box _tmp70_;
					gint _tmp71_;
					_tmp65_ = (*self).right;
					_tmp66_ = *resized;
					_tmp67_ = _tmp66_.top;
					_tmp68_ = *resized;
					_tmp69_ = _tmp68_.right;
					_tmp70_ = *resized;
					_tmp71_ = _tmp70_.bottom;
					box_init (&_vala_vertical, _tmp65_, _tmp67_, _tmp69_, _tmp71_);
					_vala_vertical_enlarged = TRUE;
				} else {
					box_init (&_vala_vertical, 0, 0, 0, 0);
					_vala_vertical_enlarged = FALSE;
					vertical_complement = FALSE;
				}
			}
		}
	}
	_tmp72_ = horizontal_complement;
	_tmp73_ = vertical_complement;
	result = box_complements_derive (_tmp72_, _tmp73_);
	if (horizontal) {
		*horizontal = _vala_horizontal;
	}
	if (horizontal_enlarged) {
		*horizontal_enlarged = _vala_horizontal_enlarged;
	}
	if (vertical) {
		*vertical = _vala_vertical;
	}
	if (vertical_enlarged) {
		*vertical_enlarged = _vala_vertical_enlarged;
	}
	return result;
}


BoxComplements
box_shifted_complements (Box *self,
                         Box* shifted,
                         Box* horizontal_this,
                         Box* vertical_this,
                         Box* horizontal_shifted,
                         Box* vertical_shifted)
{
	Box _vala_horizontal_this = {0};
	Box _vala_vertical_this = {0};
	Box _vala_horizontal_shifted = {0};
	Box _vala_vertical_shifted = {0};
	BoxComplements result = 0;
	gboolean horizontal_complement = FALSE;
	gboolean _tmp0_ = FALSE;
	Box _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean vertical_complement = FALSE;
	gboolean _tmp38_ = FALSE;
	Box _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	gboolean _tmp76_;
	gboolean _tmp77_;
	g_return_val_if_fail (shifted != NULL, 0);
	_vala_assert (box_get_width (&(*self)) == box_get_width (shifted), "get_width() == shifted.get_width()");
	_vala_assert (box_get_height (&(*self)) == box_get_height (shifted), "get_height() == shifted.get_height()");
	horizontal_complement = TRUE;
	_tmp1_ = *shifted;
	_tmp2_ = _tmp1_.top;
	_tmp3_ = (*self).top;
	if (_tmp2_ < _tmp3_) {
		Box _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		_tmp4_ = *shifted;
		_tmp5_ = _tmp4_.bottom;
		_tmp6_ = (*self).top;
		_tmp0_ = _tmp5_ > _tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint _tmp7_;
		Box _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		Box _tmp12_;
		gint _tmp13_;
		Box _tmp14_;
		gint _tmp15_;
		Box _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		_tmp7_ = (*self).left;
		_tmp8_ = *shifted;
		_tmp9_ = _tmp8_.bottom;
		_tmp10_ = (*self).right;
		_tmp11_ = (*self).bottom;
		box_init (&_vala_horizontal_this, _tmp7_, _tmp9_, _tmp10_, _tmp11_);
		_tmp12_ = *shifted;
		_tmp13_ = _tmp12_.left;
		_tmp14_ = *shifted;
		_tmp15_ = _tmp14_.top;
		_tmp16_ = *shifted;
		_tmp17_ = _tmp16_.right;
		_tmp18_ = (*self).top;
		box_init (&_vala_horizontal_shifted, _tmp13_, _tmp15_, _tmp17_, _tmp18_);
	} else {
		gboolean _tmp19_ = FALSE;
		Box _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		_tmp20_ = *shifted;
		_tmp21_ = _tmp20_.top;
		_tmp22_ = (*self).top;
		if (_tmp21_ > _tmp22_) {
			Box _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
			_tmp23_ = *shifted;
			_tmp24_ = _tmp23_.top;
			_tmp25_ = (*self).bottom;
			_tmp19_ = _tmp24_ < _tmp25_;
		} else {
			_tmp19_ = FALSE;
		}
		if (_tmp19_) {
			gint _tmp26_;
			gint _tmp27_;
			gint _tmp28_;
			Box _tmp29_;
			gint _tmp30_;
			Box _tmp31_;
			gint _tmp32_;
			gint _tmp33_;
			Box _tmp34_;
			gint _tmp35_;
			Box _tmp36_;
			gint _tmp37_;
			_tmp26_ = (*self).left;
			_tmp27_ = (*self).top;
			_tmp28_ = (*self).right;
			_tmp29_ = *shifted;
			_tmp30_ = _tmp29_.top;
			box_init (&_vala_horizontal_this, _tmp26_, _tmp27_, _tmp28_, _tmp30_);
			_tmp31_ = *shifted;
			_tmp32_ = _tmp31_.left;
			_tmp33_ = (*self).bottom;
			_tmp34_ = *shifted;
			_tmp35_ = _tmp34_.right;
			_tmp36_ = *shifted;
			_tmp37_ = _tmp36_.bottom;
			box_init (&_vala_horizontal_shifted, _tmp32_, _tmp33_, _tmp35_, _tmp37_);
		} else {
			box_init (&_vala_horizontal_this, 0, 0, 0, 0);
			box_init (&_vala_horizontal_shifted, 0, 0, 0, 0);
			horizontal_complement = FALSE;
		}
	}
	vertical_complement = TRUE;
	_tmp39_ = *shifted;
	_tmp40_ = _tmp39_.left;
	_tmp41_ = (*self).left;
	if (_tmp40_ < _tmp41_) {
		Box _tmp42_;
		gint _tmp43_;
		gint _tmp44_;
		_tmp42_ = *shifted;
		_tmp43_ = _tmp42_.right;
		_tmp44_ = (*self).left;
		_tmp38_ = _tmp43_ > _tmp44_;
	} else {
		_tmp38_ = FALSE;
	}
	if (_tmp38_) {
		Box _tmp45_;
		gint _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
		gint _tmp49_;
		Box _tmp50_;
		gint _tmp51_;
		Box _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		Box _tmp55_;
		gint _tmp56_;
		_tmp45_ = *shifted;
		_tmp46_ = _tmp45_.right;
		_tmp47_ = (*self).top;
		_tmp48_ = (*self).right;
		_tmp49_ = (*self).bottom;
		box_init (&_vala_vertical_this, _tmp46_, _tmp47_, _tmp48_, _tmp49_);
		_tmp50_ = *shifted;
		_tmp51_ = _tmp50_.left;
		_tmp52_ = *shifted;
		_tmp53_ = _tmp52_.top;
		_tmp54_ = (*self).left;
		_tmp55_ = *shifted;
		_tmp56_ = _tmp55_.bottom;
		box_init (&_vala_vertical_shifted, _tmp51_, _tmp53_, _tmp54_, _tmp56_);
	} else {
		gboolean _tmp57_ = FALSE;
		Box _tmp58_;
		gint _tmp59_;
		gint _tmp60_;
		_tmp58_ = *shifted;
		_tmp59_ = _tmp58_.left;
		_tmp60_ = (*self).left;
		if (_tmp59_ > _tmp60_) {
			Box _tmp61_;
			gint _tmp62_;
			gint _tmp63_;
			_tmp61_ = *shifted;
			_tmp62_ = _tmp61_.left;
			_tmp63_ = (*self).right;
			_tmp57_ = _tmp62_ < _tmp63_;
		} else {
			_tmp57_ = FALSE;
		}
		if (_tmp57_) {
			gint _tmp64_;
			gint _tmp65_;
			Box _tmp66_;
			gint _tmp67_;
			gint _tmp68_;
			gint _tmp69_;
			Box _tmp70_;
			gint _tmp71_;
			Box _tmp72_;
			gint _tmp73_;
			Box _tmp74_;
			gint _tmp75_;
			_tmp64_ = (*self).left;
			_tmp65_ = (*self).top;
			_tmp66_ = *shifted;
			_tmp67_ = _tmp66_.left;
			_tmp68_ = (*self).bottom;
			box_init (&_vala_vertical_this, _tmp64_, _tmp65_, _tmp67_, _tmp68_);
			_tmp69_ = (*self).right;
			_tmp70_ = *shifted;
			_tmp71_ = _tmp70_.top;
			_tmp72_ = *shifted;
			_tmp73_ = _tmp72_.right;
			_tmp74_ = *shifted;
			_tmp75_ = _tmp74_.bottom;
			box_init (&_vala_vertical_shifted, _tmp69_, _tmp71_, _tmp73_, _tmp75_);
		} else {
			box_init (&_vala_vertical_this, 0, 0, 0, 0);
			box_init (&_vala_vertical_shifted, 0, 0, 0, 0);
			vertical_complement = FALSE;
		}
	}
	_tmp76_ = horizontal_complement;
	_tmp77_ = vertical_complement;
	result = box_complements_derive (_tmp76_, _tmp77_);
	if (horizontal_this) {
		*horizontal_this = _vala_horizontal_this;
	}
	if (vertical_this) {
		*vertical_this = _vala_vertical_this;
	}
	if (horizontal_shifted) {
		*horizontal_shifted = _vala_horizontal_shifted;
	}
	if (vertical_shifted) {
		*vertical_shifted = _vala_vertical_shifted;
	}
	return result;
}


void
box_rubber_band (Box *self,
                 GdkPoint* point,
                 Box* result)
{
	GdkPoint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_;
	gint _tmp3_;
	gint t = 0;
	gint _tmp4_;
	GdkPoint _tmp5_;
	gint _tmp6_;
	gint b = 0;
	gint _tmp7_;
	GdkPoint _tmp8_;
	gint _tmp9_;
	gint l = 0;
	gint _tmp10_;
	GdkPoint _tmp11_;
	gint _tmp12_;
	gint r = 0;
	gint _tmp13_;
	GdkPoint _tmp14_;
	gint _tmp15_;
	Box _tmp16_ = {0};
	g_return_if_fail (point != NULL);
	_tmp0_ = *point;
	_tmp1_ = _tmp0_.x;
	_vala_assert (_tmp1_ >= 0, "point.x >= 0");
	_tmp2_ = *point;
	_tmp3_ = _tmp2_.y;
	_vala_assert (_tmp3_ >= 0, "point.y >= 0");
	_tmp4_ = (*self).top;
	_tmp5_ = *point;
	_tmp6_ = _tmp5_.y;
	t = MIN (_tmp4_, _tmp6_);
	_tmp7_ = (*self).bottom;
	_tmp8_ = *point;
	_tmp9_ = _tmp8_.y;
	b = MAX (_tmp7_, _tmp9_);
	_tmp10_ = (*self).left;
	_tmp11_ = *point;
	_tmp12_ = _tmp11_.x;
	l = MIN (_tmp10_, _tmp12_);
	_tmp13_ = (*self).right;
	_tmp14_ = *point;
	_tmp15_ = _tmp14_.x;
	r = MAX (_tmp13_, _tmp15_);
	box_init (&_tmp16_, l, t, r, b);
	*result = _tmp16_;
	return;
}


gchar*
box_to_string (Box *self)
{
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_ = {0};
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	_tmp0_ = (*self).left;
	_tmp1_ = (*self).top;
	_tmp2_ = (*self).right;
	_tmp3_ = (*self).bottom;
	box_get_dimensions (&(*self), &_tmp4_);
	_tmp5_ = dimensions_to_string (&_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strdup_printf ("%d,%d %d,%d (%s)", _tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp6_);
	_tmp8_ = _tmp7_;
	_g_free0 (_tmp6_);
	result = _tmp8_;
	return result;
}


static gboolean
box_in_zone (gdouble pos,
             gint zone)
{
	gboolean result = FALSE;
	gint top_zone = 0;
	gint bottom_zone = 0;
	top_zone = zone - BOX_HAND_GRENADES;
	bottom_zone = zone + BOX_HAND_GRENADES;
	result = box_in_between (pos, top_zone, bottom_zone);
	return result;
}


static gboolean
box_in_between (gdouble pos,
                gint top,
                gint bottom)
{
	gboolean result = FALSE;
	gint ipos = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	ipos = (gint) pos;
	_tmp1_ = ipos;
	if (_tmp1_ > top) {
		gint _tmp2_;
		_tmp2_ = ipos;
		_tmp0_ = _tmp2_ < bottom;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


static gboolean
box_near_in_between (gdouble pos,
                     gint top,
                     gint bottom)
{
	gboolean result = FALSE;
	gint ipos = 0;
	gint top_zone = 0;
	gint bottom_zone = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	ipos = (gint) pos;
	top_zone = top - BOX_HAND_GRENADES;
	bottom_zone = bottom + BOX_HAND_GRENADES;
	_tmp1_ = ipos;
	_tmp2_ = top_zone;
	if (_tmp1_ > _tmp2_) {
		gint _tmp3_;
		gint _tmp4_;
		_tmp3_ = ipos;
		_tmp4_ = bottom_zone;
		_tmp0_ = _tmp3_ < _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


BoxLocation
box_approx_location (Box *self,
                     gint x,
                     gint y)
{
	BoxLocation result = 0;
	gboolean near_width = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gboolean near_height = FALSE;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_;
	_tmp0_ = (*self).left;
	_tmp1_ = (*self).right;
	near_width = box_near_in_between ((gdouble) x, _tmp0_, _tmp1_);
	_tmp2_ = (*self).top;
	_tmp3_ = (*self).bottom;
	near_height = box_near_in_between ((gdouble) y, _tmp2_, _tmp3_);
	_tmp5_ = (*self).left;
	if (box_in_zone ((gdouble) x, _tmp5_)) {
		gboolean _tmp6_;
		_tmp6_ = near_height;
		_tmp4_ = _tmp6_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		gint _tmp7_;
		_tmp7_ = (*self).top;
		if (box_in_zone ((gdouble) y, _tmp7_)) {
			result = BOX_LOCATION_TOP_LEFT;
			return result;
		} else {
			gint _tmp8_;
			_tmp8_ = (*self).bottom;
			if (box_in_zone ((gdouble) y, _tmp8_)) {
				result = BOX_LOCATION_BOTTOM_LEFT;
				return result;
			} else {
				result = BOX_LOCATION_LEFT_SIDE;
				return result;
			}
		}
	} else {
		gboolean _tmp9_ = FALSE;
		gint _tmp10_;
		_tmp10_ = (*self).right;
		if (box_in_zone ((gdouble) x, _tmp10_)) {
			gboolean _tmp11_;
			_tmp11_ = near_height;
			_tmp9_ = _tmp11_;
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			gint _tmp12_;
			_tmp12_ = (*self).top;
			if (box_in_zone ((gdouble) y, _tmp12_)) {
				result = BOX_LOCATION_TOP_RIGHT;
				return result;
			} else {
				gint _tmp13_;
				_tmp13_ = (*self).bottom;
				if (box_in_zone ((gdouble) y, _tmp13_)) {
					result = BOX_LOCATION_BOTTOM_RIGHT;
					return result;
				} else {
					result = BOX_LOCATION_RIGHT_SIDE;
					return result;
				}
			}
		} else {
			gboolean _tmp14_ = FALSE;
			gint _tmp15_;
			_tmp15_ = (*self).top;
			if (box_in_zone ((gdouble) y, _tmp15_)) {
				gboolean _tmp16_;
				_tmp16_ = near_width;
				_tmp14_ = _tmp16_;
			} else {
				_tmp14_ = FALSE;
			}
			if (_tmp14_) {
				result = BOX_LOCATION_TOP_SIDE;
				return result;
			} else {
				gboolean _tmp17_ = FALSE;
				gint _tmp18_;
				_tmp18_ = (*self).bottom;
				if (box_in_zone ((gdouble) y, _tmp18_)) {
					gboolean _tmp19_;
					_tmp19_ = near_width;
					_tmp17_ = _tmp19_;
				} else {
					_tmp17_ = FALSE;
				}
				if (_tmp17_) {
					result = BOX_LOCATION_BOTTOM_SIDE;
					return result;
				} else {
					gboolean _tmp20_ = FALSE;
					gint _tmp21_;
					gint _tmp22_;
					_tmp21_ = (*self).left;
					_tmp22_ = (*self).right;
					if (box_in_between ((gdouble) x, _tmp21_, _tmp22_)) {
						gint _tmp23_;
						gint _tmp24_;
						_tmp23_ = (*self).top;
						_tmp24_ = (*self).bottom;
						_tmp20_ = box_in_between ((gdouble) y, _tmp23_, _tmp24_);
					} else {
						_tmp20_ = FALSE;
					}
					if (_tmp20_) {
						result = BOX_LOCATION_INSIDE;
						return result;
					} else {
						result = BOX_LOCATION_OUTSIDE;
						return result;
					}
				}
			}
		}
	}
}


Box*
box_dup (const Box* self)
{
	Box* dup;
	dup = g_new0 (Box, 1);
	memcpy (dup, self, sizeof (Box));
	return dup;
}


void
box_free (Box* self)
{
	g_free (self);
}


GType
box_get_type (void)
{
	static volatile gsize box_type_id__volatile = 0;
	if (g_once_init_enter (&box_type_id__volatile)) {
		GType box_type_id;
		box_type_id = g_boxed_type_register_static ("Box", (GBoxedCopyFunc) box_dup, (GBoxedFreeFunc) box_free);
		g_once_init_leave (&box_type_id__volatile, box_type_id);
	}
	return box_type_id__volatile;
}



