/* Dimensions.c generated by valac 0.42.0, the Vala compiler
 * generated from Dimensions.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_ZOOM_STATE (zoom_state_get_type ())
typedef struct _ZoomState ZoomState;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _ZoomState {
	Dimensions content_dimensions;
	Dimensions viewport_dimensions;
	gdouble zoom_factor;
	gdouble interpolation_factor;
	gdouble min_factor;
	gdouble max_factor;
	GdkPoint viewport_center;
};



GType scale_constraint_get_type (void) G_GNUC_CONST;
gchar* scale_constraint_to_string (ScaleConstraint self);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                            Dimensions* result);
void dimensions_for_allocation (GtkAllocation* allocation,
                                Dimensions* result);
void dimensions_for_widget_allocation (GtkWidget* widget,
                                       Dimensions* result);
void dimensions_for_rectangle (GdkRectangle* rect,
                               Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
void dimensions_floor (Dimensions *self,
                       Dimensions* min,
                       Dimensions* result);
gchar* dimensions_to_string (Dimensions *self);
gboolean dimensions_equals (Dimensions *self,
                            Dimensions* dim);
gboolean dimensions_approx_equals (Dimensions *self,
                                   Dimensions* dim,
                                   gint fudge);
gboolean dimensions_approx_scaled (Dimensions *self,
                                   gint scale,
                                   gint fudge);
gint dimensions_major_axis (Dimensions *self);
gint dimensions_minor_axis (Dimensions *self);
void dimensions_with_min (Dimensions *self,
                          gint min_width,
                          gint min_height,
                          Dimensions* result);
void dimensions_with_max (Dimensions *self,
                          gint max_width,
                          gint max_height,
                          Dimensions* result);
void dimensions_get_scaled (Dimensions *self,
                            gint scale,
                            gboolean scale_up,
                            Dimensions* result);
void dimensions_get_scaled_by_width (Dimensions *self,
                                     gint scale,
                                     Dimensions* result);
void dimensions_get_scaled_by_height (Dimensions *self,
                                      gint scale,
                                      Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self,
                                  Dimensions* scaled,
                                  gdouble* width_ratio,
                                  gdouble* height_ratio);
gdouble dimensions_get_aspect_ratio (Dimensions *self);
void dimensions_get_scaled_proportional (Dimensions *self,
                                         Dimensions* viewport,
                                         Dimensions* result);
void dimensions_get_scaled_to_fill_viewport (Dimensions *self,
                                             Dimensions* viewport,
                                             Dimensions* result);
void dimensions_get_scaled_rectangle (Dimensions *self,
                                      Dimensions* scaled,
                                      GdkRectangle* rect,
                                      GdkRectangle* result);
void dimensions_get_scaled_similar (Dimensions *self,
                                    Dimensions* original,
                                    Dimensions* scaled,
                                    Dimensions* result);
void dimensions_get_scaled_by_constraint (Dimensions *self,
                                          gint scale,
                                          ScaleConstraint constraint,
                                          Dimensions* result);
GType scaling_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
#define SCALING_NO_SCALE 0
static void scaling_init (Scaling *self,
                   ScaleConstraint constraint,
                   gint scale,
                   Dimensions* viewport,
                   gboolean scale_up);
void scaling_for_original (Scaling* result);
void scaling_for_screen (GtkWindow* window,
                         gboolean scale_up,
                         Scaling* result);
void scaling_for_viewport (Dimensions* viewport,
                           gboolean scale_up,
                           Scaling* result);
void scaling_get_screen_dimensions (GtkWindow* window,
                                    Dimensions* result);
void scaling_for_best_fit (gint pixels,
                           gboolean scale_up,
                           Scaling* result);
void scaling_for_widget (GtkWidget* widget,
                         gboolean scale_up,
                         Scaling* result);
void scaling_to_fill_viewport (Dimensions* viewport,
                               Scaling* result);
void scaling_to_fill_screen (GtkWindow* window,
                             Scaling* result);
void scaling_for_constraint (ScaleConstraint constraint,
                             gint scale,
                             gboolean scale_up,
                             Scaling* result);
static gint scaling_scale_to_pixels (Scaling *self);
gboolean scaling_is_unscaled (Scaling *self);
gboolean scaling_is_best_fit (Scaling *self,
                              Dimensions* original,
                              gint* pixels);
gboolean scaling_is_best_fit_dimensions (Scaling *self,
                                         Dimensions* original,
                                         Dimensions* scaled);
gboolean scaling_is_for_viewport (Scaling *self,
                                  Dimensions* original,
                                  Dimensions* scaled);
gboolean scaling_is_fill_viewport (Scaling *self,
                                   Dimensions* original,
                                   Dimensions* scaled);
void scaling_get_scaled_dimensions (Scaling *self,
                                    Dimensions* original,
                                    Dimensions* result);
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self,
                                      GdkPixbuf* pixbuf,
                                      GdkInterpType interp,
                                      gboolean scale_up);
GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf,
                         gint scale,
                         GdkInterpType interp,
                         gboolean scale_up);
GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf,
                          Dimensions* resized,
                          GdkInterpType interp);
gchar* scaling_to_string (Scaling *self);
gboolean scaling_equals (Scaling *self,
                         Scaling* scaling);
GType zoom_state_get_type (void) G_GNUC_CONST;
ZoomState* zoom_state_dup (const ZoomState* self);
void zoom_state_free (ZoomState* self);
void zoom_state_init (ZoomState *self,
                      Dimensions* content_dimensions,
                      Dimensions* viewport_dimensions,
                      gdouble slider_val,
                      GdkPoint* viewport_center);
static void zoom_state_compute_zoom_factors (ZoomState *self);
static void zoom_state_center_viewport (ZoomState *self);
static void zoom_state_clamp_viewport_center (ZoomState *self);
void zoom_state_init_rescale (ZoomState *self,
                              ZoomState* existing,
                              gdouble new_slider_val);
void zoom_state_init_rescale_to_isomorphic (ZoomState *self,
                                            ZoomState* existing);
void zoom_state_init_pan (ZoomState *self,
                          ZoomState* existing,
                          GdkPoint* new_viewport_center);
gint zoom_state_get_zoomed_width (ZoomState *self);
gint zoom_state_get_zoomed_height (ZoomState *self);
gdouble zoom_state_get_interpolation_factor (ZoomState *self);
void zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self,
                                                   GdkRectangle* result);
void zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self,
                                                  GdkRectangle* result);
void zoom_state_get_viewing_rectangle_projection (ZoomState *self,
                                                  GdkPixbuf* for_pixbuf,
                                                  GdkRectangle* result);
gdouble zoom_state_get_zoom_factor (ZoomState *self);
void zoom_state_get_viewport_center (ZoomState *self,
                                     GdkPoint* result);
gchar* zoom_state_to_string (ZoomState *self);
gboolean zoom_state_is_min (ZoomState *self);
gboolean zoom_state_is_default (ZoomState *self);
gboolean zoom_state_is_isomorphic (ZoomState *self);
gboolean zoom_state_is_max (ZoomState *self);
gboolean zoom_state_equals (ZoomState *self,
                            ZoomState* other);


gchar*
scale_constraint_to_string (ScaleConstraint self)
{
	gchar* result = NULL;
	switch (self) {
		case SCALE_CONSTRAINT_ORIGINAL:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Original size"));
			result = _tmp0_;
			return result;
		}
		case SCALE_CONSTRAINT_DIMENSIONS:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Longest edge"));
			result = _tmp1_;
			return result;
		}
		case SCALE_CONSTRAINT_WIDTH:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Width"));
			result = _tmp2_;
			return result;
		}
		case SCALE_CONSTRAINT_HEIGHT:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Height"));
			result = _tmp3_;
			return result;
		}
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("Fill Viewport");
			result = _tmp4_;
			return result;
		}
		default:
		break;
	}
	g_warn_if_reached ();
	result = NULL;
	return result;
}


GType
scale_constraint_get_type (void)
{
	static volatile gsize scale_constraint_type_id__volatile = 0;
	if (g_once_init_enter (&scale_constraint_type_id__volatile)) {
		static const GEnumValue values[] = {{SCALE_CONSTRAINT_ORIGINAL, "SCALE_CONSTRAINT_ORIGINAL", "original"}, {SCALE_CONSTRAINT_DIMENSIONS, "SCALE_CONSTRAINT_DIMENSIONS", "dimensions"}, {SCALE_CONSTRAINT_WIDTH, "SCALE_CONSTRAINT_WIDTH", "width"}, {SCALE_CONSTRAINT_HEIGHT, "SCALE_CONSTRAINT_HEIGHT", "height"}, {SCALE_CONSTRAINT_FILL_VIEWPORT, "SCALE_CONSTRAINT_FILL_VIEWPORT", "fill-viewport"}, {0, NULL, NULL}};
		GType scale_constraint_type_id;
		scale_constraint_type_id = g_enum_register_static ("ScaleConstraint", values);
		g_once_init_leave (&scale_constraint_type_id__volatile, scale_constraint_type_id);
	}
	return scale_constraint_type_id__volatile;
}


void
dimensions_init (Dimensions *self,
                 gint width,
                 gint height)
{
	gboolean _tmp0_ = FALSE;
	memset (self, 0, sizeof (Dimensions));
	if (width < 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = height < 0;
	}
	if (_tmp0_) {
		g_warning ("Dimensions.vala:45: Tried to construct a Dimensions object with negati" \
"ve width or height - forcing sensible default values.");
	}
	(*self).width = CLAMP (width, 0, width);
	(*self).height = CLAMP (height, 0, height);
}


void
dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                       Dimensions* result)
{
	Dimensions _tmp0_ = {0};
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
	dimensions_init (&_tmp0_, gdk_pixbuf_get_width (pixbuf), gdk_pixbuf_get_height (pixbuf));
	*result = _tmp0_;
	return;
}


void
dimensions_for_allocation (GtkAllocation* allocation,
                           Dimensions* result)
{
	GtkAllocation _tmp0_;
	gint _tmp1_;
	GtkAllocation _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_ = {0};
	g_return_if_fail (allocation != NULL);
	_tmp0_ = *allocation;
	_tmp1_ = _tmp0_.width;
	_tmp2_ = *allocation;
	_tmp3_ = _tmp2_.height;
	dimensions_init (&_tmp4_, _tmp1_, _tmp3_);
	*result = _tmp4_;
	return;
}


void
dimensions_for_widget_allocation (GtkWidget* widget,
                                  Dimensions* result)
{
	GtkAllocation allocation = {0};
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp1_;
	gint _tmp2_;
	GtkAllocation _tmp3_;
	gint _tmp4_;
	Dimensions _tmp5_ = {0};
	g_return_if_fail (GTK_IS_WIDGET (widget));
	gtk_widget_get_allocation (widget, &_tmp0_);
	allocation = _tmp0_;
	_tmp1_ = allocation;
	_tmp2_ = _tmp1_.width;
	_tmp3_ = allocation;
	_tmp4_ = _tmp3_.height;
	dimensions_init (&_tmp5_, _tmp2_, _tmp4_);
	*result = _tmp5_;
	return;
}


void
dimensions_for_rectangle (GdkRectangle* rect,
                          Dimensions* result)
{
	GdkRectangle _tmp0_;
	gint _tmp1_;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_ = {0};
	g_return_if_fail (rect != NULL);
	_tmp0_ = *rect;
	_tmp1_ = _tmp0_.width;
	_tmp2_ = *rect;
	_tmp3_ = _tmp2_.height;
	dimensions_init (&_tmp4_, _tmp1_, _tmp3_);
	*result = _tmp4_;
	return;
}


gboolean
dimensions_has_area (Dimensions *self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	_tmp1_ = (*self).width;
	if (_tmp1_ > 0) {
		gint _tmp2_;
		_tmp2_ = (*self).height;
		_tmp0_ = _tmp2_ > 0;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


void
dimensions_floor (Dimensions *self,
                  Dimensions* min,
                  Dimensions* result)
{
	gint _tmp0_ = 0;
	gint _tmp1_;
	Dimensions _tmp2_;
	gint _tmp3_;
	gint _tmp7_ = 0;
	gint _tmp8_;
	Dimensions _tmp9_;
	gint _tmp10_;
	Dimensions _tmp14_ = {0};
	g_return_if_fail (min != NULL);
	_tmp1_ = (*self).width;
	_tmp2_ = *min;
	_tmp3_ = _tmp2_.width;
	if (_tmp1_ > _tmp3_) {
		gint _tmp4_;
		_tmp4_ = (*self).width;
		_tmp0_ = _tmp4_;
	} else {
		Dimensions _tmp5_;
		gint _tmp6_;
		_tmp5_ = *min;
		_tmp6_ = _tmp5_.width;
		_tmp0_ = _tmp6_;
	}
	_tmp8_ = (*self).height;
	_tmp9_ = *min;
	_tmp10_ = _tmp9_.height;
	if (_tmp8_ > _tmp10_) {
		gint _tmp11_;
		_tmp11_ = (*self).height;
		_tmp7_ = _tmp11_;
	} else {
		Dimensions _tmp12_;
		gint _tmp13_;
		_tmp12_ = *min;
		_tmp13_ = _tmp12_.height;
		_tmp7_ = _tmp13_;
	}
	dimensions_init (&_tmp14_, _tmp0_, _tmp7_);
	*result = _tmp14_;
	return;
}


gchar*
dimensions_to_string (Dimensions *self)
{
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	_tmp0_ = (*self).width;
	_tmp1_ = (*self).height;
	_tmp2_ = g_strdup_printf ("%dx%d", _tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


gboolean
dimensions_equals (Dimensions *self,
                   Dimensions* dim)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	Dimensions _tmp2_;
	gint _tmp3_;
	g_return_val_if_fail (dim != NULL, FALSE);
	_tmp1_ = (*self).width;
	_tmp2_ = *dim;
	_tmp3_ = _tmp2_.width;
	if (_tmp1_ == _tmp3_) {
		gint _tmp4_;
		Dimensions _tmp5_;
		gint _tmp6_;
		_tmp4_ = (*self).height;
		_tmp5_ = *dim;
		_tmp6_ = _tmp5_.height;
		_tmp0_ = _tmp4_ == _tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gboolean
dimensions_approx_equals (Dimensions *self,
                          Dimensions* dim,
                          gint fudge)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	Dimensions _tmp2_;
	gint _tmp3_;
	g_return_val_if_fail (dim != NULL, FALSE);
	_tmp1_ = (*self).width;
	_tmp2_ = *dim;
	_tmp3_ = _tmp2_.width;
	if (abs (_tmp1_ - _tmp3_) <= fudge) {
		gint _tmp4_;
		Dimensions _tmp5_;
		gint _tmp6_;
		_tmp4_ = (*self).height;
		_tmp5_ = *dim;
		_tmp6_ = _tmp5_.height;
		_tmp0_ = abs (_tmp4_ - _tmp6_) <= fudge;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gboolean
dimensions_approx_scaled (Dimensions *self,
                          gint scale,
                          gint fudge)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	_tmp1_ = (*self).width;
	if (_tmp1_ <= (scale + fudge)) {
		gint _tmp2_;
		_tmp2_ = (*self).height;
		_tmp0_ = _tmp2_ <= (scale + fudge);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gint
dimensions_major_axis (Dimensions *self)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	_tmp0_ = (*self).width;
	_tmp1_ = (*self).height;
	result = MAX (_tmp0_, _tmp1_);
	return result;
}


gint
dimensions_minor_axis (Dimensions *self)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	_tmp0_ = (*self).width;
	_tmp1_ = (*self).height;
	result = MIN (_tmp0_, _tmp1_);
	return result;
}


void
dimensions_with_min (Dimensions *self,
                     gint min_width,
                     gint min_height,
                     Dimensions* result)
{
	gint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_ = {0};
	_tmp0_ = (*self).width;
	_tmp1_ = (*self).height;
	dimensions_init (&_tmp2_, MAX (_tmp0_, min_width), MAX (_tmp1_, min_height));
	*result = _tmp2_;
	return;
}


void
dimensions_with_max (Dimensions *self,
                     gint max_width,
                     gint max_height,
                     Dimensions* result)
{
	gint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_ = {0};
	_tmp0_ = (*self).width;
	_tmp1_ = (*self).height;
	dimensions_init (&_tmp2_, MIN (_tmp0_, max_width), MIN (_tmp1_, max_height));
	*result = _tmp2_;
	return;
}


void
dimensions_get_scaled (Dimensions *self,
                       gint scale,
                       gboolean scale_up,
                       Dimensions* result)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
	gboolean _tmp10_ = FALSE;
	gint _tmp17_;
	gint _tmp18_;
	_vala_assert (scale > 0, "scale > 0");
	_tmp2_ = (*self).width;
	if (_tmp2_ == scale) {
		gint _tmp3_;
		_tmp3_ = (*self).height;
		_tmp1_ = _tmp3_ < scale;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp4_ = FALSE;
		gint _tmp5_;
		_tmp5_ = (*self).height;
		if (_tmp5_ == scale) {
			gint _tmp6_;
			_tmp6_ = (*self).width;
			_tmp4_ = _tmp6_ < scale;
		} else {
			_tmp4_ = FALSE;
		}
		_tmp0_ = _tmp4_;
	}
	if (_tmp0_) {
		gint _tmp7_;
		gint _tmp8_;
		Dimensions _tmp9_ = {0};
		_tmp7_ = (*self).width;
		_tmp8_ = (*self).height;
		dimensions_init (&_tmp9_, _tmp7_, _tmp8_);
		*result = _tmp9_;
		return;
	}
	if (!scale_up) {
		gboolean _tmp11_ = FALSE;
		gint _tmp12_;
		_tmp12_ = (*self).width;
		if (_tmp12_ < scale) {
			gint _tmp13_;
			_tmp13_ = (*self).height;
			_tmp11_ = _tmp13_ < scale;
		} else {
			_tmp11_ = FALSE;
		}
		_tmp10_ = _tmp11_;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		gint _tmp14_;
		gint _tmp15_;
		Dimensions _tmp16_ = {0};
		_tmp14_ = (*self).width;
		_tmp15_ = (*self).height;
		dimensions_init (&_tmp16_, _tmp14_, _tmp15_);
		*result = _tmp16_;
		return;
	}
	_tmp17_ = (*self).width;
	_tmp18_ = (*self).height;
	if ((_tmp17_ - scale) > (_tmp18_ - scale)) {
		Dimensions _tmp19_ = {0};
		dimensions_get_scaled_by_width (&(*self), scale, &_tmp19_);
		*result = _tmp19_;
		return;
	} else {
		Dimensions _tmp20_ = {0};
		dimensions_get_scaled_by_height (&(*self), scale, &_tmp20_);
		*result = _tmp20_;
		return;
	}
}


void
dimensions_get_scale_ratios (Dimensions *self,
                             Dimensions* scaled,
                             gdouble* width_ratio,
                             gdouble* height_ratio)
{
	gdouble _vala_width_ratio = 0.0;
	gdouble _vala_height_ratio = 0.0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Dimensions _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	g_return_if_fail (scaled != NULL);
	_tmp0_ = *scaled;
	_tmp1_ = _tmp0_.width;
	_tmp2_ = (*self).width;
	_vala_width_ratio = ((gdouble) _tmp1_) / ((gdouble) _tmp2_);
	_tmp3_ = *scaled;
	_tmp4_ = _tmp3_.height;
	_tmp5_ = (*self).height;
	_vala_height_ratio = ((gdouble) _tmp4_) / ((gdouble) _tmp5_);
	if (width_ratio) {
		*width_ratio = _vala_width_ratio;
	}
	if (height_ratio) {
		*height_ratio = _vala_height_ratio;
	}
}


gdouble
dimensions_get_aspect_ratio (Dimensions *self)
{
	gdouble result = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	_tmp0_ = (*self).width;
	_tmp1_ = (*self).height;
	result = ((gdouble) _tmp0_) / _tmp1_;
	return result;
}


void
dimensions_get_scaled_proportional (Dimensions *self,
                                    Dimensions* viewport,
                                    Dimensions* result)
{
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	gdouble _tmp3_;
	gdouble _tmp4_;
	Dimensions scaled = {0};
	gdouble _tmp13_;
	gdouble _tmp14_;
	Dimensions _tmp15_ = {0};
	Dimensions _tmp16_ = {0};
	Dimensions _tmp17_ = {0};
	Dimensions _tmp18_;
	gint _tmp19_;
	Dimensions _tmp20_;
	gint _tmp21_;
	Dimensions _tmp22_;
	gint _tmp23_;
	Dimensions _tmp24_;
	gint _tmp25_;
	g_return_if_fail (viewport != NULL);
	_tmp0_ = *viewport;
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
	width_ratio = _tmp1_;
	height_ratio = _tmp2_;
	_tmp3_ = width_ratio;
	_tmp4_ = height_ratio;
	if (_tmp3_ < _tmp4_) {
		Dimensions _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gdouble _tmp8_;
		_tmp5_ = *viewport;
		_tmp6_ = _tmp5_.width;
		scaled_width = (gdouble) _tmp6_;
		_tmp7_ = (*self).height;
		_tmp8_ = width_ratio;
		scaled_height = ((gdouble) _tmp7_) * _tmp8_;
	} else {
		gint _tmp9_;
		gdouble _tmp10_;
		Dimensions _tmp11_;
		gint _tmp12_;
		_tmp9_ = (*self).width;
		_tmp10_ = height_ratio;
		scaled_width = ((gdouble) _tmp9_) * _tmp10_;
		_tmp11_ = *viewport;
		_tmp12_ = _tmp11_.height;
		scaled_height = (gdouble) _tmp12_;
	}
	_tmp13_ = scaled_width;
	_tmp14_ = scaled_height;
	dimensions_init (&_tmp15_, (gint) round (_tmp13_), (gint) round (_tmp14_));
	dimensions_init (&_tmp16_, 1, 1);
	dimensions_floor (&_tmp15_, &_tmp16_, &_tmp17_);
	scaled = _tmp17_;
	_tmp18_ = scaled;
	_tmp19_ = _tmp18_.height;
	_tmp20_ = *viewport;
	_tmp21_ = _tmp20_.height;
	_vala_assert (_tmp19_ <= _tmp21_, "scaled.height <= viewport.height");
	_tmp22_ = scaled;
	_tmp23_ = _tmp22_.width;
	_tmp24_ = *viewport;
	_tmp25_ = _tmp24_.width;
	_vala_assert (_tmp23_ <= _tmp25_, "scaled.width <= viewport.width");
	*result = scaled;
	return;
}


void
dimensions_get_scaled_to_fill_viewport (Dimensions *self,
                                        Dimensions* viewport,
                                        Dimensions* result)
{
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	Dimensions _tmp5_;
	gint _tmp6_;
	gdouble _tmp31_;
	gdouble _tmp32_;
	Dimensions _tmp33_ = {0};
	Dimensions _tmp34_ = {0};
	Dimensions _tmp35_ = {0};
	g_return_if_fail (viewport != NULL);
	_tmp0_ = *viewport;
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
	width_ratio = _tmp1_;
	height_ratio = _tmp2_;
	_tmp4_ = (*self).width;
	_tmp5_ = *viewport;
	_tmp6_ = _tmp5_.width;
	if (_tmp4_ < _tmp6_) {
		gint _tmp7_;
		Dimensions _tmp8_;
		gint _tmp9_;
		_tmp7_ = (*self).height;
		_tmp8_ = *viewport;
		_tmp9_ = _tmp8_.height;
		_tmp3_ = _tmp7_ >= _tmp9_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		Dimensions _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gdouble _tmp13_;
		_tmp10_ = *viewport;
		_tmp11_ = _tmp10_.width;
		scaled_width = (gdouble) _tmp11_;
		_tmp12_ = (*self).height;
		_tmp13_ = width_ratio;
		scaled_height = ((gdouble) _tmp12_) * _tmp13_;
	} else {
		gboolean _tmp14_ = FALSE;
		gint _tmp15_;
		Dimensions _tmp16_;
		gint _tmp17_;
		_tmp15_ = (*self).width;
		_tmp16_ = *viewport;
		_tmp17_ = _tmp16_.width;
		if (_tmp15_ >= _tmp17_) {
			gint _tmp18_;
			Dimensions _tmp19_;
			gint _tmp20_;
			_tmp18_ = (*self).height;
			_tmp19_ = *viewport;
			_tmp20_ = _tmp19_.height;
			_tmp14_ = _tmp18_ < _tmp20_;
		} else {
			_tmp14_ = FALSE;
		}
		if (_tmp14_) {
			gint _tmp21_;
			gdouble _tmp22_;
			Dimensions _tmp23_;
			gint _tmp24_;
			_tmp21_ = (*self).width;
			_tmp22_ = height_ratio;
			scaled_width = ((gdouble) _tmp21_) * _tmp22_;
			_tmp23_ = *viewport;
			_tmp24_ = _tmp23_.height;
			scaled_height = (gdouble) _tmp24_;
		} else {
			gdouble ratio = 0.0;
			gdouble _tmp25_;
			gdouble _tmp26_;
			gint _tmp27_;
			gdouble _tmp28_;
			gint _tmp29_;
			gdouble _tmp30_;
			_tmp25_ = width_ratio;
			_tmp26_ = height_ratio;
			ratio = MAX (_tmp25_, _tmp26_);
			_tmp27_ = (*self).width;
			_tmp28_ = ratio;
			scaled_width = ((gdouble) _tmp27_) * _tmp28_;
			_tmp29_ = (*self).height;
			_tmp30_ = ratio;
			scaled_height = ((gdouble) _tmp29_) * _tmp30_;
		}
	}
	_tmp31_ = scaled_width;
	_tmp32_ = scaled_height;
	dimensions_init (&_tmp33_, (gint) round (_tmp31_), (gint) round (_tmp32_));
	dimensions_init (&_tmp34_, 1, 1);
	dimensions_floor (&_tmp33_, &_tmp34_, &_tmp35_);
	*result = _tmp35_;
	return;
}


void
dimensions_get_scaled_rectangle (Dimensions *self,
                                 Dimensions* scaled,
                                 GdkRectangle* rect,
                                 GdkRectangle* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	GdkRectangle scaled_rect = {0};
	GdkRectangle _tmp3_;
	gint _tmp4_;
	gdouble _tmp5_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	gdouble _tmp8_;
	GdkRectangle _tmp9_;
	gint _tmp10_;
	gdouble _tmp11_;
	GdkRectangle _tmp12_;
	gint _tmp13_;
	gdouble _tmp14_;
	GdkRectangle _tmp15_;
	gint _tmp16_;
	GdkRectangle _tmp17_;
	gint _tmp18_;
	g_return_if_fail (scaled != NULL);
	g_return_if_fail (rect != NULL);
	_tmp0_ = *scaled;
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
	x_scale = _tmp1_;
	y_scale = _tmp2_;
	memset (&scaled_rect, 0, sizeof (GdkRectangle));
	_tmp3_ = *rect;
	_tmp4_ = _tmp3_.x;
	_tmp5_ = x_scale;
	scaled_rect.x = (gint) round (((gdouble) _tmp4_) * _tmp5_);
	_tmp6_ = *rect;
	_tmp7_ = _tmp6_.y;
	_tmp8_ = y_scale;
	scaled_rect.y = (gint) round (((gdouble) _tmp7_) * _tmp8_);
	_tmp9_ = *rect;
	_tmp10_ = _tmp9_.width;
	_tmp11_ = x_scale;
	scaled_rect.width = (gint) round (((gdouble) _tmp10_) * _tmp11_);
	_tmp12_ = *rect;
	_tmp13_ = _tmp12_.height;
	_tmp14_ = y_scale;
	scaled_rect.height = (gint) round (((gdouble) _tmp13_) * _tmp14_);
	_tmp15_ = scaled_rect;
	_tmp16_ = _tmp15_.width;
	if (_tmp16_ <= 0) {
		scaled_rect.width = 1;
	}
	_tmp17_ = scaled_rect;
	_tmp18_ = _tmp17_.height;
	if (_tmp18_ <= 0) {
		scaled_rect.height = 1;
	}
	*result = scaled_rect;
	return;
}


void
dimensions_get_scaled_similar (Dimensions *self,
                               Dimensions* original,
                               Dimensions* scaled,
                               Dimensions* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scale = 0.0;
	gint _tmp3_;
	gint _tmp4_;
	Dimensions _tmp5_ = {0};
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	g_return_if_fail (original != NULL);
	g_return_if_fail (scaled != NULL);
	_tmp0_ = *scaled;
	dimensions_get_scale_ratios (original, &_tmp0_, &_tmp1_, &_tmp2_);
	x_scale = _tmp1_;
	y_scale = _tmp2_;
	scale = MIN (x_scale, y_scale);
	_tmp3_ = (*self).width;
	_tmp4_ = (*self).height;
	dimensions_init (&_tmp5_, (gint) round (((gdouble) _tmp3_) * scale), (gint) round (((gdouble) _tmp4_) * scale));
	dimensions_init (&_tmp6_, 1, 1);
	dimensions_floor (&_tmp5_, &_tmp6_, &_tmp7_);
	*result = _tmp7_;
	return;
}


void
dimensions_get_scaled_by_width (Dimensions *self,
                                gint scale,
                                Dimensions* result)
{
	gdouble ratio = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	Dimensions _tmp4_ = {0};
	_vala_assert (scale > 0, "scale > 0");
	_tmp0_ = (*self).width;
	ratio = ((gdouble) scale) / ((gdouble) _tmp0_);
	_tmp1_ = (*self).height;
	dimensions_init (&_tmp2_, scale, (gint) round (((gdouble) _tmp1_) * ratio));
	dimensions_init (&_tmp3_, 1, 1);
	dimensions_floor (&_tmp2_, &_tmp3_, &_tmp4_);
	*result = _tmp4_;
	return;
}


void
dimensions_get_scaled_by_height (Dimensions *self,
                                 gint scale,
                                 Dimensions* result)
{
	gdouble ratio = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	Dimensions _tmp4_ = {0};
	_vala_assert (scale > 0, "scale > 0");
	_tmp0_ = (*self).height;
	ratio = ((gdouble) scale) / ((gdouble) _tmp0_);
	_tmp1_ = (*self).width;
	dimensions_init (&_tmp2_, (gint) round (((gdouble) _tmp1_) * ratio), scale);
	dimensions_init (&_tmp3_, 1, 1);
	dimensions_floor (&_tmp2_, &_tmp3_, &_tmp4_);
	*result = _tmp4_;
	return;
}


void
dimensions_get_scaled_by_constraint (Dimensions *self,
                                     gint scale,
                                     ScaleConstraint constraint,
                                     Dimensions* result)
{
	switch (constraint) {
		case SCALE_CONSTRAINT_ORIGINAL:
		{
			gint _tmp0_;
			gint _tmp1_;
			Dimensions _tmp2_ = {0};
			_tmp0_ = (*self).width;
			_tmp1_ = (*self).height;
			dimensions_init (&_tmp2_, _tmp0_, _tmp1_);
			*result = _tmp2_;
			return;
		}
		case SCALE_CONSTRAINT_DIMENSIONS:
		{
			Dimensions _tmp3_ = {0};
			gint _tmp4_;
			gint _tmp5_;
			_tmp4_ = (*self).width;
			_tmp5_ = (*self).height;
			if (_tmp4_ >= _tmp5_) {
				Dimensions _tmp6_ = {0};
				dimensions_get_scaled_by_width (&(*self), scale, &_tmp6_);
				_tmp3_ = _tmp6_;
			} else {
				Dimensions _tmp7_ = {0};
				dimensions_get_scaled_by_height (&(*self), scale, &_tmp7_);
				_tmp3_ = _tmp7_;
			}
			*result = _tmp3_;
			return;
		}
		case SCALE_CONSTRAINT_WIDTH:
		{
			Dimensions _tmp8_ = {0};
			dimensions_get_scaled_by_width (&(*self), scale, &_tmp8_);
			*result = _tmp8_;
			return;
		}
		case SCALE_CONSTRAINT_HEIGHT:
		{
			Dimensions _tmp9_ = {0};
			dimensions_get_scaled_by_height (&(*self), scale, &_tmp9_);
			*result = _tmp9_;
			return;
		}
		default:
		{
			g_error ("Dimensions.vala:244: Bad constraint: %d", (gint) constraint);
		}
	}
}


Dimensions*
dimensions_dup (const Dimensions* self)
{
	Dimensions* dup;
	dup = g_new0 (Dimensions, 1);
	memcpy (dup, self, sizeof (Dimensions));
	return dup;
}


void
dimensions_free (Dimensions* self)
{
	g_free (self);
}


GType
dimensions_get_type (void)
{
	static volatile gsize dimensions_type_id__volatile = 0;
	if (g_once_init_enter (&dimensions_type_id__volatile)) {
		GType dimensions_type_id;
		dimensions_type_id = g_boxed_type_register_static ("Dimensions", (GBoxedCopyFunc) dimensions_dup, (GBoxedFreeFunc) dimensions_free);
		g_once_init_leave (&dimensions_type_id__volatile, dimensions_type_id);
	}
	return dimensions_type_id__volatile;
}


static void
scaling_init (Scaling *self,
              ScaleConstraint constraint,
              gint scale,
              Dimensions* viewport,
              gboolean scale_up)
{
	Dimensions _tmp0_;
	g_return_if_fail (viewport != NULL);
	memset (self, 0, sizeof (Scaling));
	(*self).constraint = constraint;
	(*self).scale = scale;
	_tmp0_ = *viewport;
	(*self).viewport = _tmp0_;
	(*self).scale_up = scale_up;
}


void
scaling_for_original (Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
	dimensions_init (&_tmp0_, 0, 0);
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_ORIGINAL, SCALING_NO_SCALE, &_tmp0_, FALSE);
	*result = _tmp1_;
	return;
}


void
scaling_for_screen (GtkWindow* window,
                    gboolean scale_up,
                    Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
	g_return_if_fail (GTK_IS_WINDOW (window));
	scaling_get_screen_dimensions (window, &_tmp0_);
	scaling_for_viewport (&_tmp0_, scale_up, &_tmp1_);
	*result = _tmp1_;
	return;
}


void
scaling_for_best_fit (gint pixels,
                      gboolean scale_up,
                      Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
	_vala_assert (pixels > 0, "pixels > 0");
	dimensions_init (&_tmp0_, 0, 0);
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, pixels, &_tmp0_, scale_up);
	*result = _tmp1_;
	return;
}


void
scaling_for_viewport (Dimensions* viewport,
                      gboolean scale_up,
                      Scaling* result)
{
	Dimensions _tmp0_;
	Scaling _tmp1_ = {0};
	g_return_if_fail (viewport != NULL);
	_vala_assert (dimensions_has_area (viewport), "viewport.has_area()");
	_tmp0_ = *viewport;
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &_tmp0_, scale_up);
	*result = _tmp1_;
	return;
}


void
scaling_for_widget (GtkWidget* widget,
                    gboolean scale_up,
                    Scaling* result)
{
	Dimensions viewport = {0};
	Dimensions _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	Dimensions _tmp2_;
	gint _tmp3_;
	Dimensions _tmp7_;
	Scaling _tmp8_ = {0};
	g_return_if_fail (GTK_IS_WIDGET (widget));
	dimensions_for_widget_allocation (widget, &_tmp0_);
	viewport = _tmp0_;
	_tmp2_ = viewport;
	_tmp3_ = _tmp2_.width;
	if (_tmp3_ <= 1) {
		_tmp1_ = TRUE;
	} else {
		Dimensions _tmp4_;
		gint _tmp5_;
		_tmp4_ = viewport;
		_tmp5_ = _tmp4_.height;
		_tmp1_ = _tmp5_ <= 1;
	}
	if (_tmp1_) {
		Scaling _tmp6_ = {0};
		scaling_for_original (&_tmp6_);
		*result = _tmp6_;
		return;
	}
	_tmp7_ = viewport;
	scaling_init (&_tmp8_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &_tmp7_, scale_up);
	*result = _tmp8_;
	return;
}


void
scaling_to_fill_viewport (Dimensions* viewport,
                          Scaling* result)
{
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_;
	gint _tmp2_;
	Dimensions _tmp6_;
	Scaling _tmp7_ = {0};
	g_return_if_fail (viewport != NULL);
	_tmp1_ = *viewport;
	_tmp2_ = _tmp1_.width;
	if (_tmp2_ <= 1) {
		_tmp0_ = TRUE;
	} else {
		Dimensions _tmp3_;
		gint _tmp4_;
		_tmp3_ = *viewport;
		_tmp4_ = _tmp3_.height;
		_tmp0_ = _tmp4_ <= 1;
	}
	if (_tmp0_) {
		Scaling _tmp5_ = {0};
		scaling_for_original (&_tmp5_);
		*result = _tmp5_;
		return;
	}
	_tmp6_ = *viewport;
	scaling_init (&_tmp7_, SCALE_CONSTRAINT_FILL_VIEWPORT, SCALING_NO_SCALE, &_tmp6_, TRUE);
	*result = _tmp7_;
	return;
}


void
scaling_to_fill_screen (GtkWindow* window,
                        Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
	g_return_if_fail (GTK_IS_WINDOW (window));
	scaling_get_screen_dimensions (window, &_tmp0_);
	scaling_to_fill_viewport (&_tmp0_, &_tmp1_);
	*result = _tmp1_;
	return;
}


void
scaling_for_constraint (ScaleConstraint constraint,
                        gint scale,
                        gboolean scale_up,
                        Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
	dimensions_init (&_tmp0_, 0, 0);
	scaling_init (&_tmp1_, constraint, scale, &_tmp0_, scale_up);
	*result = _tmp1_;
	return;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
scaling_get_screen_dimensions (GtkWindow* window,
                               Dimensions* result)
{
	GdkDisplay* display = NULL;
	GdkWindow* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkMonitor* monitor = NULL;
	GdkWindow* _tmp3_;
	GdkMonitor* _tmp4_;
	GdkMonitor* _tmp5_;
	GdkRectangle geom = {0};
	GdkRectangle _tmp6_ = {0};
	GdkRectangle _tmp7_;
	gint _tmp8_;
	GdkRectangle _tmp9_;
	gint _tmp10_;
	Dimensions _tmp11_ = {0};
	g_return_if_fail (GTK_IS_WINDOW (window));
	_tmp0_ = gtk_widget_get_window (G_TYPE_CHECK_INSTANCE_CAST (window, gtk_widget_get_type (), GtkWidget));
	_tmp1_ = gdk_window_get_display (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	display = _tmp2_;
	_tmp3_ = gtk_widget_get_window (G_TYPE_CHECK_INSTANCE_CAST (window, gtk_widget_get_type (), GtkWidget));
	_tmp4_ = gdk_display_get_monitor_at_window (display, _tmp3_);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	monitor = _tmp5_;
	gdk_monitor_get_geometry (monitor, &_tmp6_);
	geom = _tmp6_;
	_tmp7_ = geom;
	_tmp8_ = _tmp7_.width;
	_tmp9_ = geom;
	_tmp10_ = _tmp9_.height;
	dimensions_init (&_tmp11_, _tmp8_, _tmp10_);
	*result = _tmp11_;
	_g_object_unref0 (monitor);
	_g_object_unref0 (display);
	return;
}


static gint
scaling_scale_to_pixels (Scaling *self)
{
	gint result = 0;
	gint _tmp0_ = 0;
	gint _tmp1_;
	_tmp1_ = (*self).scale;
	if (_tmp1_ >= 0) {
		gint _tmp2_;
		_tmp2_ = (*self).scale;
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = 0;
	}
	result = _tmp0_;
	return result;
}


gboolean
scaling_is_unscaled (Scaling *self)
{
	gboolean result = FALSE;
	ScaleConstraint _tmp0_;
	_tmp0_ = (*self).constraint;
	result = _tmp0_ == SCALE_CONSTRAINT_ORIGINAL;
	return result;
}


gboolean
scaling_is_best_fit (Scaling *self,
                     Dimensions* original,
                     gint* pixels)
{
	gint _vala_pixels = 0;
	gboolean result = FALSE;
	gint _tmp0_;
	ScaleConstraint _tmp1_;
	g_return_val_if_fail (original != NULL, FALSE);
	_vala_pixels = 0;
	_tmp0_ = (*self).scale;
	if (_tmp0_ == SCALING_NO_SCALE) {
		result = FALSE;
		if (pixels) {
			*pixels = _vala_pixels;
		}
		return result;
	}
	_tmp1_ = (*self).constraint;
	switch (_tmp1_) {
		case SCALE_CONSTRAINT_ORIGINAL:
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = FALSE;
			if (pixels) {
				*pixels = _vala_pixels;
			}
			return result;
		}
		default:
		{
			gint _tmp2_;
			_vala_pixels = scaling_scale_to_pixels (&(*self));
			_tmp2_ = _vala_pixels;
			_vala_assert (_tmp2_ > 0, "pixels > 0");
			result = TRUE;
			if (pixels) {
				*pixels = _vala_pixels;
			}
			return result;
		}
	}
	if (pixels) {
		*pixels = _vala_pixels;
	}
}


gboolean
scaling_is_best_fit_dimensions (Scaling *self,
                                Dimensions* original,
                                Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	gint _tmp0_;
	ScaleConstraint _tmp1_;
	g_return_val_if_fail (original != NULL, FALSE);
	dimensions_init (&_vala_scaled, 0, 0);
	_tmp0_ = (*self).scale;
	if (_tmp0_ == SCALING_NO_SCALE) {
		result = FALSE;
		if (scaled) {
			*scaled = _vala_scaled;
		}
		return result;
	}
	_tmp1_ = (*self).constraint;
	switch (_tmp1_) {
		case SCALE_CONSTRAINT_ORIGINAL:
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = FALSE;
			if (scaled) {
				*scaled = _vala_scaled;
			}
			return result;
		}
		default:
		{
			gint pixels = 0;
			gint _tmp2_;
			gint _tmp3_;
			ScaleConstraint _tmp4_;
			Dimensions _tmp5_ = {0};
			pixels = scaling_scale_to_pixels (&(*self));
			_tmp2_ = pixels;
			_vala_assert (_tmp2_ > 0, "pixels > 0");
			_tmp3_ = pixels;
			_tmp4_ = (*self).constraint;
			dimensions_get_scaled_by_constraint (original, _tmp3_, _tmp4_, &_tmp5_);
			_vala_scaled = _tmp5_;
			result = TRUE;
			if (scaled) {
				*scaled = _vala_scaled;
			}
			return result;
		}
	}
	if (scaled) {
		*scaled = _vala_scaled;
	}
}


gboolean
scaling_is_for_viewport (Scaling *self,
                         Dimensions* original,
                         Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	gint _tmp0_;
	ScaleConstraint _tmp1_;
	g_return_val_if_fail (original != NULL, FALSE);
	dimensions_init (&_vala_scaled, 0, 0);
	_tmp0_ = (*self).scale;
	if (_tmp0_ != SCALING_NO_SCALE) {
		result = FALSE;
		if (scaled) {
			*scaled = _vala_scaled;
		}
		return result;
	}
	_tmp1_ = (*self).constraint;
	switch (_tmp1_) {
		case SCALE_CONSTRAINT_ORIGINAL:
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = FALSE;
			if (scaled) {
				*scaled = _vala_scaled;
			}
			return result;
		}
		default:
		{
			gboolean _tmp2_ = FALSE;
			gboolean _tmp3_ = FALSE;
			gboolean _tmp4_;
			_vala_assert (dimensions_has_area (&(*self).viewport), "viewport.has_area()");
			_tmp4_ = (*self).scale_up;
			if (!_tmp4_) {
				Dimensions _tmp5_;
				gint _tmp6_;
				Dimensions _tmp7_;
				gint _tmp8_;
				_tmp5_ = *original;
				_tmp6_ = _tmp5_.width;
				_tmp7_ = (*self).viewport;
				_tmp8_ = _tmp7_.width;
				_tmp3_ = _tmp6_ < _tmp8_;
			} else {
				_tmp3_ = FALSE;
			}
			if (_tmp3_) {
				Dimensions _tmp9_;
				gint _tmp10_;
				Dimensions _tmp11_;
				gint _tmp12_;
				_tmp9_ = *original;
				_tmp10_ = _tmp9_.height;
				_tmp11_ = (*self).viewport;
				_tmp12_ = _tmp11_.height;
				_tmp2_ = _tmp10_ < _tmp12_;
			} else {
				_tmp2_ = FALSE;
			}
			if (_tmp2_) {
				Dimensions _tmp13_;
				_tmp13_ = *original;
				_vala_scaled = _tmp13_;
			} else {
				Dimensions _tmp14_;
				Dimensions _tmp15_ = {0};
				_tmp14_ = (*self).viewport;
				dimensions_get_scaled_proportional (original, &_tmp14_, &_tmp15_);
				_vala_scaled = _tmp15_;
			}
			result = TRUE;
			if (scaled) {
				*scaled = _vala_scaled;
			}
			return result;
		}
	}
	if (scaled) {
		*scaled = _vala_scaled;
	}
}


gboolean
scaling_is_fill_viewport (Scaling *self,
                          Dimensions* original,
                          Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	ScaleConstraint _tmp0_;
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
	g_return_val_if_fail (original != NULL, FALSE);
	dimensions_init (&_vala_scaled, 0, 0);
	_tmp0_ = (*self).constraint;
	if (_tmp0_ != SCALE_CONSTRAINT_FILL_VIEWPORT) {
		result = FALSE;
		if (scaled) {
			*scaled = _vala_scaled;
		}
		return result;
	}
	_vala_assert (dimensions_has_area (&(*self).viewport), "viewport.has_area()");
	_tmp1_ = (*self).viewport;
	dimensions_get_scaled_to_fill_viewport (original, &_tmp1_, &_tmp2_);
	_vala_scaled = _tmp2_;
	result = TRUE;
	if (scaled) {
		*scaled = _vala_scaled;
	}
	return result;
}


void
scaling_get_scaled_dimensions (Scaling *self,
                               Dimensions* original,
                               Dimensions* result)
{
	Dimensions scaled = {0};
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
	gboolean _tmp3_;
	Dimensions _tmp4_;
	Dimensions _tmp5_ = {0};
	gboolean _tmp6_;
	gboolean is_viewport = FALSE;
	Dimensions _tmp7_;
	Dimensions _tmp8_ = {0};
	gboolean _tmp9_;
	gboolean _tmp10_;
	g_return_if_fail (original != NULL);
	if (scaling_is_unscaled (&(*self))) {
		Dimensions _tmp0_;
		_tmp0_ = *original;
		*result = _tmp0_;
		return;
	}
	_tmp1_ = *original;
	_tmp3_ = scaling_is_fill_viewport (&(*self), &_tmp1_, &_tmp2_);
	scaled = _tmp2_;
	if (_tmp3_) {
		*result = scaled;
		return;
	}
	_tmp4_ = *original;
	_tmp6_ = scaling_is_best_fit_dimensions (&(*self), &_tmp4_, &_tmp5_);
	scaled = _tmp5_;
	if (_tmp6_) {
		*result = scaled;
		return;
	}
	_tmp7_ = *original;
	_tmp9_ = scaling_is_for_viewport (&(*self), &_tmp7_, &_tmp8_);
	scaled = _tmp8_;
	is_viewport = _tmp9_;
	_tmp10_ = is_viewport;
	_vala_assert (_tmp10_, "is_viewport");
	*result = scaled;
	return;
}


GdkPixbuf*
scaling_perform_on_pixbuf (Scaling *self,
                           GdkPixbuf* pixbuf,
                           GdkInterpType interp,
                           gboolean scale_up)
{
	GdkPixbuf* result = NULL;
	Dimensions pixbuf_dim = {0};
	Dimensions _tmp1_ = {0};
	gint pixels = 0;
	Dimensions _tmp2_;
	gint _tmp3_ = 0;
	gboolean _tmp4_;
	Dimensions scaled = {0};
	Dimensions _tmp7_;
	Dimensions _tmp8_ = {0};
	gboolean _tmp9_;
	gboolean is_viewport = FALSE;
	Dimensions _tmp12_;
	Dimensions _tmp13_ = {0};
	gboolean _tmp14_;
	gboolean _tmp15_;
	Dimensions _tmp16_;
	GdkPixbuf* _tmp17_;
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
	if (scaling_is_unscaled (&(*self))) {
		GdkPixbuf* _tmp0_;
		_tmp0_ = _g_object_ref0 (pixbuf);
		result = _tmp0_;
		return result;
	}
	dimensions_for_pixbuf (pixbuf, &_tmp1_);
	pixbuf_dim = _tmp1_;
	_tmp2_ = pixbuf_dim;
	_tmp4_ = scaling_is_best_fit (&(*self), &_tmp2_, &_tmp3_);
	pixels = _tmp3_;
	if (_tmp4_) {
		gint _tmp5_;
		GdkPixbuf* _tmp6_;
		_tmp5_ = pixels;
		_tmp6_ = scale_pixbuf (pixbuf, _tmp5_, interp, scale_up);
		result = _tmp6_;
		return result;
	}
	_tmp7_ = pixbuf_dim;
	_tmp9_ = scaling_is_fill_viewport (&(*self), &_tmp7_, &_tmp8_);
	scaled = _tmp8_;
	if (_tmp9_) {
		Dimensions _tmp10_;
		GdkPixbuf* _tmp11_;
		_tmp10_ = scaled;
		_tmp11_ = resize_pixbuf (pixbuf, &_tmp10_, interp);
		result = _tmp11_;
		return result;
	}
	_tmp12_ = pixbuf_dim;
	_tmp14_ = scaling_is_for_viewport (&(*self), &_tmp12_, &_tmp13_);
	scaled = _tmp13_;
	is_viewport = _tmp14_;
	_tmp15_ = is_viewport;
	_vala_assert (_tmp15_, "is_viewport");
	_tmp16_ = scaled;
	_tmp17_ = resize_pixbuf (pixbuf, &_tmp16_, interp);
	result = _tmp17_;
	return result;
}


gchar*
scaling_to_string (Scaling *self)
{
	gchar* result = NULL;
	ScaleConstraint _tmp0_;
	_tmp0_ = (*self).constraint;
	if (_tmp0_ == SCALE_CONSTRAINT_ORIGINAL) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("scaling: UNSCALED");
		result = _tmp1_;
		return result;
	} else {
		ScaleConstraint _tmp2_;
		_tmp2_ = (*self).constraint;
		if (_tmp2_ == SCALE_CONSTRAINT_FILL_VIEWPORT) {
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			_tmp3_ = dimensions_to_string (&(*self).viewport);
			_tmp4_ = _tmp3_;
			_tmp5_ = g_strdup_printf ("scaling: fill viewport %s", _tmp4_);
			_tmp6_ = _tmp5_;
			_g_free0 (_tmp4_);
			result = _tmp6_;
			return result;
		} else {
			gint _tmp7_;
			_tmp7_ = (*self).scale;
			if (_tmp7_ != SCALING_NO_SCALE) {
				const gchar* _tmp8_ = NULL;
				gboolean _tmp9_;
				ScaleConstraint _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				_tmp9_ = (*self).scale_up;
				if (_tmp9_) {
					_tmp8_ = "scaled up";
				} else {
					_tmp8_ = "not scaled up";
				}
				_tmp10_ = (*self).constraint;
				_tmp11_ = scale_constraint_to_string (_tmp10_);
				_tmp12_ = _tmp11_;
				_tmp13_ = g_strdup_printf ("scaling: best-fit (%s %d pixels %s)", _tmp12_, scaling_scale_to_pixels (&(*self)), _tmp8_);
				_tmp14_ = _tmp13_;
				_g_free0 (_tmp12_);
				result = _tmp14_;
				return result;
			} else {
				const gchar* _tmp15_ = NULL;
				gboolean _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				_tmp16_ = (*self).scale_up;
				if (_tmp16_) {
					_tmp15_ = "scaled up";
				} else {
					_tmp15_ = "not scaled up";
				}
				_tmp17_ = dimensions_to_string (&(*self).viewport);
				_tmp18_ = _tmp17_;
				_tmp19_ = g_strdup_printf ("scaling: viewport %s (%s)", _tmp18_, _tmp15_);
				_tmp20_ = _tmp19_;
				_g_free0 (_tmp18_);
				result = _tmp20_;
				return result;
			}
		}
	}
}


gboolean
scaling_equals (Scaling *self,
                Scaling* scaling)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ScaleConstraint _tmp2_;
	Scaling _tmp3_;
	ScaleConstraint _tmp4_;
	g_return_val_if_fail (scaling != NULL, FALSE);
	_tmp2_ = (*self).constraint;
	_tmp3_ = *scaling;
	_tmp4_ = _tmp3_.constraint;
	if (_tmp2_ == _tmp4_) {
		gint _tmp5_;
		Scaling _tmp6_;
		gint _tmp7_;
		_tmp5_ = (*self).scale;
		_tmp6_ = *scaling;
		_tmp7_ = _tmp6_.scale;
		_tmp1_ = _tmp5_ == _tmp7_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		Scaling _tmp8_;
		Dimensions _tmp9_;
		_tmp8_ = *scaling;
		_tmp9_ = _tmp8_.viewport;
		_tmp0_ = dimensions_equals (&(*self).viewport, &_tmp9_);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


Scaling*
scaling_dup (const Scaling* self)
{
	Scaling* dup;
	dup = g_new0 (Scaling, 1);
	memcpy (dup, self, sizeof (Scaling));
	return dup;
}


void
scaling_free (Scaling* self)
{
	g_free (self);
}


GType
scaling_get_type (void)
{
	static volatile gsize scaling_type_id__volatile = 0;
	if (g_once_init_enter (&scaling_type_id__volatile)) {
		GType scaling_type_id;
		scaling_type_id = g_boxed_type_register_static ("Scaling", (GBoxedCopyFunc) scaling_dup, (GBoxedFreeFunc) scaling_free);
		g_once_init_leave (&scaling_type_id__volatile, scaling_type_id);
	}
	return scaling_type_id__volatile;
}


void
zoom_state_init (ZoomState *self,
                 Dimensions* content_dimensions,
                 Dimensions* viewport_dimensions,
                 gdouble slider_val,
                 GdkPoint* viewport_center)
{
	Dimensions _tmp0_;
	Dimensions _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	g_return_if_fail (content_dimensions != NULL);
	g_return_if_fail (viewport_dimensions != NULL);
	memset (self, 0, sizeof (ZoomState));
	_tmp0_ = *content_dimensions;
	(*self).content_dimensions = _tmp0_;
	_tmp1_ = *viewport_dimensions;
	(*self).viewport_dimensions = _tmp1_;
	(*self).interpolation_factor = slider_val;
	zoom_state_compute_zoom_factors (&(*self));
	if (viewport_center == NULL) {
		_tmp3_ = TRUE;
	} else {
		gboolean _tmp4_ = FALSE;
		gint _tmp5_;
		_tmp5_ = (*viewport_center).x;
		if (_tmp5_ == 0) {
			gint _tmp6_;
			_tmp6_ = (*viewport_center).y;
			_tmp4_ = _tmp6_ == 0;
		} else {
			_tmp4_ = FALSE;
		}
		_tmp3_ = _tmp4_;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = slider_val == 0.0;
	}
	if (_tmp2_) {
		zoom_state_center_viewport (&(*self));
	} else {
		(*self).viewport_center = *viewport_center;
		zoom_state_clamp_viewport_center (&(*self));
	}
}


void
zoom_state_init_rescale (ZoomState *self,
                         ZoomState* existing,
                         gdouble new_slider_val)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	g_return_if_fail (existing != NULL);
	memset (self, 0, sizeof (ZoomState));
	_tmp0_ = *existing;
	_tmp1_ = _tmp0_.content_dimensions;
	(*self).content_dimensions = _tmp1_;
	_tmp2_ = *existing;
	_tmp3_ = _tmp2_.viewport_dimensions;
	(*self).viewport_dimensions = _tmp3_;
	(*self).interpolation_factor = new_slider_val;
	zoom_state_compute_zoom_factors (&(*self));
	if (new_slider_val == 0.0) {
		zoom_state_center_viewport (&(*self));
	} else {
		gdouble _tmp4_;
		ZoomState _tmp5_;
		GdkPoint _tmp6_;
		gint _tmp7_;
		ZoomState _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
		ZoomState _tmp11_;
		GdkPoint _tmp12_;
		gint _tmp13_;
		ZoomState _tmp14_;
		gdouble _tmp15_;
		_tmp4_ = (*self).zoom_factor;
		_tmp5_ = *existing;
		_tmp6_ = _tmp5_.viewport_center;
		_tmp7_ = _tmp6_.x;
		_tmp8_ = *existing;
		_tmp9_ = _tmp8_.zoom_factor;
		(*self).viewport_center.x = (gint) (_tmp4_ * (_tmp7_ / _tmp9_));
		_tmp10_ = (*self).zoom_factor;
		_tmp11_ = *existing;
		_tmp12_ = _tmp11_.viewport_center;
		_tmp13_ = _tmp12_.y;
		_tmp14_ = *existing;
		_tmp15_ = _tmp14_.zoom_factor;
		(*self).viewport_center.y = (gint) (_tmp10_ * (_tmp13_ / _tmp15_));
		zoom_state_clamp_viewport_center (&(*self));
	}
}


void
zoom_state_init_rescale_to_isomorphic (ZoomState *self,
                                       ZoomState* existing)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	gdouble _tmp5_;
	ZoomState _tmp6_;
	gdouble _tmp7_;
	ZoomState _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	g_return_if_fail (existing != NULL);
	memset (self, 0, sizeof (ZoomState));
	_tmp0_ = *existing;
	_tmp1_ = _tmp0_.content_dimensions;
	(*self).content_dimensions = _tmp1_;
	_tmp2_ = *existing;
	_tmp3_ = _tmp2_.viewport_dimensions;
	(*self).viewport_dimensions = _tmp3_;
	_tmp4_ = *existing;
	_tmp5_ = _tmp4_.min_factor;
	_tmp6_ = *existing;
	_tmp7_ = _tmp6_.max_factor;
	_tmp8_ = *existing;
	_tmp9_ = _tmp8_.min_factor;
	(*self).interpolation_factor = log (1.0 / _tmp5_) / log (_tmp7_ / _tmp9_);
	zoom_state_compute_zoom_factors (&(*self));
	_tmp10_ = (*self).interpolation_factor;
	if (_tmp10_ == 0.0) {
		zoom_state_center_viewport (&(*self));
	} else {
		gdouble _tmp11_;
		ZoomState _tmp12_;
		GdkPoint _tmp13_;
		gint _tmp14_;
		ZoomState _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
		ZoomState _tmp18_;
		GdkPoint _tmp19_;
		gint _tmp20_;
		ZoomState _tmp21_;
		gdouble _tmp22_;
		_tmp11_ = (*self).zoom_factor;
		_tmp12_ = *existing;
		_tmp13_ = _tmp12_.viewport_center;
		_tmp14_ = _tmp13_.x;
		_tmp15_ = *existing;
		_tmp16_ = _tmp15_.zoom_factor;
		(*self).viewport_center.x = (gint) (_tmp11_ * (_tmp14_ / _tmp16_));
		_tmp17_ = (*self).zoom_factor;
		_tmp18_ = *existing;
		_tmp19_ = _tmp18_.viewport_center;
		_tmp20_ = _tmp19_.y;
		_tmp21_ = *existing;
		_tmp22_ = _tmp21_.zoom_factor;
		(*self).viewport_center.y = (gint) (_tmp17_ * (_tmp20_ / _tmp22_));
		zoom_state_clamp_viewport_center (&(*self));
	}
}


void
zoom_state_init_pan (ZoomState *self,
                     ZoomState* existing,
                     GdkPoint* new_viewport_center)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	gdouble _tmp5_;
	GdkPoint _tmp6_;
	g_return_if_fail (existing != NULL);
	g_return_if_fail (new_viewport_center != NULL);
	memset (self, 0, sizeof (ZoomState));
	_tmp0_ = *existing;
	_tmp1_ = _tmp0_.content_dimensions;
	(*self).content_dimensions = _tmp1_;
	_tmp2_ = *existing;
	_tmp3_ = _tmp2_.viewport_dimensions;
	(*self).viewport_dimensions = _tmp3_;
	_tmp4_ = *existing;
	_tmp5_ = _tmp4_.interpolation_factor;
	(*self).interpolation_factor = _tmp5_;
	zoom_state_compute_zoom_factors (&(*self));
	_tmp6_ = *new_viewport_center;
	(*self).viewport_center = _tmp6_;
	zoom_state_clamp_viewport_center (&(*self));
}


static void
zoom_state_clamp_viewport_center (ZoomState *self)
{
	gint zoomed_width = 0;
	gint zoomed_height = 0;
	GdkPoint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	Dimensions _tmp8_;
	gint _tmp9_;
	Dimensions _tmp10_;
	gint _tmp11_;
	zoomed_width = zoom_state_get_zoomed_width (&(*self));
	zoomed_height = zoom_state_get_zoomed_height (&(*self));
	_tmp0_ = (*self).viewport_center;
	_tmp1_ = _tmp0_.x;
	_tmp2_ = (*self).viewport_dimensions;
	_tmp3_ = _tmp2_.width;
	_tmp4_ = (*self).viewport_dimensions;
	_tmp5_ = _tmp4_.width;
	(*self).viewport_center.x = CLAMP (_tmp1_, _tmp3_ / 2, (zoomed_width - (_tmp5_ / 2)) - 1);
	_tmp6_ = (*self).viewport_center;
	_tmp7_ = _tmp6_.y;
	_tmp8_ = (*self).viewport_dimensions;
	_tmp9_ = _tmp8_.height;
	_tmp10_ = (*self).viewport_dimensions;
	_tmp11_ = _tmp10_.height;
	(*self).viewport_center.y = CLAMP (_tmp7_, _tmp9_ / 2, (zoomed_height - (_tmp11_ / 2)) - 1);
}


static void
zoom_state_center_viewport (ZoomState *self)
{
	(*self).viewport_center.x = zoom_state_get_zoomed_width (&(*self)) / 2;
	(*self).viewport_center.y = zoom_state_get_zoomed_height (&(*self)) / 2;
}


static void
zoom_state_compute_zoom_factors (ZoomState *self)
{
	gdouble viewport_to_content_x = 0.0;
	gdouble viewport_to_content_y = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	(*self).max_factor = 2.0;
	_tmp0_ = (*self).viewport_dimensions;
	dimensions_get_scale_ratios (&(*self).content_dimensions, &_tmp0_, &_tmp1_, &_tmp2_);
	viewport_to_content_x = _tmp1_;
	viewport_to_content_y = _tmp2_;
	_tmp3_ = viewport_to_content_x;
	_tmp4_ = viewport_to_content_y;
	(*self).min_factor = MIN (_tmp3_, _tmp4_);
	_tmp5_ = (*self).min_factor;
	if (_tmp5_ > 1.0) {
		(*self).min_factor = 1.0;
	}
	_tmp6_ = (*self).min_factor;
	_tmp7_ = (*self).max_factor;
	_tmp8_ = (*self).min_factor;
	_tmp9_ = (*self).interpolation_factor;
	(*self).zoom_factor = _tmp6_ * pow (_tmp7_ / _tmp8_, _tmp9_);
}


gdouble
zoom_state_get_interpolation_factor (ZoomState *self)
{
	gdouble result = 0.0;
	gdouble _tmp0_;
	_tmp0_ = (*self).interpolation_factor;
	result = _tmp0_;
	return result;
}


void
zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self,
                                              GdkRectangle* result)
{
	gint zoomed_width = 0;
	gint zoomed_height = 0;
	GdkRectangle _result_ = {0};
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	Dimensions _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	GdkRectangle _tmp22_;
	gint _tmp23_;
	gint right = 0;
	GdkRectangle _tmp24_;
	gint _tmp25_;
	Dimensions _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp31_;
	GdkRectangle _tmp32_;
	gint _tmp33_;
	gint bottom = 0;
	GdkRectangle _tmp34_;
	gint _tmp35_;
	Dimensions _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	gint _tmp41_;
	GdkRectangle _tmp42_;
	gint _tmp43_;
	GdkRectangle _tmp44_;
	gint _tmp45_;
	GdkRectangle _tmp46_;
	gint _tmp47_;
	zoomed_width = zoom_state_get_zoomed_width (&(*self));
	zoomed_height = zoom_state_get_zoomed_height (&(*self));
	memset (&_result_, 0, sizeof (GdkRectangle));
	_tmp0_ = (*self).viewport_dimensions;
	_tmp1_ = _tmp0_.width;
	_tmp2_ = zoomed_width;
	if (_tmp1_ < _tmp2_) {
		GdkPoint _tmp3_;
		gint _tmp4_;
		Dimensions _tmp5_;
		gint _tmp6_;
		_tmp3_ = (*self).viewport_center;
		_tmp4_ = _tmp3_.x;
		_tmp5_ = (*self).viewport_dimensions;
		_tmp6_ = _tmp5_.width;
		_result_.x = _tmp4_ - (_tmp6_ / 2);
	} else {
		gint _tmp7_;
		Dimensions _tmp8_;
		gint _tmp9_;
		_tmp7_ = zoomed_width;
		_tmp8_ = (*self).viewport_dimensions;
		_tmp9_ = _tmp8_.width;
		_result_.x = (_tmp7_ - _tmp9_) / 2;
	}
	_tmp10_ = _result_;
	_tmp11_ = _tmp10_.x;
	if (_tmp11_ < 0) {
		_result_.x = 0;
	}
	_tmp12_ = (*self).viewport_dimensions;
	_tmp13_ = _tmp12_.height;
	_tmp14_ = zoomed_height;
	if (_tmp13_ < _tmp14_) {
		GdkPoint _tmp15_;
		gint _tmp16_;
		Dimensions _tmp17_;
		gint _tmp18_;
		_tmp15_ = (*self).viewport_center;
		_tmp16_ = _tmp15_.y;
		_tmp17_ = (*self).viewport_dimensions;
		_tmp18_ = _tmp17_.height;
		_result_.y = _tmp16_ - (_tmp18_ / 2);
	} else {
		gint _tmp19_;
		Dimensions _tmp20_;
		gint _tmp21_;
		_tmp19_ = zoomed_height;
		_tmp20_ = (*self).viewport_dimensions;
		_tmp21_ = _tmp20_.height;
		_result_.y = (_tmp19_ - _tmp21_) / 2;
	}
	_tmp22_ = _result_;
	_tmp23_ = _tmp22_.y;
	if (_tmp23_ < 0) {
		_result_.y = 0;
	}
	_tmp24_ = _result_;
	_tmp25_ = _tmp24_.x;
	_tmp26_ = (*self).viewport_dimensions;
	_tmp27_ = _tmp26_.width;
	right = _tmp25_ + _tmp27_;
	_tmp28_ = right;
	_tmp29_ = zoomed_width;
	if (_tmp28_ > _tmp29_) {
		gint _tmp30_;
		_tmp30_ = zoomed_width;
		right = _tmp30_;
	}
	_tmp31_ = right;
	_tmp32_ = _result_;
	_tmp33_ = _tmp32_.x;
	_result_.width = _tmp31_ - _tmp33_;
	_tmp34_ = _result_;
	_tmp35_ = _tmp34_.y;
	_tmp36_ = (*self).viewport_dimensions;
	_tmp37_ = _tmp36_.height;
	bottom = _tmp35_ + _tmp37_;
	_tmp38_ = bottom;
	_tmp39_ = zoomed_height;
	if (_tmp38_ > _tmp39_) {
		gint _tmp40_;
		_tmp40_ = zoomed_height;
		bottom = _tmp40_;
	}
	_tmp41_ = bottom;
	_tmp42_ = _result_;
	_tmp43_ = _tmp42_.y;
	_result_.height = _tmp41_ - _tmp43_;
	_tmp44_ = _result_;
	_tmp45_ = _tmp44_.width;
	_result_.width = CLAMP (_tmp45_, 1, G_MAXINT);
	_tmp46_ = _result_;
	_tmp47_ = _tmp46_.height;
	_result_.height = CLAMP (_tmp47_, 1, G_MAXINT);
	*result = _result_;
	return;
}


void
zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self,
                                             GdkRectangle* result)
{
	GdkRectangle wrt_content = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _result_ = {0};
	Dimensions _tmp1_;
	gint _tmp2_;
	GdkRectangle _tmp3_;
	gint _tmp4_;
	GdkRectangle _tmp5_;
	gint _tmp6_;
	Dimensions _tmp7_;
	gint _tmp8_;
	GdkRectangle _tmp9_;
	gint _tmp10_;
	GdkRectangle _tmp11_;
	gint _tmp12_;
	GdkRectangle _tmp13_;
	gint _tmp14_;
	GdkRectangle _tmp15_;
	gint _tmp16_;
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp0_);
	wrt_content = _tmp0_;
	memset (&_result_, 0, sizeof (GdkRectangle));
	_tmp1_ = (*self).viewport_dimensions;
	_tmp2_ = _tmp1_.width;
	_tmp3_ = wrt_content;
	_tmp4_ = _tmp3_.width;
	_result_.x = (_tmp2_ / 2) - (_tmp4_ / 2);
	_tmp5_ = _result_;
	_tmp6_ = _tmp5_.x;
	if (_tmp6_ < 0) {
		_result_.x = 0;
	}
	_tmp7_ = (*self).viewport_dimensions;
	_tmp8_ = _tmp7_.height;
	_tmp9_ = wrt_content;
	_tmp10_ = _tmp9_.height;
	_result_.y = (_tmp8_ / 2) - (_tmp10_ / 2);
	_tmp11_ = _result_;
	_tmp12_ = _tmp11_.y;
	if (_tmp12_ < 0) {
		_result_.y = 0;
	}
	_tmp13_ = wrt_content;
	_tmp14_ = _tmp13_.width;
	_result_.width = _tmp14_;
	_tmp15_ = wrt_content;
	_tmp16_ = _tmp15_.height;
	_result_.height = _tmp16_;
	*result = _result_;
	return;
}


void
zoom_state_get_viewing_rectangle_projection (ZoomState *self,
                                             GdkPixbuf* for_pixbuf,
                                             GdkRectangle* result)
{
	gdouble zoomed_width = 0.0;
	gdouble zoomed_height = 0.0;
	gdouble horiz_scale = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	gdouble vert_scale = 0.0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble scale = 0.0;
	GdkRectangle viewing_rectangle = {0};
	GdkRectangle _tmp4_ = {0};
	GdkRectangle _result_ = {0};
	GdkRectangle _tmp5_;
	gint _tmp6_;
	GdkRectangle _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GdkRectangle _tmp11_;
	gint _tmp12_;
	GdkRectangle _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint right = 0;
	GdkRectangle _tmp17_;
	gint _tmp18_;
	GdkRectangle _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	gint bottom = 0;
	GdkRectangle _tmp24_;
	gint _tmp25_;
	GdkRectangle _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	GdkRectangle _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	GdkRectangle _tmp35_;
	gint _tmp36_;
	g_return_if_fail (GDK_IS_PIXBUF (for_pixbuf));
	zoomed_width = (gdouble) zoom_state_get_zoomed_width (&(*self));
	zoomed_height = (gdouble) zoom_state_get_zoomed_height (&(*self));
	_tmp0_ = gdk_pixbuf_get_width (for_pixbuf);
	_tmp1_ = _tmp0_;
	horiz_scale = _tmp1_ / zoomed_width;
	_tmp2_ = gdk_pixbuf_get_height (for_pixbuf);
	_tmp3_ = _tmp2_;
	vert_scale = _tmp3_ / zoomed_height;
	scale = (horiz_scale + vert_scale) / 2.0;
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp4_);
	viewing_rectangle = _tmp4_;
	memset (&_result_, 0, sizeof (GdkRectangle));
	_tmp5_ = viewing_rectangle;
	_tmp6_ = _tmp5_.x;
	_result_.x = (gint) (_tmp6_ * scale);
	_tmp7_ = _result_;
	_tmp8_ = _tmp7_.x;
	_tmp9_ = gdk_pixbuf_get_width (for_pixbuf);
	_tmp10_ = _tmp9_;
	_result_.x = CLAMP (_tmp8_, 0, _tmp10_);
	_tmp11_ = viewing_rectangle;
	_tmp12_ = _tmp11_.y;
	_result_.y = (gint) (_tmp12_ * scale);
	_tmp13_ = _result_;
	_tmp14_ = _tmp13_.y;
	_tmp15_ = gdk_pixbuf_get_height (for_pixbuf);
	_tmp16_ = _tmp15_;
	_result_.y = CLAMP (_tmp14_, 0, _tmp16_);
	_tmp17_ = viewing_rectangle;
	_tmp18_ = _tmp17_.x;
	_tmp19_ = viewing_rectangle;
	_tmp20_ = _tmp19_.width;
	right = (gint) ((_tmp18_ + _tmp20_) * scale);
	_tmp21_ = right;
	_tmp22_ = gdk_pixbuf_get_width (for_pixbuf);
	_tmp23_ = _tmp22_;
	right = CLAMP (_tmp21_, 0, _tmp23_);
	_tmp24_ = viewing_rectangle;
	_tmp25_ = _tmp24_.y;
	_tmp26_ = viewing_rectangle;
	_tmp27_ = _tmp26_.height;
	bottom = (gint) ((_tmp25_ + _tmp27_) * scale);
	_tmp28_ = bottom;
	_tmp29_ = gdk_pixbuf_get_height (for_pixbuf);
	_tmp30_ = _tmp29_;
	bottom = CLAMP (_tmp28_, 0, _tmp30_);
	_tmp31_ = right;
	_tmp32_ = _result_;
	_tmp33_ = _tmp32_.x;
	_result_.width = _tmp31_ - _tmp33_;
	_tmp34_ = bottom;
	_tmp35_ = _result_;
	_tmp36_ = _tmp35_.y;
	_result_.height = _tmp34_ - _tmp36_;
	*result = _result_;
	return;
}


gdouble
zoom_state_get_zoom_factor (ZoomState *self)
{
	gdouble result = 0.0;
	gdouble _tmp0_;
	_tmp0_ = (*self).zoom_factor;
	result = _tmp0_;
	return result;
}


gint
zoom_state_get_zoomed_width (ZoomState *self)
{
	gint result = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gdouble _tmp2_;
	_tmp0_ = (*self).content_dimensions;
	_tmp1_ = _tmp0_.width;
	_tmp2_ = (*self).zoom_factor;
	result = (gint) (_tmp1_ * _tmp2_);
	return result;
}


gint
zoom_state_get_zoomed_height (ZoomState *self)
{
	gint result = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gdouble _tmp2_;
	_tmp0_ = (*self).content_dimensions;
	_tmp1_ = _tmp0_.height;
	_tmp2_ = (*self).zoom_factor;
	result = (gint) (_tmp1_ * _tmp2_);
	return result;
}


void
zoom_state_get_viewport_center (ZoomState *self,
                                GdkPoint* result)
{
	GdkPoint _tmp0_;
	_tmp0_ = (*self).viewport_center;
	*result = _tmp0_;
	return;
}


gchar*
zoom_state_to_string (ZoomState *self)
{
	gchar* result = NULL;
	gchar* named_modes = NULL;
	gchar* _tmp0_;
	const gchar* _tmp17_;
	GdkRectangle viewing_rect = {0};
	GdkRectangle _tmp19_ = {0};
	Dimensions _tmp20_;
	gint _tmp21_;
	Dimensions _tmp22_;
	gint _tmp23_;
	Dimensions _tmp24_;
	gint _tmp25_;
	Dimensions _tmp26_;
	gint _tmp27_;
	gdouble _tmp28_;
	gdouble _tmp29_;
	gdouble _tmp30_;
	const gchar* _tmp31_;
	GdkRectangle _tmp32_;
	gint _tmp33_;
	GdkRectangle _tmp34_;
	gint _tmp35_;
	GdkRectangle _tmp36_;
	gint _tmp37_;
	GdkRectangle _tmp38_;
	gint _tmp39_;
	GdkPoint _tmp40_;
	gint _tmp41_;
	GdkPoint _tmp42_;
	gint _tmp43_;
	gchar* _tmp44_;
	_tmp0_ = g_strdup ("");
	named_modes = _tmp0_;
	if (zoom_state_is_min (&(*self))) {
		const gchar* _tmp1_ = NULL;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp2_ = named_modes;
		if (g_strcmp0 (_tmp2_, "") == 0) {
			_tmp1_ = "MIN";
		} else {
			_tmp1_ = ", MIN";
		}
		_tmp3_ = named_modes;
		_tmp4_ = g_strconcat (_tmp3_, _tmp1_, NULL);
		_g_free0 (named_modes);
		named_modes = _tmp4_;
	}
	if (zoom_state_is_default (&(*self))) {
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp6_ = named_modes;
		if (g_strcmp0 (_tmp6_, "") == 0) {
			_tmp5_ = "DEFAULT";
		} else {
			_tmp5_ = ", DEFAULT";
		}
		_tmp7_ = named_modes;
		_tmp8_ = g_strconcat (_tmp7_, _tmp5_, NULL);
		_g_free0 (named_modes);
		named_modes = _tmp8_;
	}
	if (zoom_state_is_isomorphic (&(*self))) {
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		_tmp10_ = named_modes;
		if (g_strcmp0 (_tmp10_, "") == 0) {
			_tmp9_ = "ISOMORPHIC";
		} else {
			_tmp9_ = ", ISOMORPHIC";
		}
		_tmp11_ = named_modes;
		_tmp12_ = g_strconcat (_tmp11_, _tmp9_, NULL);
		_g_free0 (named_modes);
		named_modes = _tmp12_;
	}
	if (zoom_state_is_max (&(*self))) {
		const gchar* _tmp13_ = NULL;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		_tmp14_ = named_modes;
		if (g_strcmp0 (_tmp14_, "") == 0) {
			_tmp13_ = "MAX";
		} else {
			_tmp13_ = ", MAX";
		}
		_tmp15_ = named_modes;
		_tmp16_ = g_strconcat (_tmp15_, _tmp13_, NULL);
		_g_free0 (named_modes);
		named_modes = _tmp16_;
	}
	_tmp17_ = named_modes;
	if (g_strcmp0 (_tmp17_, "") == 0) {
		gchar* _tmp18_;
		_tmp18_ = g_strdup ("(none)");
		_g_free0 (named_modes);
		named_modes = _tmp18_;
	}
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp19_);
	viewing_rect = _tmp19_;
	_tmp20_ = (*self).content_dimensions;
	_tmp21_ = _tmp20_.width;
	_tmp22_ = (*self).content_dimensions;
	_tmp23_ = _tmp22_.height;
	_tmp24_ = (*self).viewport_dimensions;
	_tmp25_ = _tmp24_.width;
	_tmp26_ = (*self).viewport_dimensions;
	_tmp27_ = _tmp26_.height;
	_tmp28_ = (*self).min_factor;
	_tmp29_ = (*self).max_factor;
	_tmp30_ = (*self).zoom_factor;
	_tmp31_ = named_modes;
	_tmp32_ = viewing_rect;
	_tmp33_ = _tmp32_.x;
	_tmp34_ = viewing_rect;
	_tmp35_ = _tmp34_.y;
	_tmp36_ = viewing_rect;
	_tmp37_ = _tmp36_.width;
	_tmp38_ = viewing_rect;
	_tmp39_ = _tmp38_.height;
	_tmp40_ = (*self).viewport_center;
	_tmp41_ = _tmp40_.x;
	_tmp42_ = (*self).viewport_center;
	_tmp43_ = _tmp42_.y;
	_tmp44_ = g_strdup_printf ("ZoomState {\n" \
"    content dimensions = %d x %d;\n" \
"    viewport dimensions = " "%d x %d;\n" \
"    min factor = %f;\n" \
"    max factor = %f;\n" \
"    current factor = %f;" "\n" \
"    zoomed width = %d;\n" \
"    zoomed height = %d;\n" \
"    named modes = %s;" "\n    viewing rectangle = { x: %d, y: %d, width: %d, height: %d };" "\n    viewport center = (%d, %d);\n}\n", _tmp21_, _tmp23_, _tmp25_, _tmp27_, _tmp28_, _tmp29_, _tmp30_, zoom_state_get_zoomed_width (&(*self)), zoom_state_get_zoomed_height (&(*self)), _tmp31_, _tmp33_, _tmp35_, _tmp37_, _tmp39_, _tmp41_, _tmp43_);
	result = _tmp44_;
	_g_free0 (named_modes);
	return result;
}


gboolean
zoom_state_is_min (ZoomState *self)
{
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = (*self).zoom_factor;
	_tmp1_ = (*self).min_factor;
	result = _tmp0_ == _tmp1_;
	return result;
}


gboolean
zoom_state_is_default (ZoomState *self)
{
	gboolean result = FALSE;
	result = zoom_state_is_min (&(*self));
	return result;
}


gboolean
zoom_state_is_max (ZoomState *self)
{
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
	_tmp0_ = (*self).zoom_factor;
	_tmp1_ = (*self).max_factor;
	result = _tmp0_ == _tmp1_;
	return result;
}


gboolean
zoom_state_is_isomorphic (ZoomState *self)
{
	gboolean result = FALSE;
	gdouble _tmp0_;
	_tmp0_ = (*self).zoom_factor;
	result = _tmp0_ == 1.0;
	return result;
}


gboolean
zoom_state_equals (ZoomState *self,
                   ZoomState* other)
{
	gboolean result = FALSE;
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	gdouble _tmp4_;
	ZoomState _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	ZoomState _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	ZoomState _tmp11_;
	gdouble _tmp12_;
	GdkPoint _tmp13_;
	gint _tmp14_;
	ZoomState _tmp15_;
	GdkPoint _tmp16_;
	gint _tmp17_;
	GdkPoint _tmp18_;
	gint _tmp19_;
	ZoomState _tmp20_;
	GdkPoint _tmp21_;
	gint _tmp22_;
	g_return_val_if_fail (other != NULL, FALSE);
	_tmp0_ = *other;
	_tmp1_ = _tmp0_.content_dimensions;
	if (!dimensions_equals (&(*self).content_dimensions, &_tmp1_)) {
		result = FALSE;
		return result;
	}
	_tmp2_ = *other;
	_tmp3_ = _tmp2_.viewport_dimensions;
	if (!dimensions_equals (&(*self).viewport_dimensions, &_tmp3_)) {
		result = FALSE;
		return result;
	}
	_tmp4_ = (*self).zoom_factor;
	_tmp5_ = *other;
	_tmp6_ = _tmp5_.zoom_factor;
	if (_tmp4_ != _tmp6_) {
		result = FALSE;
		return result;
	}
	_tmp7_ = (*self).min_factor;
	_tmp8_ = *other;
	_tmp9_ = _tmp8_.min_factor;
	if (_tmp7_ != _tmp9_) {
		result = FALSE;
		return result;
	}
	_tmp10_ = (*self).max_factor;
	_tmp11_ = *other;
	_tmp12_ = _tmp11_.max_factor;
	if (_tmp10_ != _tmp12_) {
		result = FALSE;
		return result;
	}
	_tmp13_ = (*self).viewport_center;
	_tmp14_ = _tmp13_.x;
	_tmp15_ = *other;
	_tmp16_ = _tmp15_.viewport_center;
	_tmp17_ = _tmp16_.x;
	if (_tmp14_ != _tmp17_) {
		result = FALSE;
		return result;
	}
	_tmp18_ = (*self).viewport_center;
	_tmp19_ = _tmp18_.y;
	_tmp20_ = *other;
	_tmp21_ = _tmp20_.viewport_center;
	_tmp22_ = _tmp21_.y;
	if (_tmp19_ != _tmp22_) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


ZoomState*
zoom_state_dup (const ZoomState* self)
{
	ZoomState* dup;
	dup = g_new0 (ZoomState, 1);
	memcpy (dup, self, sizeof (ZoomState));
	return dup;
}


void
zoom_state_free (ZoomState* self)
{
	g_free (self);
}


GType
zoom_state_get_type (void)
{
	static volatile gsize zoom_state_type_id__volatile = 0;
	if (g_once_init_enter (&zoom_state_type_id__volatile)) {
		GType zoom_state_type_id;
		zoom_state_type_id = g_boxed_type_register_static ("ZoomState", (GBoxedCopyFunc) zoom_state_dup, (GBoxedFreeFunc) zoom_state_free);
		g_once_init_leave (&zoom_state_type_id__volatile, zoom_state_type_id);
	}
	return zoom_state_type_id__volatile;
}



