/* NaturalCollate.c generated by valac 0.42.0, the Vala compiler
 * generated from NaturalCollate.vala, do not modify */



#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



#define NATURAL_COLLATE_SUPERDIGIT ((gunichar) ':')
#define NATURAL_COLLATE_NUM_SENTINEL ((gunichar) 0x2)
#define NATURAL_COLLATE_COLLATION_SENTINEL "\x01\x01\x01"
gint natural_collate_read_number (gchar* s,
                                  gint* byte_index);
gint natural_collate_compare (const gchar* str1,
                              const gchar* str2);
gchar* natural_collate_collate_key (gchar* str);


static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	result = g_utf8_get_char (((gchar*) self) + index);
	return result;
}


static gint
string_index_of_nth_char (const gchar* self,
                          glong c)
{
	gint result = 0;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = g_utf8_offset_to_pointer (self, c);
	result = (gint) (_tmp0_ - ((gchar*) self));
	return result;
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		glong _tmp3_;
		_tmp3_ = string_length;
		offset = _tmp3_ + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		glong _tmp4_;
		_tmp4_ = string_length;
		g_return_val_if_fail (offset <= _tmp4_, NULL);
	}
	if (len < ((glong) 0)) {
		glong _tmp5_;
		_tmp5_ = string_length;
		len = _tmp5_ - offset;
	}
	_tmp6_ = string_length;
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp7_;
	return result;
}


gint
natural_collate_read_number (gchar* s,
                             gint* byte_index)
{
	gint result = 0;
	gint number = 0;
	g_return_val_if_fail (s != NULL, 0);
	number = 0;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		gint _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint second_char = 0;
		gint _tmp5_;
		gchar* _tmp6_;
		gint _tmp7_;
		_tmp1_ = strlen (s);
		_tmp2_ = _tmp1_;
		if (_tmp2_ != 0) {
			_tmp0_ = g_unichar_isdigit (string_get_char (s, (glong) 0));
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		_tmp3_ = number;
		number = _tmp3_ * 10;
		_tmp4_ = number;
		number = _tmp4_ + g_unichar_digit_value (string_get_char (s, (glong) 0));
		second_char = string_index_of_nth_char (s, (glong) 1);
		_tmp5_ = second_char;
		_tmp6_ = string_substring (s, (glong) _tmp5_, (glong) -1);
		_g_free0 (s);
		s = _tmp6_;
		_tmp7_ = second_char;
		*byte_index = (*byte_index) + _tmp7_;
	}
	result = number;
	_g_free0 (s);
	return result;
}


gint
natural_collate_compare (const gchar* str1,
                         const gchar* str2)
{
	gint result = 0;
	GCompareFunc _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gint _tmp7_;
	g_return_val_if_fail (str1 != NULL, 0);
	g_return_val_if_fail (str2 != NULL, 0);
	_tmp0_ = g_strcmp0;
	_tmp1_ = g_strdup (str1);
	_tmp2_ = natural_collate_collate_key (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup (str2);
	_tmp5_ = natural_collate_collate_key (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp0_ (_tmp3_, _tmp6_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp3_);
	result = _tmp7_;
	return result;
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}


static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* result = NULL;
	gchar* str = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	_tmp0_ = g_new0 (gchar, 7);
	str = (gchar*) _tmp0_;
	_tmp1_ = str;
	g_unichar_to_utf8 (self, _tmp1_);
	result = str;
	return result;
}


gchar*
natural_collate_collate_key (gchar* str)
{
	gchar* result = NULL;
	gboolean _tmp0_;
	gchar* _result_ = NULL;
	gchar* _tmp1_;
	gboolean eos = FALSE;
	gint _tmp2_;
	gint _tmp3_;
	const gchar* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	g_return_val_if_fail (str != NULL, NULL);
	_tmp0_ = g_utf8_validate (str, (gssize) -1, NULL);
	_vala_assert (_tmp0_, "str.validate()");
	_tmp1_ = g_strdup ("");
	_result_ = _tmp1_;
	_tmp2_ = strlen (str);
	_tmp3_ = _tmp2_;
	eos = _tmp3_ == 0;
	while (TRUE) {
		gboolean _tmp4_;
		gboolean _tmp5_;
		gint position = 0;
		const gchar* _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gint _tmp18_;
		gchar* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		gboolean _tmp22_;
		gint _tmp56_;
		gint _tmp57_;
		_tmp4_ = eos;
		if (!(!_tmp4_)) {
			break;
		}
		_tmp5_ = g_utf8_validate (str, (gssize) -1, NULL);
		_vala_assert (_tmp5_, "str.validate()");
		position = 0;
		while (TRUE) {
			gint _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gboolean _tmp9_;
			gint _tmp10_;
			_tmp6_ = position;
			_tmp7_ = g_unichar_to_string (string_get_char (str, (glong) _tmp6_));
			_tmp8_ = _tmp7_;
			_tmp9_ = !(!string_contains ("0123456789", _tmp8_));
			_g_free0 (_tmp8_);
			if (_tmp9_) {
				break;
			}
			_tmp10_ = position;
			position = _tmp10_ + 1;
		}
		_tmp11_ = _result_;
		_tmp12_ = position;
		_tmp13_ = string_substring (str, (glong) 0, (glong) _tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = g_utf8_collate_key (_tmp14_, (gssize) -1);
		_tmp16_ = _tmp15_;
		_tmp17_ = g_strconcat (_tmp11_, _tmp16_, NULL);
		_g_free0 (_result_);
		_result_ = _tmp17_;
		_g_free0 (_tmp16_);
		_g_free0 (_tmp14_);
		_tmp18_ = position;
		_tmp19_ = string_substring (str, (glong) _tmp18_, (glong) -1);
		_g_free0 (str);
		str = _tmp19_;
		_tmp20_ = strlen (str);
		_tmp21_ = _tmp20_;
		eos = _tmp21_ == 0;
		position = 0;
		_tmp22_ = eos;
		if (!_tmp22_) {
			gint number = 0;
			gchar* _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
			gchar* _tmp26_;
			gint number_of_superdigits = 0;
			gint _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			gchar* to_append = NULL;
			gchar* _tmp33_;
			const gchar* _tmp42_;
			gint _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			const gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			const gchar* _tmp54_;
			gchar* _tmp55_;
			_tmp23_ = g_strdup (str);
			_tmp24_ = natural_collate_read_number (_tmp23_, &position);
			number = _tmp24_;
			_tmp25_ = position;
			_tmp26_ = string_substring (str, (glong) _tmp25_, (glong) -1);
			_g_free0 (str);
			str = _tmp26_;
			_tmp27_ = number;
			_tmp28_ = g_strdup_printf ("%i", _tmp27_);
			_tmp29_ = _tmp28_;
			_tmp30_ = strlen (_tmp29_);
			_tmp31_ = _tmp30_;
			_tmp32_ = _tmp31_;
			_g_free0 (_tmp29_);
			number_of_superdigits = _tmp32_;
			_tmp33_ = g_strdup ("");
			to_append = _tmp33_;
			{
				gint i = 0;
				i = 1;
				{
					gboolean _tmp34_ = FALSE;
					_tmp34_ = TRUE;
					while (TRUE) {
						gint _tmp36_;
						gint _tmp37_;
						const gchar* _tmp38_;
						gchar* _tmp39_;
						gchar* _tmp40_;
						gchar* _tmp41_;
						if (!_tmp34_) {
							gint _tmp35_;
							_tmp35_ = i;
							i = _tmp35_ + 1;
						}
						_tmp34_ = FALSE;
						_tmp36_ = i;
						_tmp37_ = number_of_superdigits;
						if (!(_tmp36_ < _tmp37_)) {
							break;
						}
						_tmp38_ = to_append;
						_tmp39_ = g_unichar_to_string (NATURAL_COLLATE_SUPERDIGIT);
						_tmp40_ = _tmp39_;
						_tmp41_ = g_strconcat (_tmp38_, _tmp40_, NULL);
						_g_free0 (to_append);
						to_append = _tmp41_;
						_g_free0 (_tmp40_);
					}
				}
			}
			_tmp42_ = to_append;
			_tmp43_ = number;
			_tmp44_ = g_strdup_printf ("%i", _tmp43_);
			_tmp45_ = _tmp44_;
			_tmp46_ = g_strconcat (_tmp42_, _tmp45_, NULL);
			_g_free0 (to_append);
			to_append = _tmp46_;
			_g_free0 (_tmp45_);
			_tmp47_ = _result_;
			_tmp48_ = g_strconcat (_tmp47_, NATURAL_COLLATE_COLLATION_SENTINEL, NULL);
			_tmp49_ = _tmp48_;
			_tmp50_ = g_unichar_to_string (NATURAL_COLLATE_NUM_SENTINEL);
			_tmp51_ = _tmp50_;
			_tmp52_ = g_strconcat (_tmp49_, _tmp51_, NULL);
			_tmp53_ = _tmp52_;
			_tmp54_ = to_append;
			_tmp55_ = g_strconcat (_tmp53_, _tmp54_, NULL);
			_g_free0 (_result_);
			_result_ = _tmp55_;
			_g_free0 (_tmp53_);
			_g_free0 (_tmp51_);
			_g_free0 (_tmp49_);
			_g_free0 (to_append);
		}
		_tmp56_ = strlen (str);
		_tmp57_ = _tmp56_;
		eos = _tmp57_ == 0;
	}
	_tmp58_ = _result_;
	_tmp59_ = g_unichar_to_string (NATURAL_COLLATE_NUM_SENTINEL);
	_tmp60_ = _tmp59_;
	_tmp61_ = g_strconcat (_tmp58_, _tmp60_, NULL);
	_g_free0 (_result_);
	_result_ = _tmp61_;
	_g_free0 (_tmp60_);
	result = _result_;
	_g_free0 (str);
	return result;
}



