/* SortedList.c generated by valac 0.42.0, the Vala compiler
 * generated from SortedList.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <gee.h>


#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;
typedef struct _SortedListPrivate SortedListPrivate;
enum  {
	SORTED_LIST_0_PROPERTY,
	SORTED_LIST_G_TYPE,
	SORTED_LIST_G_DUP_FUNC,
	SORTED_LIST_G_DESTROY_FUNC,
	SORTED_LIST_ELEMENT_TYPE_PROPERTY,
	SORTED_LIST_READ_ONLY_PROPERTY,
	SORTED_LIST_IS_EMPTY_PROPERTY,
	SORTED_LIST_SIZE_PROPERTY,
	SORTED_LIST_READ_ONLY_VIEW_PROPERTY,
	SORTED_LIST_READ_ONLY_VIEW_AS_LIST_PROPERTY,
	SORTED_LIST_NUM_PROPERTIES
};
static GParamSpec* sorted_list_properties[SORTED_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef gint64 (*Comparator) (void* a, void* b, gpointer user_data);
struct _SortedList {
	GObject parent_instance;
	SortedListPrivate * priv;
};

struct _SortedListClass {
	GObjectClass parent_class;
};

struct _SortedListPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	GeeArrayList* list;
	Comparator cmp;
	gpointer cmp_target;
};


static gint SortedList_private_offset;
static gpointer sorted_list_parent_class = NULL;
static GeeTraversableIface * sorted_list_gee_traversable_parent_iface = NULL;
static GeeIterableIface * sorted_list_gee_iterable_parent_iface = NULL;
static GeeCollectionIface * sorted_list_gee_collection_parent_iface = NULL;

GType sorted_list_get_type (void) G_GNUC_CONST;
SortedList* sorted_list_new (GType g_type,
                             GBoxedCopyFunc g_dup_func,
                             GDestroyNotify g_destroy_func,
                             Comparator cmp,
                             gpointer cmp_target);
SortedList* sorted_list_construct (GType object_type,
                                   GType g_type,
                                   GBoxedCopyFunc g_dup_func,
                                   GDestroyNotify g_destroy_func,
                                   Comparator cmp,
                                   gpointer cmp_target);
static GeeIterator* sorted_list_real_iterator (GeeIterable* base);
static gboolean sorted_list_real_foreach (GeeTraversable* base,
                                   GeeForallFunc f,
                                   gpointer f_target);
static gboolean sorted_list_real_add (GeeCollection* base,
                               gconstpointer item);
static gint sorted_list_get_sorted_insert_pos (SortedList* self,
                                        gconstpointer item);
static gboolean sorted_list_real_add_all (GeeCollection* base,
                                   GeeCollection* collection);
gboolean sorted_list_add_list (SortedList* self,
                               GeeList* items);
static gboolean sorted_list_merge_sort (SortedList* self,
                                 GeeList* add);
static void sorted_list_real_clear (GeeCollection* base);
static gboolean sorted_list_real_contains (GeeCollection* base,
                                    gconstpointer item);
static gboolean sorted_list_real_contains_all (GeeCollection* base,
                                        GeeCollection* collection);
static gboolean sorted_list_real_remove (GeeCollection* base,
                                  gconstpointer item);
static gboolean sorted_list_real_remove_all (GeeCollection* base,
                                      GeeCollection* collection);
static gboolean sorted_list_real_retain_all (GeeCollection* base,
                                      GeeCollection* collection);
gint sorted_list_get_count (SortedList* self);
gpointer sorted_list_get_at (SortedList* self,
                             gint index);
static gint sorted_list_binary_search (SortedList* self,
                                gconstpointer search,
                                GEqualFunc equal_func);
gint sorted_list_index_of (SortedList* self,
                           gconstpointer search);
gint sorted_list_locate (SortedList* self,
                         gconstpointer search,
                         gboolean altered,
                         GEqualFunc equal_func);
gpointer sorted_list_remove_at (SortedList* self,
                                gint index);
static gpointer* sorted_list_real_to_array (GeeCollection* base,
                                     int* result_length1);
void sorted_list_resort (SortedList* self,
                         Comparator new_cmp,
                         gpointer new_cmp_target);
gboolean sorted_list_resort_item (SortedList* self,
                                  gconstpointer item);
SortedList* sorted_list_copy (SortedList* self);
static void _sorted_list_merge_sort (SortedList* self,
                              gpointer* array,
                              int array_length1,
                              gpointer* scratch,
                              int scratch_length1,
                              gint start_index,
                              gint end_index);
static void sorted_list_merge (SortedList* self,
                        gpointer* array,
                        int array_length1,
                        gpointer* scratch,
                        int scratch_length1,
                        gint start_index,
                        gint middle_index,
                        gint end_index);
GeeList* sorted_list_get_read_only_view_as_list (SortedList* self);
static void sorted_list_finalize (GObject * obj);
static void _vala_sorted_list_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sorted_list_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static inline gpointer
sorted_list_get_instance_private (SortedList* self)
{
	return G_STRUCT_MEMBER_P (self, SortedList_private_offset);
}


SortedList*
sorted_list_construct (GType object_type,
                       GType g_type,
                       GBoxedCopyFunc g_dup_func,
                       GDestroyNotify g_destroy_func,
                       Comparator cmp,
                       gpointer cmp_target)
{
	SortedList * self = NULL;
	GeeArrayList* _tmp0_;
	self = (SortedList*) g_object_new (object_type, NULL);
	self->priv->g_type = g_type;
	self->priv->g_dup_func = g_dup_func;
	self->priv->g_destroy_func = g_destroy_func;
	_tmp0_ = gee_array_list_new (g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->list);
	self->priv->list = _tmp0_;
	self->priv->cmp = cmp;
	self->priv->cmp_target = cmp_target;
	return self;
}


SortedList*
sorted_list_new (GType g_type,
                 GBoxedCopyFunc g_dup_func,
                 GDestroyNotify g_destroy_func,
                 Comparator cmp,
                 gpointer cmp_target)
{
	return sorted_list_construct (TYPE_SORTED_LIST, g_type, g_dup_func, g_destroy_func, cmp, cmp_target);
}


static GeeIterator*
sorted_list_real_iterator (GeeIterable* base)
{
	SortedList * self;
	GeeIterator* result = NULL;
	GeeArrayList* _tmp0_;
	GeeIterator* _tmp1_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	_tmp0_ = self->priv->list;
	_tmp1_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
	result = _tmp1_;
	return result;
}


static gboolean
sorted_list_real_foreach (GeeTraversable* base,
                          GeeForallFunc f,
                          gpointer f_target)
{
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	_tmp0_ = self->priv->list;
	result = gee_abstract_collection_foreach (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), f, f_target);
	return result;
}


static gboolean
sorted_list_real_add (GeeCollection* base,
                      gconstpointer item)
{
	SortedList * self;
	gboolean result = FALSE;
	Comparator _tmp0_;
	void* _tmp0__target;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	_tmp0_ = self->priv->cmp;
	_tmp0__target = self->priv->cmp_target;
	if (_tmp0_ == NULL) {
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->list;
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), item);
	} else {
		GeeArrayList* _tmp2_;
		_tmp2_ = self->priv->list;
		gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), sorted_list_get_sorted_insert_pos (self, item), item);
	}
	result = TRUE;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static gboolean
sorted_list_real_add_all (GeeCollection* base,
                          GeeCollection* collection)
{
	SortedList * self;
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	GeeList* as_list = NULL;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
	Comparator _tmp5_;
	void* _tmp5__target;
	gboolean changed = FALSE;
	gint _tmp7_;
	gint _tmp8_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
	_tmp0_ = gee_collection_get_size (collection);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == 0) {
		result = FALSE;
		return result;
	}
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (collection, GEE_TYPE_LIST) ? ((GeeList*) collection) : NULL);
	as_list = _tmp2_;
	_tmp3_ = as_list;
	if (_tmp3_ != NULL) {
		GeeList* _tmp4_;
		_tmp4_ = as_list;
		result = sorted_list_add_list (self, _tmp4_);
		_g_object_unref0 (as_list);
		return result;
	}
	_tmp5_ = self->priv->cmp;
	_tmp5__target = self->priv->cmp_target;
	if (_tmp5_ == NULL) {
		GeeArrayList* _tmp6_;
		_tmp6_ = self->priv->list;
		result = gee_array_list_add_all (_tmp6_, collection);
		_g_object_unref0 (as_list);
		return result;
	}
	changed = FALSE;
	_tmp7_ = gee_collection_get_size (collection);
	_tmp8_ = _tmp7_;
	if (_tmp8_ == 1) {
		GeeIterator* iter = NULL;
		GeeIterator* _tmp9_;
		GeeIterator* _tmp10_;
		gpointer item = NULL;
		GeeIterator* _tmp11_;
		gpointer _tmp12_;
		GeeArrayList* _tmp13_;
		gconstpointer _tmp14_;
		gconstpointer _tmp15_;
		_tmp9_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (collection, GEE_TYPE_ITERABLE, GeeIterable));
		iter = _tmp9_;
		_tmp10_ = iter;
		gee_iterator_next (_tmp10_);
		_tmp11_ = iter;
		_tmp12_ = gee_iterator_get (_tmp11_);
		item = _tmp12_;
		_tmp13_ = self->priv->list;
		_tmp14_ = item;
		_tmp15_ = item;
		gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), sorted_list_get_sorted_insert_pos (self, _tmp14_), _tmp15_);
		changed = TRUE;
		((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
		_g_object_unref0 (iter);
	} else {
		GeeList* items = NULL;
		GeeArrayList* _tmp16_;
		GeeList* _tmp17_;
		GeeList* _tmp18_;
		_tmp16_ = gee_array_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, NULL, NULL, NULL);
		items = G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_LIST, GeeList);
		_tmp17_ = items;
		gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection), collection);
		_tmp18_ = items;
		changed = sorted_list_merge_sort (self, _tmp18_);
		_g_object_unref0 (items);
	}
	result = changed;
	_g_object_unref0 (as_list);
	return result;
}


gboolean
sorted_list_add_list (SortedList* self,
                      GeeList* items)
{
	gboolean result = FALSE;
	gboolean added = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
	g_return_val_if_fail (GEE_IS_LIST (items), FALSE);
	added = FALSE;
	_tmp0_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (items, GEE_TYPE_COLLECTION, GeeCollection));
	_tmp1_ = _tmp0_;
	if (_tmp1_ == 0) {
	} else {
		Comparator _tmp2_;
		void* _tmp2__target;
		_tmp2_ = self->priv->cmp;
		_tmp2__target = self->priv->cmp_target;
		if (_tmp2_ != NULL) {
			gint _tmp3_;
			gint _tmp4_;
			_tmp3_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (items, GEE_TYPE_COLLECTION, GeeCollection));
			_tmp4_ = _tmp3_;
			if (_tmp4_ == 1) {
				GeeArrayList* _tmp5_;
				gpointer _tmp6_;
				gpointer _tmp7_;
				gpointer _tmp8_;
				gpointer _tmp9_;
				_tmp5_ = self->priv->list;
				_tmp6_ = gee_list_get (items, 0);
				_tmp7_ = _tmp6_;
				_tmp8_ = gee_list_get (items, 0);
				_tmp9_ = _tmp8_;
				gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), sorted_list_get_sorted_insert_pos (self, _tmp7_), _tmp9_);
				((_tmp9_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp9_ = (self->priv->g_destroy_func (_tmp9_), NULL));
				((_tmp7_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp7_ = (self->priv->g_destroy_func (_tmp7_), NULL));
				added = TRUE;
			} else {
				added = sorted_list_merge_sort (self, items);
			}
		} else {
			GeeArrayList* _tmp10_;
			_tmp10_ = self->priv->list;
			added = gee_array_list_add_all (_tmp10_, G_TYPE_CHECK_INSTANCE_CAST (items, GEE_TYPE_COLLECTION, GeeCollection));
		}
	}
	result = added;
	return result;
}


static void
sorted_list_real_clear (GeeCollection* base)
{
	SortedList * self;
	GeeArrayList* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	_tmp0_ = self->priv->list;
	gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
}


static gboolean
sorted_list_real_contains (GeeCollection* base,
                           gconstpointer item)
{
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	_tmp0_ = self->priv->list;
	result = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), item);
	return result;
}


static gboolean
sorted_list_real_contains_all (GeeCollection* base,
                               GeeCollection* collection)
{
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
	_tmp0_ = self->priv->list;
	result = gee_collection_contains_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), collection);
	return result;
}


static gboolean
sorted_list_real_remove (GeeCollection* base,
                         gconstpointer item)
{
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	_tmp0_ = self->priv->list;
	result = gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), item);
	return result;
}


static gboolean
sorted_list_real_remove_all (GeeCollection* base,
                             GeeCollection* collection)
{
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
	_tmp0_ = self->priv->list;
	result = gee_collection_remove_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), collection);
	return result;
}


static gboolean
sorted_list_real_retain_all (GeeCollection* base,
                             GeeCollection* collection)
{
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
	_tmp0_ = self->priv->list;
	result = gee_collection_retain_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), collection);
	return result;
}


inline gint
sorted_list_get_count (SortedList* self)
{
	gint result = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
	_tmp0_ = self->priv->list;
	_tmp1_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


gpointer
sorted_list_get_at (SortedList* self,
                    gint index)
{
	gpointer result = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
	_tmp0_ = self->priv->list;
	_tmp1_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), index);
	result = _tmp1_;
	return result;
}


static gint
sorted_list_binary_search (SortedList* self,
                           gconstpointer search,
                           GEqualFunc equal_func)
{
	gint result = 0;
	Comparator _tmp0_;
	void* _tmp0__target;
	gint min = 0;
	gint max = 0;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
	_tmp0_ = self->priv->cmp;
	_tmp0__target = self->priv->cmp_target;
	_vala_assert (_tmp0_ != NULL, "cmp != null");
	min = 0;
	_tmp1_ = self->priv->list;
	_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
	_tmp3_ = _tmp2_;
	max = _tmp3_;
	{
		gboolean _tmp4_ = FALSE;
		_tmp4_ = TRUE;
		while (TRUE) {
			gint mid = 0;
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gpointer item = NULL;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			gboolean _tmp11_ = FALSE;
			gint64 compare = 0LL;
			Comparator _tmp13_;
			void* _tmp13__target;
			gconstpointer _tmp14_;
			gint64 _tmp15_;
			gint _tmp19_;
			gint _tmp20_;
			if (!_tmp4_) {
			}
			_tmp4_ = FALSE;
			_tmp5_ = min;
			_tmp6_ = max;
			_tmp7_ = min;
			mid = _tmp5_ + ((_tmp6_ - _tmp7_) / 2);
			_tmp8_ = self->priv->list;
			_tmp9_ = mid;
			_tmp10_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp9_);
			item = _tmp10_;
			if (equal_func != NULL) {
				gconstpointer _tmp12_;
				_tmp12_ = item;
				_tmp11_ = equal_func (_tmp12_, search);
			} else {
				_tmp11_ = FALSE;
			}
			if (_tmp11_) {
				result = mid;
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
				return result;
			}
			_tmp13_ = self->priv->cmp;
			_tmp13__target = self->priv->cmp_target;
			_tmp14_ = item;
			compare = _tmp13_ (_tmp14_, search, _tmp13__target);
			_tmp15_ = compare;
			if (_tmp15_ == ((gint64) 0)) {
				result = mid;
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
				return result;
			} else {
				gint64 _tmp16_;
				_tmp16_ = compare;
				if (_tmp16_ > ((gint64) 0)) {
					gint _tmp17_;
					_tmp17_ = mid;
					max = _tmp17_ - 1;
				} else {
					gint _tmp18_;
					_tmp18_ = mid;
					min = _tmp18_ + 1;
				}
			}
			_tmp19_ = min;
			_tmp20_ = max;
			if (_tmp19_ > _tmp20_) {
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
				break;
			}
			((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
		}
	}
	result = -1;
	return result;
}


gint
sorted_list_index_of (SortedList* self,
                      gconstpointer search)
{
	gint result = 0;
	gint _tmp0_ = 0;
	Comparator _tmp1_;
	void* _tmp1__target;
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
	_tmp1_ = self->priv->cmp;
	_tmp1__target = self->priv->cmp_target;
	if (_tmp1_ != NULL) {
		_tmp0_ = sorted_list_binary_search (self, search, NULL);
	} else {
		GEqualFunc _tmp2_;
		_tmp2_ = g_direct_equal;
		_tmp0_ = sorted_list_locate (self, search, FALSE, _tmp2_);
	}
	result = _tmp0_;
	return result;
}


gint
sorted_list_locate (SortedList* self,
                    gconstpointer search,
                    gboolean altered,
                    GEqualFunc equal_func)
{
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	Comparator _tmp1_;
	void* _tmp1__target;
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
	_tmp1_ = self->priv->cmp;
	_tmp1__target = self->priv->cmp_target;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = altered;
	}
	if (_tmp0_) {
		gint count = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		_tmp2_ = self->priv->list;
		_tmp3_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
		_tmp4_ = _tmp3_;
		count = _tmp4_;
		{
			gint ctr = 0;
			ctr = 0;
			{
				gboolean _tmp5_ = FALSE;
				_tmp5_ = TRUE;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					GeeArrayList* _tmp9_;
					gint _tmp10_;
					gpointer _tmp11_;
					gpointer _tmp12_;
					gboolean _tmp13_;
					if (!_tmp5_) {
						gint _tmp6_;
						_tmp6_ = ctr;
						ctr = _tmp6_ + 1;
					}
					_tmp5_ = FALSE;
					_tmp7_ = ctr;
					_tmp8_ = count;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = self->priv->list;
					_tmp10_ = ctr;
					_tmp11_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp10_);
					_tmp12_ = _tmp11_;
					_tmp13_ = equal_func (_tmp12_, search);
					((_tmp12_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp12_ = (self->priv->g_destroy_func (_tmp12_), NULL));
					if (_tmp13_) {
						result = ctr;
						return result;
					}
				}
			}
		}
		result = -1;
		return result;
	}
	result = sorted_list_binary_search (self, search, equal_func);
	return result;
}


gpointer
sorted_list_remove_at (SortedList* self,
                       gint index)
{
	gpointer result = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
	_tmp0_ = self->priv->list;
	_tmp1_ = gee_abstract_list_remove_at (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), index);
	result = _tmp1_;
	return result;
}


static gpointer*
sorted_list_real_to_array (GeeCollection* base,
                           int* result_length1)
{
	SortedList * self;
	gpointer* result = NULL;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gpointer* _tmp2_;
	gpointer* _tmp3_;
	gint _tmp3__length1;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	_tmp0_ = self->priv->list;
	_tmp2_ = gee_collection_to_array (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	if (result_length1) {
		*result_length1 = _tmp3__length1;
	}
	result = _tmp3_;
	return result;
}


void
sorted_list_resort (SortedList* self,
                    Comparator new_cmp,
                    gpointer new_cmp_target)
{
	g_return_if_fail (IS_SORTED_LIST (self));
	self->priv->cmp = new_cmp;
	self->priv->cmp_target = new_cmp_target;
	sorted_list_merge_sort (self, NULL);
}


gboolean
sorted_list_resort_item (SortedList* self,
                         gconstpointer item)
{
	gboolean result = FALSE;
	gint index = 0;
	GEqualFunc _tmp0_;
	gint _tmp1_;
	gint new_index = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
	_tmp0_ = g_direct_equal;
	index = sorted_list_locate (self, item, TRUE, _tmp0_);
	_tmp1_ = index;
	_vala_assert (_tmp1_ >= 0, "index >= 0");
	new_index = sorted_list_get_sorted_insert_pos (self, item);
	_tmp2_ = index;
	_tmp3_ = new_index;
	if (_tmp2_ == _tmp3_) {
		result = FALSE;
		return result;
	}
	_tmp4_ = new_index;
	_tmp5_ = index;
	if (_tmp4_ > _tmp5_) {
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gpointer removed_item = NULL;
		GeeArrayList* _tmp8_;
		gint _tmp9_;
		gpointer _tmp10_;
		gconstpointer _tmp11_;
		_tmp6_ = self->priv->list;
		_tmp7_ = new_index;
		gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp7_, item);
		_tmp8_ = self->priv->list;
		_tmp9_ = index;
		_tmp10_ = gee_abstract_list_remove_at (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp9_);
		removed_item = _tmp10_;
		_tmp11_ = removed_item;
		_vala_assert (item == _tmp11_, "item == removed_item");
		((removed_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (removed_item = (self->priv->g_destroy_func (removed_item), NULL));
	} else {
		gpointer removed_item = NULL;
		GeeArrayList* _tmp12_;
		gint _tmp13_;
		gpointer _tmp14_;
		gconstpointer _tmp15_;
		GeeArrayList* _tmp16_;
		gint _tmp17_;
		_tmp12_ = self->priv->list;
		_tmp13_ = index;
		_tmp14_ = gee_abstract_list_remove_at (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp13_);
		removed_item = _tmp14_;
		_tmp15_ = removed_item;
		_vala_assert (item == _tmp15_, "item == removed_item");
		_tmp16_ = self->priv->list;
		_tmp17_ = new_index;
		gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp17_, item);
		((removed_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (removed_item = (self->priv->g_destroy_func (removed_item), NULL));
	}
	result = TRUE;
	return result;
}


static gint
sorted_list_get_sorted_insert_pos (SortedList* self,
                                   gconstpointer item)
{
	gint result = 0;
	gint low = 0;
	gint high = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
	low = 0;
	_tmp0_ = self->priv->list;
	_tmp1_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
	_tmp2_ = _tmp1_;
	high = _tmp2_;
	{
		gboolean _tmp3_ = FALSE;
		_tmp3_ = TRUE;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			gint mid = 0;
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gpointer cmp_item = NULL;
			GeeArrayList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_;
			gconstpointer _tmp12_;
			gint64 _result_ = 0LL;
			Comparator _tmp23_;
			void* _tmp23__target;
			gconstpointer _tmp24_;
			gint64 _tmp25_;
			if (!_tmp3_) {
			}
			_tmp3_ = FALSE;
			_tmp4_ = low;
			_tmp5_ = high;
			if (_tmp4_ == _tmp5_) {
				result = low;
				return result;
			}
			_tmp6_ = low;
			_tmp7_ = high;
			_tmp8_ = low;
			mid = _tmp6_ + ((_tmp7_ - _tmp8_) / 2);
			_tmp9_ = self->priv->list;
			_tmp10_ = mid;
			_tmp11_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp10_);
			cmp_item = _tmp11_;
			_tmp12_ = cmp_item;
			if (item == _tmp12_) {
				gint _tmp13_;
				GeeArrayList* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				GeeArrayList* _tmp20_;
				gint _tmp21_;
				gpointer _tmp22_;
				_tmp13_ = mid;
				_tmp14_ = self->priv->list;
				_tmp15_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
				_tmp16_ = _tmp15_;
				if (_tmp13_ >= (_tmp16_ - 1)) {
					GeeArrayList* _tmp17_;
					gint _tmp18_;
					gint _tmp19_;
					_tmp17_ = self->priv->list;
					_tmp18_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
					_tmp19_ = _tmp18_;
					result = _tmp19_;
					((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
					return result;
				}
				_tmp20_ = self->priv->list;
				_tmp21_ = mid;
				_tmp22_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp21_ + 1);
				((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
				cmp_item = _tmp22_;
			}
			_tmp23_ = self->priv->cmp;
			_tmp23__target = self->priv->cmp_target;
			_tmp24_ = cmp_item;
			_result_ = _tmp23_ (item, _tmp24_, _tmp23__target);
			_tmp25_ = _result_;
			if (_tmp25_ < ((gint64) 0)) {
				gint _tmp26_;
				_tmp26_ = mid;
				high = _tmp26_;
			} else {
				gint64 _tmp27_;
				_tmp27_ = _result_;
				if (_tmp27_ > ((gint64) 0)) {
					gint _tmp28_;
					_tmp28_ = mid;
					low = _tmp28_ + 1;
				} else {
					result = mid;
					((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
					return result;
				}
			}
			((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
		}
	}
}


SortedList*
sorted_list_copy (SortedList* self)
{
	SortedList* result = NULL;
	SortedList* copy = NULL;
	Comparator _tmp0_;
	void* _tmp0__target;
	SortedList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
	_tmp0_ = self->priv->cmp;
	_tmp0__target = self->priv->cmp_target;
	_tmp1_ = sorted_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, _tmp0_, _tmp0__target);
	copy = _tmp1_;
	_tmp2_ = copy->priv->list;
	_tmp3_ = self->priv->list;
	gee_array_list_add_all (_tmp2_, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
	result = copy;
	return result;
}


static gboolean
sorted_list_merge_sort (SortedList* self,
                        GeeList* add)
{
	gboolean result = FALSE;
	Comparator _tmp0_;
	void* _tmp0__target;
	gint list_count = 0;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_ = 0;
	gint add_count = 0;
	gint count = 0;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gpointer* array = NULL;
	gint _tmp10_;
	gpointer* _tmp11_;
	gint array_length1;
	gint _array_size_;
	gint offset = 0;
	gint _tmp29_;
	gint _tmp30_;
	gpointer* _tmp31_;
	gint _tmp31__length1;
	gint _tmp32_;
	gpointer* _tmp33_;
	gpointer* _tmp34_;
	gint _tmp34__length1;
	gint _tmp35_;
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
	g_return_val_if_fail ((add == NULL) || GEE_IS_LIST (add), FALSE);
	_tmp0_ = self->priv->cmp;
	_tmp0__target = self->priv->cmp_target;
	_vala_assert (_tmp0_ != NULL, "cmp != null");
	_tmp1_ = self->priv->list;
	_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
	_tmp3_ = _tmp2_;
	list_count = _tmp3_;
	if (add != NULL) {
		gint _tmp5_;
		gint _tmp6_;
		_tmp5_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (add, GEE_TYPE_COLLECTION, GeeCollection));
		_tmp6_ = _tmp5_;
		_tmp4_ = _tmp6_;
	} else {
		_tmp4_ = 0;
	}
	add_count = _tmp4_;
	_tmp7_ = list_count;
	_tmp8_ = add_count;
	count = _tmp7_ + _tmp8_;
	_tmp9_ = count;
	if (_tmp9_ == 0) {
		result = FALSE;
		return result;
	}
	_tmp10_ = count;
	_tmp11_ = g_new0 (gpointer, _tmp10_);
	array = _tmp11_;
	array_length1 = _tmp10_;
	_array_size_ = array_length1;
	offset = 0;
	while (TRUE) {
		gint _tmp12_;
		gint _tmp13_;
		gpointer* _tmp14_;
		gint _tmp14__length1;
		gint _tmp15_;
		GeeArrayList* _tmp16_;
		gint _tmp17_;
		gpointer _tmp18_;
		gpointer _tmp19_;
		gint _tmp20_;
		_tmp12_ = offset;
		_tmp13_ = list_count;
		if (!(_tmp12_ < _tmp13_)) {
			break;
		}
		_tmp14_ = array;
		_tmp14__length1 = array_length1;
		_tmp15_ = offset;
		_tmp16_ = self->priv->list;
		_tmp17_ = offset;
		_tmp18_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp17_);
		((_tmp14_[_tmp15_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp14_[_tmp15_] = (self->priv->g_destroy_func (_tmp14_[_tmp15_]), NULL));
		_tmp14_[_tmp15_] = _tmp18_;
		_tmp19_ = _tmp14_[_tmp15_];
		_tmp20_ = offset;
		offset = _tmp20_ + 1;
	}
	if (add != NULL) {
		gint add_ctr = 0;
		add_ctr = 0;
		while (TRUE) {
			gint _tmp21_;
			gint _tmp22_;
			gpointer* _tmp23_;
			gint _tmp23__length1;
			gint _tmp24_;
			gint _tmp25_;
			gpointer _tmp26_;
			gpointer _tmp27_;
			gint _tmp28_;
			_tmp21_ = offset;
			_tmp22_ = count;
			if (!(_tmp21_ < _tmp22_)) {
				break;
			}
			_tmp23_ = array;
			_tmp23__length1 = array_length1;
			_tmp24_ = offset;
			_tmp25_ = add_ctr;
			add_ctr = _tmp25_ + 1;
			_tmp26_ = gee_list_get (add, _tmp25_);
			((_tmp23_[_tmp24_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp23_[_tmp24_] = (self->priv->g_destroy_func (_tmp23_[_tmp24_]), NULL));
			_tmp23_[_tmp24_] = _tmp26_;
			_tmp27_ = _tmp23_[_tmp24_];
			_tmp28_ = offset;
			offset = _tmp28_ + 1;
		}
	}
	_tmp29_ = offset;
	_tmp30_ = count;
	_vala_assert (_tmp29_ == _tmp30_, "offset == count");
	_tmp31_ = array;
	_tmp31__length1 = array_length1;
	_tmp32_ = count;
	_tmp33_ = g_new0 (gpointer, _tmp32_);
	_tmp34_ = _tmp33_;
	_tmp34__length1 = _tmp32_;
	_tmp35_ = count;
	_sorted_list_merge_sort (self, _tmp31_, _tmp31__length1, _tmp34_, _tmp32_, 0, _tmp35_ - 1);
	_tmp34_ = (_vala_array_free (_tmp34_, _tmp34__length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
	offset = 0;
	while (TRUE) {
		gint _tmp36_;
		gint _tmp37_;
		GeeArrayList* _tmp38_;
		gint _tmp39_;
		gpointer* _tmp40_;
		gint _tmp40__length1;
		gint _tmp41_;
		gconstpointer _tmp42_;
		gint _tmp43_;
		_tmp36_ = offset;
		_tmp37_ = list_count;
		if (!(_tmp36_ < _tmp37_)) {
			break;
		}
		_tmp38_ = self->priv->list;
		_tmp39_ = offset;
		_tmp40_ = array;
		_tmp40__length1 = array_length1;
		_tmp41_ = offset;
		_tmp42_ = _tmp40_[_tmp41_];
		gee_abstract_list_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp39_, _tmp42_);
		_tmp43_ = offset;
		offset = _tmp43_ + 1;
	}
	while (TRUE) {
		gint _tmp44_;
		gint _tmp45_;
		GeeArrayList* _tmp46_;
		gint _tmp47_;
		gpointer* _tmp48_;
		gint _tmp48__length1;
		gint _tmp49_;
		gconstpointer _tmp50_;
		gint _tmp51_;
		_tmp44_ = offset;
		_tmp45_ = count;
		if (!(_tmp44_ < _tmp45_)) {
			break;
		}
		_tmp46_ = self->priv->list;
		_tmp47_ = offset;
		_tmp48_ = array;
		_tmp48__length1 = array_length1;
		_tmp49_ = offset;
		_tmp50_ = _tmp48_[_tmp49_];
		gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp47_, _tmp50_);
		_tmp51_ = offset;
		offset = _tmp51_ + 1;
	}
	result = TRUE;
	array = (_vala_array_free (array, array_length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
	return result;
}


static void
_sorted_list_merge_sort (SortedList* self,
                         gpointer* array,
                         int array_length1,
                         gpointer* scratch,
                         int scratch_length1,
                         gint start_index,
                         gint end_index)
{
	gint count = 0;
	gint _tmp0_;
	gint middle_index = 0;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Comparator _tmp4_;
	void* _tmp4__target;
	gint _tmp5_;
	gconstpointer _tmp6_;
	gint _tmp7_;
	gconstpointer _tmp8_;
	g_return_if_fail (IS_SORTED_LIST (self));
	_vala_assert (start_index <= end_index, "start_index <= end_index");
	count = (end_index - start_index) + 1;
	_tmp0_ = count;
	if (_tmp0_ <= 1) {
		return;
	}
	_tmp1_ = count;
	middle_index = start_index + (_tmp1_ / 2);
	_tmp2_ = middle_index;
	_sorted_list_merge_sort (self, array, array_length1, scratch, scratch_length1, start_index, _tmp2_ - 1);
	_tmp3_ = middle_index;
	_sorted_list_merge_sort (self, array, array_length1, scratch, scratch_length1, _tmp3_, end_index);
	_tmp4_ = self->priv->cmp;
	_tmp4__target = self->priv->cmp_target;
	_tmp5_ = middle_index;
	_tmp6_ = array[_tmp5_ - 1];
	_tmp7_ = middle_index;
	_tmp8_ = array[_tmp7_];
	if (_tmp4_ (_tmp6_, _tmp8_, _tmp4__target) > ((gint64) 0)) {
		gint _tmp9_;
		_tmp9_ = middle_index;
		sorted_list_merge (self, array, array_length1, scratch, scratch_length1, start_index, _tmp9_, end_index);
	}
}


static void
sorted_list_merge (SortedList* self,
                   gpointer* array,
                   int array_length1,
                   gpointer* scratch,
                   int scratch_length1,
                   gint start_index,
                   gint middle_index,
                   gint end_index)
{
	gint count = 0;
	gint left_start = 0;
	gint left_end = 0;
	gint right_start = 0;
	gint right_end = 0;
	gint _tmp0_;
	gint scratch_index = 0;
	gint _tmp39_;
	gint _tmp40_;
	g_return_if_fail (IS_SORTED_LIST (self));
	_vala_assert (start_index < end_index, "start_index < end_index");
	count = (end_index - start_index) + 1;
	left_start = start_index;
	left_end = middle_index - 1;
	right_start = middle_index;
	right_end = end_index;
	_tmp0_ = count;
	_vala_assert (scratch_length1 >= _tmp0_, "scratch.length >= count");
	scratch_index = 0;
	while (TRUE) {
		gboolean _tmp1_ = FALSE;
		gint _tmp2_;
		gint _tmp3_;
		gpointer left = NULL;
		gint _tmp6_;
		gconstpointer _tmp7_;
		gpointer _tmp8_;
		gpointer right = NULL;
		gint _tmp9_;
		gconstpointer _tmp10_;
		gpointer _tmp11_;
		Comparator _tmp12_;
		void* _tmp12__target;
		gconstpointer _tmp13_;
		gconstpointer _tmp14_;
		_tmp2_ = left_start;
		_tmp3_ = left_end;
		if (_tmp2_ <= _tmp3_) {
			gint _tmp4_;
			gint _tmp5_;
			_tmp4_ = right_start;
			_tmp5_ = right_end;
			_tmp1_ = _tmp4_ <= _tmp5_;
		} else {
			_tmp1_ = FALSE;
		}
		if (!_tmp1_) {
			break;
		}
		_tmp6_ = left_start;
		_tmp7_ = array[_tmp6_];
		_tmp8_ = ((_tmp7_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp7_) : ((gpointer) _tmp7_);
		left = _tmp8_;
		_tmp9_ = right_start;
		_tmp10_ = array[_tmp9_];
		_tmp11_ = ((_tmp10_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp10_) : ((gpointer) _tmp10_);
		right = _tmp11_;
		_tmp12_ = self->priv->cmp;
		_tmp12__target = self->priv->cmp_target;
		_tmp13_ = left;
		_tmp14_ = right;
		if (_tmp12_ (_tmp13_, _tmp14_, _tmp12__target) <= ((gint64) 0)) {
			gint _tmp15_;
			gconstpointer _tmp16_;
			gpointer _tmp17_;
			gpointer _tmp18_;
			gint _tmp19_;
			_tmp15_ = scratch_index;
			scratch_index = _tmp15_ + 1;
			_tmp16_ = left;
			_tmp17_ = ((_tmp16_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp16_) : ((gpointer) _tmp16_);
			((scratch[_tmp15_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (scratch[_tmp15_] = (self->priv->g_destroy_func (scratch[_tmp15_]), NULL));
			scratch[_tmp15_] = _tmp17_;
			_tmp18_ = scratch[_tmp15_];
			_tmp19_ = left_start;
			left_start = _tmp19_ + 1;
		} else {
			gint _tmp20_;
			gconstpointer _tmp21_;
			gpointer _tmp22_;
			gpointer _tmp23_;
			gint _tmp24_;
			_tmp20_ = scratch_index;
			scratch_index = _tmp20_ + 1;
			_tmp21_ = right;
			_tmp22_ = ((_tmp21_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp21_) : ((gpointer) _tmp21_);
			((scratch[_tmp20_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (scratch[_tmp20_] = (self->priv->g_destroy_func (scratch[_tmp20_]), NULL));
			scratch[_tmp20_] = _tmp22_;
			_tmp23_ = scratch[_tmp20_];
			_tmp24_ = right_start;
			right_start = _tmp24_ + 1;
		}
		((right == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (right = (self->priv->g_destroy_func (right), NULL));
		((left == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (left = (self->priv->g_destroy_func (left), NULL));
	}
	while (TRUE) {
		gint _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
		gconstpointer _tmp29_;
		gpointer _tmp30_;
		gpointer _tmp31_;
		_tmp25_ = left_start;
		_tmp26_ = left_end;
		if (!(_tmp25_ <= _tmp26_)) {
			break;
		}
		_tmp27_ = scratch_index;
		scratch_index = _tmp27_ + 1;
		_tmp28_ = left_start;
		left_start = _tmp28_ + 1;
		_tmp29_ = array[_tmp28_];
		_tmp30_ = ((_tmp29_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp29_) : ((gpointer) _tmp29_);
		((scratch[_tmp27_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (scratch[_tmp27_] = (self->priv->g_destroy_func (scratch[_tmp27_]), NULL));
		scratch[_tmp27_] = _tmp30_;
		_tmp31_ = scratch[_tmp27_];
	}
	while (TRUE) {
		gint _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
		gconstpointer _tmp36_;
		gpointer _tmp37_;
		gpointer _tmp38_;
		_tmp32_ = right_start;
		_tmp33_ = right_end;
		if (!(_tmp32_ <= _tmp33_)) {
			break;
		}
		_tmp34_ = scratch_index;
		scratch_index = _tmp34_ + 1;
		_tmp35_ = right_start;
		right_start = _tmp35_ + 1;
		_tmp36_ = array[_tmp35_];
		_tmp37_ = ((_tmp36_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp36_) : ((gpointer) _tmp36_);
		((scratch[_tmp34_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (scratch[_tmp34_] = (self->priv->g_destroy_func (scratch[_tmp34_]), NULL));
		scratch[_tmp34_] = _tmp37_;
		_tmp38_ = scratch[_tmp34_];
	}
	_tmp39_ = scratch_index;
	_tmp40_ = count;
	_vala_assert (_tmp39_ == _tmp40_, "scratch_index == count");
	scratch_index = 0;
	{
		gint list_index = 0;
		list_index = start_index;
		{
			gboolean _tmp41_ = FALSE;
			_tmp41_ = TRUE;
			while (TRUE) {
				gint _tmp43_;
				gint _tmp44_;
				gint _tmp45_;
				gconstpointer _tmp46_;
				gpointer _tmp47_;
				gpointer _tmp48_;
				if (!_tmp41_) {
					gint _tmp42_;
					_tmp42_ = list_index;
					list_index = _tmp42_ + 1;
				}
				_tmp41_ = FALSE;
				_tmp43_ = list_index;
				if (!(_tmp43_ <= end_index)) {
					break;
				}
				_tmp44_ = list_index;
				_tmp45_ = scratch_index;
				scratch_index = _tmp45_ + 1;
				_tmp46_ = scratch[_tmp45_];
				_tmp47_ = ((_tmp46_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp46_) : ((gpointer) _tmp46_);
				((array[_tmp44_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (array[_tmp44_] = (self->priv->g_destroy_func (array[_tmp44_]), NULL));
				array[_tmp44_] = _tmp47_;
				_tmp48_ = array[_tmp44_];
			}
		}
	}
}


static GType
sorted_list_real_get_element_type (GeeTraversable* base)
{
	GType result;
	SortedList* self;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	result = self->priv->g_type;
	return result;
}


static gboolean
sorted_list_real_get_read_only (GeeCollection* base)
{
	gboolean result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	_tmp0_ = self->priv->list;
	_tmp1_ = gee_abstract_collection_get_read_only (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static gboolean
sorted_list_real_get_is_empty (GeeCollection* base)
{
	gboolean result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	_tmp0_ = self->priv->list;
	_tmp1_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static gint
sorted_list_real_get_size (GeeCollection* base)
{
	gint result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	_tmp0_ = self->priv->list;
	_tmp1_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static GeeCollection*
sorted_list_real_get_read_only_view (GeeCollection* base)
{
	GeeCollection* result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SORTED_LIST, SortedList);
	_tmp0_ = self->priv->list;
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_BIDIR_LIST, GeeAbstractBidirList));
	_tmp2_ = _tmp1_;
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection);
	return result;
}


GeeList*
sorted_list_get_read_only_view_as_list (SortedList* self)
{
	GeeList* result;
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
	_tmp0_ = self->priv->list;
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_BIDIR_LIST, GeeAbstractBidirList));
	_tmp2_ = _tmp1_;
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_LIST, GeeList);
	return result;
}


static void
sorted_list_class_init (SortedListClass * klass)
{
	sorted_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SortedList_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_sorted_list_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sorted_list_set_property;
	G_OBJECT_CLASS (klass)->finalize = sorted_list_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_ELEMENT_TYPE_PROPERTY, sorted_list_properties[SORTED_LIST_ELEMENT_TYPE_PROPERTY] = g_param_spec_gtype ("element-type", "element-type", "element-type", G_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_READ_ONLY_PROPERTY, sorted_list_properties[SORTED_LIST_READ_ONLY_PROPERTY] = g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_IS_EMPTY_PROPERTY, sorted_list_properties[SORTED_LIST_IS_EMPTY_PROPERTY] = g_param_spec_boolean ("is-empty", "is-empty", "is-empty", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_SIZE_PROPERTY, sorted_list_properties[SORTED_LIST_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_READ_ONLY_VIEW_PROPERTY, sorted_list_properties[SORTED_LIST_READ_ONLY_VIEW_PROPERTY] = g_param_spec_object ("read-only-view", "read-only-view", "read-only-view", GEE_TYPE_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_READ_ONLY_VIEW_AS_LIST_PROPERTY, sorted_list_properties[SORTED_LIST_READ_ONLY_VIEW_AS_LIST_PROPERTY] = g_param_spec_object ("read-only-view-as-list", "read-only-view-as-list", "read-only-view-as-list", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static GType
sorted_list_gee_traversable_get_g_type (SortedList* self)
{
	return self->priv->g_type;
}


static GBoxedCopyFunc
sorted_list_gee_traversable_get_g_dup_func (SortedList* self)
{
	return self->priv->g_dup_func;
}


static GDestroyNotify
sorted_list_gee_traversable_get_g_destroy_func (SortedList* self)
{
	return self->priv->g_destroy_func;
}


static void
sorted_list_gee_traversable_interface_init (GeeTraversableIface * iface)
{
	sorted_list_gee_traversable_parent_iface = g_type_interface_peek_parent (iface);
	iface->foreach = (gboolean (*) (GeeTraversable *, GeeForallFunc, gpointer)) sorted_list_real_foreach;
	iface->get_g_type = (GType (*) (GeeTraversable *)) sorted_list_gee_traversable_get_g_type;
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeTraversable *)) sorted_list_gee_traversable_get_g_dup_func;
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeTraversable *)) sorted_list_gee_traversable_get_g_destroy_func;
	iface->get_element_type = sorted_list_real_get_element_type;
}


static GType
sorted_list_gee_iterable_get_g_type (SortedList* self)
{
	return self->priv->g_type;
}


static GBoxedCopyFunc
sorted_list_gee_iterable_get_g_dup_func (SortedList* self)
{
	return self->priv->g_dup_func;
}


static GDestroyNotify
sorted_list_gee_iterable_get_g_destroy_func (SortedList* self)
{
	return self->priv->g_destroy_func;
}


static void
sorted_list_gee_iterable_interface_init (GeeIterableIface * iface)
{
	sorted_list_gee_iterable_parent_iface = g_type_interface_peek_parent (iface);
	iface->iterator = (GeeIterator* (*) (GeeIterable *)) sorted_list_real_iterator;
	iface->get_g_type = (GType (*) (GeeIterable *)) sorted_list_gee_iterable_get_g_type;
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeIterable *)) sorted_list_gee_iterable_get_g_dup_func;
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeIterable *)) sorted_list_gee_iterable_get_g_destroy_func;
}


static GType
sorted_list_gee_collection_get_g_type (SortedList* self)
{
	return self->priv->g_type;
}


static GBoxedCopyFunc
sorted_list_gee_collection_get_g_dup_func (SortedList* self)
{
	return self->priv->g_dup_func;
}


static GDestroyNotify
sorted_list_gee_collection_get_g_destroy_func (SortedList* self)
{
	return self->priv->g_destroy_func;
}


static void
sorted_list_gee_collection_interface_init (GeeCollectionIface * iface)
{
	sorted_list_gee_collection_parent_iface = g_type_interface_peek_parent (iface);
	iface->add = (gboolean (*) (GeeCollection *, gconstpointer)) sorted_list_real_add;
	iface->add_all = (gboolean (*) (GeeCollection *, GeeCollection*)) sorted_list_real_add_all;
	iface->clear = (void (*) (GeeCollection *)) sorted_list_real_clear;
	iface->contains = (gboolean (*) (GeeCollection *, gconstpointer)) sorted_list_real_contains;
	iface->contains_all = (gboolean (*) (GeeCollection *, GeeCollection*)) sorted_list_real_contains_all;
	iface->remove = (gboolean (*) (GeeCollection *, gconstpointer)) sorted_list_real_remove;
	iface->remove_all = (gboolean (*) (GeeCollection *, GeeCollection*)) sorted_list_real_remove_all;
	iface->retain_all = (gboolean (*) (GeeCollection *, GeeCollection*)) sorted_list_real_retain_all;
	iface->to_array = (gpointer* (*) (GeeCollection *, int*)) sorted_list_real_to_array;
	iface->get_g_type = (GType (*) (GeeCollection *)) sorted_list_gee_collection_get_g_type;
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeCollection *)) sorted_list_gee_collection_get_g_dup_func;
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeCollection *)) sorted_list_gee_collection_get_g_destroy_func;
	iface->get_read_only = sorted_list_real_get_read_only;
	iface->get_is_empty = sorted_list_real_get_is_empty;
	iface->get_size = sorted_list_real_get_size;
	iface->get_read_only_view = sorted_list_real_get_read_only_view;
}


static void
sorted_list_instance_init (SortedList * self)
{
	self->priv = sorted_list_get_instance_private (self);
}


static void
sorted_list_finalize (GObject * obj)
{
	SortedList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SORTED_LIST, SortedList);
	_g_object_unref0 (self->priv->list);
	G_OBJECT_CLASS (sorted_list_parent_class)->finalize (obj);
}


GType
sorted_list_get_type (void)
{
	static volatile gsize sorted_list_type_id__volatile = 0;
	if (g_once_init_enter (&sorted_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SortedListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sorted_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SortedList), 0, (GInstanceInitFunc) sorted_list_instance_init, NULL };
		static const GInterfaceInfo gee_traversable_info = { (GInterfaceInitFunc) sorted_list_gee_traversable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gee_iterable_info = { (GInterfaceInitFunc) sorted_list_gee_iterable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gee_collection_info = { (GInterfaceInitFunc) sorted_list_gee_collection_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType sorted_list_type_id;
		sorted_list_type_id = g_type_register_static (G_TYPE_OBJECT, "SortedList", &g_define_type_info, 0);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_TRAVERSABLE, &gee_traversable_info);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_ITERABLE, &gee_iterable_info);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_COLLECTION, &gee_collection_info);
		SortedList_private_offset = g_type_add_instance_private (sorted_list_type_id, sizeof (SortedListPrivate));
		g_once_init_leave (&sorted_list_type_id__volatile, sorted_list_type_id);
	}
	return sorted_list_type_id__volatile;
}


static void
_vala_sorted_list_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SortedList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SORTED_LIST, SortedList);
	switch (property_id) {
		case SORTED_LIST_ELEMENT_TYPE_PROPERTY:
		g_value_set_gtype (value, gee_traversable_get_element_type (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_TRAVERSABLE, GeeTraversable)));
		break;
		case SORTED_LIST_READ_ONLY_PROPERTY:
		g_value_set_boolean (value, gee_collection_get_read_only (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_COLLECTION, GeeCollection)));
		break;
		case SORTED_LIST_IS_EMPTY_PROPERTY:
		g_value_set_boolean (value, gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_COLLECTION, GeeCollection)));
		break;
		case SORTED_LIST_SIZE_PROPERTY:
		g_value_set_int (value, gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_COLLECTION, GeeCollection)));
		break;
		case SORTED_LIST_READ_ONLY_VIEW_PROPERTY:
		g_value_take_object (value, gee_collection_get_read_only_view (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_COLLECTION, GeeCollection)));
		break;
		case SORTED_LIST_READ_ONLY_VIEW_AS_LIST_PROPERTY:
		g_value_take_object (value, sorted_list_get_read_only_view_as_list (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_sorted_list_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SortedList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SORTED_LIST, SortedList);
	switch (property_id) {
		case SORTED_LIST_G_TYPE:
		self->priv->g_type = g_value_get_gtype (value);
		break;
		case SORTED_LIST_G_DUP_FUNC:
		self->priv->g_dup_func = g_value_get_pointer (value);
		break;
		case SORTED_LIST_G_DESTROY_FUNC:
		self->priv->g_destroy_func = g_value_get_pointer (value);
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



