/* string.c generated by valac 0.42.0, the Vala compiler
 * generated from string.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define TYPE_PREPARE_INPUT_TEXT_OPTIONS (prepare_input_text_options_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL = 1 << 0,
	PREPARE_INPUT_TEXT_OPTIONS_VALIDATE = 1 << 1,
	PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL = 1 << 2,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP = 1 << 3,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF = 1 << 4,
	PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE = 1 << 5,
	PREPARE_INPUT_TEXT_OPTIONS_DEFAULT = ((((PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) | PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE
} PrepareInputTextOptions;



gint64 g_ascii_strtoll (const gchar* str,
                        gchar** endptr,
                        guint num_base);
#define DEFAULT_USER_TEXT_INPUT_LENGTH 1024
gboolean is_string_empty (const gchar* s);
gint utf8_cs_compare (void* a,
                      void* b);
gint utf8_ci_compare (void* a,
                      void* b);
gchar* uchar_array_to_string (guchar* data,
                              int data_length1,
                              gint length);
guchar* string_to_uchar_array (const gchar* str,
                               int* result_length1);
static void _vala_array_add1 (guchar* * array,
                       int* length,
                       int* size,
                       guchar value);
gchar* guarded_markup_escape_text (const gchar* plain);
glong find_last_offset (const gchar* str,
                        gchar c);
gboolean is_in_ci_array (const gchar* str,
                         gchar** strings,
                         int strings_length1);
GType prepare_input_text_options_get_type (void) G_GNUC_CONST;
gchar* guess_convert (const gchar* text);
gchar* prepare_input_text (const gchar* text,
                           PrepareInputTextOptions options,
                           gint dest_length);
gint64 parse_int64 (const gchar* str,
                    gint num_base);
gboolean string_contains_char (const gchar* haystack,
                               gunichar needle);
gboolean string_contains_str (const gchar* haystack,
                              const gchar* needle);
gchar* string_sliced_at (const gchar* str,
                         gint index);
gchar* string_sliced_at_first_str (const gchar* haystack,
                                   const gchar* needle,
                                   gint start_index);
gchar* string_sliced_at_last_str (const gchar* haystack,
                                  const gchar* needle,
                                  gint start_index);
gchar* string_sliced_at_first_char (const gchar* haystack,
                                    gunichar ch,
                                    gint start_index);
gchar* string_sliced_at_last_char (const gchar* haystack,
                                   gunichar ch,
                                   gint start_index);
gchar* string_strip_leading_zeroes (const gchar* str);
gchar* string_remove_diacritics (const gchar* istring);
gchar* string_to_hex_string (const gchar* str);
guint string_collated_hash (void* ptr);
guint string_precollated_hash (void* ptr);
gint string_collated_compare (void* a,
                              void* b);
gint string_precollated_compare (const gchar* astr,
                                 const gchar* akey,
                                 const gchar* bstr,
                                 const gchar* bkey);
gboolean string_collated_equals (void* a,
                                 void* b);
gboolean string_precollated_equals (const gchar* astr,
                                    const gchar* akey,
                                    const gchar* bstr,
                                    const gchar* bkey);


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}


inline gboolean
is_string_empty (const gchar* s)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	if (s == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = string_get (s, (glong) 0) == '\0';
	}
	result = _tmp0_;
	return result;
}


gint
utf8_cs_compare (void* a,
                 void* b)
{
	gint result = 0;
	result = g_utf8_collate ((const gchar*) a, (const gchar*) b);
	return result;
}


gint
utf8_ci_compare (void* a,
                 void* b)
{
	gint result = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	_tmp0_ = g_utf8_strdown ((const gchar*) a, (gssize) -1);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_utf8_strdown ((const gchar*) b, (gssize) -1);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_utf8_collate (_tmp1_, _tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	result = _tmp4_;
	return result;
}


gchar*
uchar_array_to_string (guchar* data,
                       int data_length1,
                       gint length)
{
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	if (length < 0) {
		length = data_length1;
	}
	_tmp0_ = g_string_new ("");
	builder = _tmp0_;
	{
		gint ctr = 0;
		ctr = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				gint _tmp4_;
				guchar _tmp5_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = ctr;
					ctr = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = ctr;
				if (!(_tmp3_ < length)) {
					break;
				}
				_tmp4_ = ctr;
				_tmp5_ = data[_tmp4_];
				if (_tmp5_ != ((guchar) '\0')) {
					GString* _tmp6_;
					gint _tmp7_;
					guchar _tmp8_;
					_tmp6_ = builder;
					_tmp7_ = ctr;
					_tmp8_ = data[_tmp7_];
					g_string_append_c (_tmp6_, (gchar) _tmp8_);
				} else {
					break;
				}
			}
		}
	}
	_tmp9_ = builder;
	_tmp10_ = _tmp9_->str;
	_tmp11_ = g_strdup (_tmp10_);
	result = _tmp11_;
	_g_string_free0 (builder);
	return result;
}


static void
_vala_array_add1 (guchar* * array,
                  int* length,
                  int* size,
                  guchar value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (guchar, *array, *size);
	}
	(*array)[(*length)++] = value;
}


guchar*
string_to_uchar_array (const gchar* str,
                       int* result_length1)
{
	guchar* result = NULL;
	guchar* data = NULL;
	guchar* _tmp0_;
	gint data_length1;
	gint _data_size_;
	guchar* _tmp8_;
	gint _tmp8__length1;
	g_return_val_if_fail (str != NULL, NULL);
	_tmp0_ = g_new0 (guchar, 0);
	data = _tmp0_;
	data_length1 = 0;
	_data_size_ = data_length1;
	{
		gint ctr = 0;
		ctr = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				guchar* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = ctr;
					ctr = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = ctr;
				_tmp4_ = strlen (str);
				_tmp5_ = _tmp4_;
				if (!(_tmp3_ < _tmp5_)) {
					break;
				}
				_tmp6_ = data;
				_tmp6__length1 = data_length1;
				_tmp7_ = ctr;
				_vala_array_add1 (&data, &data_length1, &_data_size_, (guchar) string_get (str, (glong) _tmp7_));
			}
		}
	}
	_tmp8_ = data;
	_tmp8__length1 = data_length1;
	if (result_length1) {
		*result_length1 = _tmp8__length1;
	}
	result = _tmp8_;
	return result;
}


inline gchar*
guarded_markup_escape_text (const gchar* plain)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	if (!is_string_empty (plain)) {
		gboolean _tmp2_;
		_tmp2_ = g_utf8_validate (plain, (gssize) -1, NULL);
		_tmp1_ = _tmp2_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gchar* _tmp3_;
		_tmp3_ = g_markup_escape_text (plain, (gssize) -1);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
	} else {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	}
	result = _tmp0_;
	return result;
}


glong
find_last_offset (const gchar* str,
                  gchar c)
{
	glong result = 0L;
	glong offset = 0L;
	gint _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (str != NULL, 0L);
	_tmp0_ = strlen (str);
	_tmp1_ = _tmp0_;
	offset = (glong) _tmp1_;
	while (TRUE) {
		glong _tmp2_;
		glong _tmp3_;
		glong _tmp4_;
		_tmp2_ = offset;
		offset = _tmp2_ - 1;
		_tmp3_ = offset;
		if (!(_tmp3_ >= ((glong) 0))) {
			break;
		}
		_tmp4_ = offset;
		if (string_get (str, _tmp4_) == c) {
			result = offset;
			return result;
		}
	}
	result = (glong) -1;
	return result;
}


gboolean
is_in_ci_array (const gchar* str,
                gchar** strings,
                int strings_length1)
{
	gboolean result = FALSE;
	gchar* strdown = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (str != NULL, FALSE);
	_tmp0_ = g_utf8_strdown (str, (gssize) -1);
	strdown = _tmp0_;
	{
		gchar** str_element_collection = NULL;
		gint str_element_collection_length1 = 0;
		gint _str_element_collection_size_ = 0;
		gint str_element_it = 0;
		str_element_collection = strings;
		str_element_collection_length1 = strings_length1;
		for (str_element_it = 0; str_element_it < strings_length1; str_element_it = str_element_it + 1) {
			gchar* _tmp1_;
			gchar* str_element = NULL;
			_tmp1_ = g_strdup (str_element_collection[str_element_it]);
			str_element = _tmp1_;
			{
				const gchar* _tmp2_;
				const gchar* _tmp3_;
				_tmp2_ = strdown;
				_tmp3_ = str_element;
				if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
					result = TRUE;
					_g_free0 (str_element);
					_g_free0 (strdown);
					return result;
				}
				_g_free0 (str_element);
			}
		}
	}
	result = FALSE;
	_g_free0 (strdown);
	return result;
}


GType
prepare_input_text_options_get_type (void)
{
	static volatile gsize prepare_input_text_options_type_id__volatile = 0;
	if (g_once_init_enter (&prepare_input_text_options_type_id__volatile)) {
		static const GFlagsValue values[] = {{PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL, "PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL", "empty-is-null"}, {PREPARE_INPUT_TEXT_OPTIONS_VALIDATE, "PREPARE_INPUT_TEXT_OPTIONS_VALIDATE", "validate"}, {PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL, "PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL", "invalid-is-null"}, {PREPARE_INPUT_TEXT_OPTIONS_STRIP, "PREPARE_INPUT_TEXT_OPTIONS_STRIP", "strip"}, {PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF, "PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF", "strip-crlf"}, {PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE, "PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE", "normalize"}, {PREPARE_INPUT_TEXT_OPTIONS_DEFAULT, "PREPARE_INPUT_TEXT_OPTIONS_DEFAULT", "default"}, {0, NULL, NULL}};
		GType prepare_input_text_options_type_id;
		prepare_input_text_options_type_id = g_flags_register_static ("PrepareInputTextOptions", values);
		g_once_init_leave (&prepare_input_text_options_type_id__volatile, prepare_input_text_options_type_id);
	}
	return prepare_input_text_options_type_id__volatile;
}


gchar*
guess_convert (const gchar* text)
{
	gchar* result = NULL;
	gchar* output = NULL;
	gsize bytes_read = 0UL;
	const gchar* charset = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gsize _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	output = NULL;
	bytes_read = (gsize) 0;
	charset = NULL;
	g_debug ("string.vala:98: CONVERT: Text did not validate as UTF-8, trying conver" \
"sion");
	_tmp1_ = g_get_charset (&_tmp0_);
	charset = _tmp0_;
	if (!_tmp1_) {
		gint _tmp2_;
		gint _tmp3_;
		gsize _tmp4_ = 0UL;
		gchar* _tmp5_;
		gsize _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		_tmp2_ = strlen (text);
		_tmp3_ = _tmp2_;
		_tmp5_ = g_locale_to_utf8 (text, (gssize) _tmp3_, &_tmp4_, NULL, NULL);
		bytes_read = _tmp4_;
		_g_free0 (output);
		output = _tmp5_;
		_tmp6_ = bytes_read;
		_tmp7_ = strlen (text);
		_tmp8_ = _tmp7_;
		if (_tmp6_ == ((gsize) _tmp8_)) {
			const gchar* _tmp9_;
			_tmp9_ = charset;
			g_debug ("string.vala:104: CONVERT: Locale is not UTF-8, convert from %s", _tmp9_);
			result = output;
			return result;
		}
	}
	{
		gchar* _tmp10_ = NULL;
		gint _tmp11_;
		gint _tmp12_;
		gsize _tmp13_ = 0UL;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp11_ = strlen (text);
		_tmp12_ = _tmp11_;
		_tmp14_ = g_convert (text, (gssize) _tmp12_, "UTF-8", "WINDOWS-1252", &_tmp13_, NULL, &_inner_error_);
		bytes_read = _tmp13_;
		_tmp10_ = _tmp14_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_CONVERT_ERROR) {
				goto __catch7_g_convert_error;
			}
			_g_free0 (output);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp15_ = _tmp10_;
		_tmp10_ = NULL;
		_g_free0 (output);
		output = _tmp15_;
		charset = "WINDOWS-1252";
		_g_free0 (_tmp10_);
	}
	goto __finally7;
	__catch7_g_convert_error:
	{
		GError* _error_ = NULL;
		GError* _tmp16_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		_tmp16_ = _error_;
		if (g_error_matches (_tmp16_, G_CONVERT_ERROR, G_CONVERT_ERROR_NO_CONVERSION)) {
			{
				gchar* _tmp17_ = NULL;
				gint _tmp18_;
				gint _tmp19_;
				gsize _tmp20_ = 0UL;
				gchar* _tmp21_;
				gchar* _tmp22_;
				_tmp18_ = strlen (text);
				_tmp19_ = _tmp18_;
				_tmp21_ = g_convert (text, (gssize) _tmp19_, "UTF-8", "ISO-8859-1", &_tmp20_, NULL, &_inner_error_);
				bytes_read = _tmp20_;
				_tmp17_ = _tmp21_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					goto __catch8_g_error;
				}
				_tmp22_ = _tmp17_;
				_tmp17_ = NULL;
				_g_free0 (output);
				output = _tmp22_;
				charset = "ISO-8859-1";
				_g_free0 (_tmp17_);
			}
			goto __finally8;
			__catch8_g_error:
			{
				GError* _error_ = NULL;
				_error_ = _inner_error_;
				_inner_error_ = NULL;
				_g_error_free0 (_error_);
			}
			__finally8:
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_error_free0 (_error_);
				_g_error_free0 (_error_);
				_g_free0 (output);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_g_error_free0 (_error_);
	}
	__finally7:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (output);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp23_ = bytes_read;
	_tmp24_ = strlen (text);
	_tmp25_ = _tmp24_;
	if (_tmp23_ == ((gsize) _tmp25_)) {
		const gchar* _tmp26_;
		_tmp26_ = charset;
		g_debug ("string.vala:122: CONVERT: Guessed conversion from %s", _tmp26_);
		result = output;
		return result;
	}
	result = NULL;
	_g_free0 (output);
	return result;
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static gchar*
string_delimit (const gchar* self,
                const gchar* delimiters,
                gchar new_delimiter)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (delimiters != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strdelimit (_tmp1_, delimiters, new_delimiter);
	result = _result_;
	return result;
}


gchar*
prepare_input_text (const gchar* text,
                    PrepareInputTextOptions options,
                    gint dest_length)
{
	gchar* result = NULL;
	gchar* prepped = NULL;
	gchar* _tmp0_;
	gboolean _tmp12_ = FALSE;
	if (text == NULL) {
		result = NULL;
		return result;
	}
	_tmp0_ = g_strdup (text);
	prepped = _tmp0_;
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) == PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) {
		gboolean _tmp1_;
		_tmp1_ = g_utf8_validate (text, (gssize) -1, NULL);
		if (!_tmp1_) {
			gchar* _tmp2_;
			const gchar* _tmp3_;
			_tmp2_ = guess_convert (text);
			_g_free0 (prepped);
			prepped = _tmp2_;
			_tmp3_ = prepped;
			if (_tmp3_ == NULL) {
				const gchar* _tmp4_ = NULL;
				gchar* _tmp5_;
				if ((options & PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) != 0) {
					_tmp4_ = NULL;
				} else {
					_tmp4_ = "";
				}
				_tmp5_ = g_strdup (_tmp4_);
				result = _tmp5_;
				_g_free0 (prepped);
				return result;
			}
		}
	}
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE) != 0) {
		const gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp6_ = prepped;
		_tmp7_ = g_utf8_normalize (_tmp6_, (gssize) -1, G_NORMALIZE_NFC);
		_g_free0 (prepped);
		prepped = _tmp7_;
	}
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_STRIP) != 0) {
		const gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp8_ = prepped;
		_tmp9_ = string_strip (_tmp8_);
		_g_free0 (prepped);
		prepped = _tmp9_;
	}
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) != 0) {
		const gchar* _tmp10_;
		gchar* _tmp11_;
		_tmp10_ = prepped;
		_tmp11_ = string_delimit (_tmp10_, "\n\r", ' ');
		_g_free0 (prepped);
		prepped = _tmp11_;
	}
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL) != 0) {
		const gchar* _tmp13_;
		_tmp13_ = prepped;
		_tmp12_ = is_string_empty (_tmp13_);
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		result = NULL;
		_g_free0 (prepped);
		return result;
	}
	if (dest_length >= 0) {
		GString* sb = NULL;
		const gchar* _tmp14_;
		GString* _tmp15_;
		GString* _tmp16_;
		GString* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		_tmp14_ = prepped;
		_tmp15_ = g_string_new (_tmp14_);
		sb = _tmp15_;
		_tmp16_ = sb;
		g_string_truncate (_tmp16_, (gsize) dest_length);
		_tmp17_ = sb;
		_tmp18_ = _tmp17_->str;
		_tmp19_ = g_strdup (_tmp18_);
		result = _tmp19_;
		_g_string_free0 (sb);
		_g_free0 (prepped);
		return result;
	}
	result = prepped;
	return result;
}


gint64
parse_int64 (const gchar* str,
             gint num_base)
{
	gint64 result = 0LL;
	gint64 _tmp0_;
	g_return_val_if_fail (str != NULL, 0LL);
	_tmp0_ = g_ascii_strtoll (str, NULL, (guint) num_base);
	result = _tmp0_;
	return result;
}


static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


inline gboolean
string_contains_char (const gchar* haystack,
                      gunichar needle)
{
	gboolean result = FALSE;
	g_return_val_if_fail (haystack != NULL, FALSE);
	result = string_index_of_char (haystack, needle, 0) >= 0;
	return result;
}


static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


inline gboolean
string_contains_str (const gchar* haystack,
                     const gchar* needle)
{
	gboolean result = FALSE;
	g_return_val_if_fail (haystack != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	result = string_index_of (haystack, needle, 0) >= 0;
	return result;
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		glong _tmp2_;
		_tmp2_ = string_length;
		start = _tmp2_ + start;
	}
	if (end < ((glong) 0)) {
		glong _tmp3_;
		_tmp3_ = string_length;
		end = _tmp3_ + end;
	}
	if (start >= ((glong) 0)) {
		glong _tmp5_;
		_tmp5_ = string_length;
		_tmp4_ = start <= _tmp5_;
	} else {
		_tmp4_ = FALSE;
	}
	g_return_val_if_fail (_tmp4_, NULL);
	if (end >= ((glong) 0)) {
		glong _tmp7_;
		_tmp7_ = string_length;
		_tmp6_ = end <= _tmp7_;
	} else {
		_tmp6_ = FALSE;
	}
	g_return_val_if_fail (_tmp6_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp8_;
	return result;
}


inline gchar*
string_sliced_at (const gchar* str,
                  gint index)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (str != NULL, NULL);
	if (index >= 0) {
		gint _tmp1_;
		gint _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = strlen (str);
		_tmp2_ = _tmp1_;
		_tmp3_ = string_slice (str, (glong) index, (glong) _tmp2_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
	} else {
		_g_free0 (_tmp0_);
		_tmp0_ = NULL;
	}
	result = _tmp0_;
	return result;
}


inline gchar*
string_sliced_at_first_str (const gchar* haystack,
                            const gchar* needle,
                            gint start_index)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (haystack != NULL, NULL);
	g_return_val_if_fail (needle != NULL, NULL);
	_tmp0_ = string_sliced_at (haystack, string_index_of (haystack, needle, start_index));
	result = _tmp0_;
	return result;
}


static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


inline gchar*
string_sliced_at_last_str (const gchar* haystack,
                           const gchar* needle,
                           gint start_index)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (haystack != NULL, NULL);
	g_return_val_if_fail (needle != NULL, NULL);
	_tmp0_ = string_sliced_at (haystack, string_last_index_of (haystack, needle, start_index));
	result = _tmp0_;
	return result;
}


inline gchar*
string_sliced_at_first_char (const gchar* haystack,
                             gunichar ch,
                             gint start_index)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (haystack != NULL, NULL);
	_tmp0_ = string_sliced_at (haystack, string_index_of_char (haystack, ch, start_index));
	result = _tmp0_;
	return result;
}


static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


inline gchar*
string_sliced_at_last_char (const gchar* haystack,
                            gunichar ch,
                            gint start_index)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (haystack != NULL, NULL);
	_tmp0_ = string_sliced_at (haystack, string_last_index_of_char (haystack, ch, start_index));
	result = _tmp0_;
	return result;
}


static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	result = g_utf8_get_char (((gchar*) self) + index);
	return result;
}


gchar*
string_strip_leading_zeroes (const gchar* str)
{
	gchar* result = NULL;
	GString* stripped = NULL;
	GString* _tmp0_;
	gboolean prev_is_space = FALSE;
	GString* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	g_return_val_if_fail (str != NULL, NULL);
	_tmp0_ = g_string_new ("");
	stripped = _tmp0_;
	prev_is_space = TRUE;
	{
		const gchar* iter = NULL;
		iter = str;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				const gchar* _tmp4_;
				gunichar ch = 0U;
				const gchar* _tmp5_;
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_;
				if (!_tmp1_) {
					const gchar* _tmp2_;
					const gchar* _tmp3_;
					_tmp2_ = iter;
					_tmp3_ = g_utf8_next_char (_tmp2_);
					iter = _tmp3_;
				}
				_tmp1_ = FALSE;
				_tmp4_ = iter;
				if (!(string_get_char (_tmp4_, (glong) 0) != ((gunichar) 0))) {
					break;
				}
				_tmp5_ = iter;
				ch = string_get_char (_tmp5_, (glong) 0);
				_tmp7_ = prev_is_space;
				if (!_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gunichar _tmp8_;
					_tmp8_ = ch;
					_tmp6_ = _tmp8_ != ((gunichar) '0');
				}
				if (_tmp6_) {
					GString* _tmp9_;
					gunichar _tmp10_;
					gunichar _tmp11_;
					_tmp9_ = stripped;
					_tmp10_ = ch;
					g_string_append_unichar (_tmp9_, _tmp10_);
					_tmp11_ = ch;
					prev_is_space = g_unichar_isspace (_tmp11_);
				}
			}
		}
	}
	_tmp12_ = stripped;
	_tmp13_ = _tmp12_->str;
	_tmp14_ = g_strdup (_tmp13_);
	result = _tmp14_;
	_g_string_free0 (stripped);
	return result;
}


static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gunichar _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
	_tmp0_ = _vala_c;
	if (_tmp0_ != ((gunichar) 0)) {
		gchar* _tmp1_;
		_tmp1_ = g_utf8_next_char (((gchar*) self) + (*index));
		*index = (gint) (_tmp1_ - ((gchar*) self));
		result = TRUE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	} else {
		result = FALSE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	}
	if (c) {
		*c = _vala_c;
	}
}


gchar*
string_remove_diacritics (const gchar* istring)
{
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_;
	gunichar ch = 0U;
	gint i = 0;
	GString* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	g_return_val_if_fail (istring != NULL, NULL);
	_tmp0_ = g_string_new ("");
	builder = _tmp0_;
	i = 0;
	while (TRUE) {
		gchar* _tmp1_;
		gchar* _tmp2_;
		gunichar _tmp3_ = 0U;
		gboolean _tmp4_;
		gboolean _tmp5_;
		gunichar _tmp6_;
		GString* _tmp7_;
		gunichar _tmp8_;
		_tmp1_ = g_utf8_normalize (istring, (gssize) -1, G_NORMALIZE_DEFAULT);
		_tmp2_ = _tmp1_;
		_tmp4_ = string_get_next_char (_tmp2_, &i, &_tmp3_);
		ch = _tmp3_;
		_tmp5_ = !_tmp4_;
		_g_free0 (_tmp2_);
		if (_tmp5_) {
			break;
		}
		_tmp6_ = ch;
		switch (g_unichar_type (_tmp6_)) {
			case G_UNICODE_CONTROL:
			case G_UNICODE_FORMAT:
			case G_UNICODE_UNASSIGNED:
			case G_UNICODE_NON_SPACING_MARK:
			case G_UNICODE_COMBINING_MARK:
			case G_UNICODE_ENCLOSING_MARK:
			{
				continue;
			}
			default:
			break;
		}
		_tmp7_ = builder;
		_tmp8_ = ch;
		g_string_append_unichar (_tmp7_, _tmp8_);
	}
	_tmp9_ = builder;
	_tmp10_ = _tmp9_->str;
	_tmp11_ = g_strdup (_tmp10_);
	result = _tmp11_;
	_g_string_free0 (builder);
	return result;
}


gchar*
string_to_hex_string (const gchar* str)
{
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_;
	guint8* data = NULL;
	GString* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	g_return_val_if_fail (str != NULL, NULL);
	_tmp0_ = g_string_new ("");
	builder = _tmp0_;
	data = (guint8*) str;
	while (TRUE) {
		guint8* _tmp1_;
		const gchar* _tmp2_ = NULL;
		guint8* _tmp3_;
		GString* _tmp4_;
		guint8* _tmp5_;
		_tmp1_ = data;
		if (!(((gint) (*_tmp1_)) != 0)) {
			break;
		}
		_tmp3_ = data;
		if (((gint) (*_tmp3_)) != 0) {
			_tmp2_ = " ";
		} else {
			_tmp2_ = "";
		}
		_tmp4_ = builder;
		_tmp5_ = data;
		data = _tmp5_ + 1;
		g_string_append_printf (_tmp4_, "%02Xh%s", (guint) (*_tmp5_), _tmp2_);
	}
	_tmp6_ = builder;
	_tmp7_ = _tmp6_->str;
	_tmp8_ = g_strdup (_tmp7_);
	result = _tmp8_;
	_g_string_free0 (builder);
	return result;
}


guint
string_collated_hash (void* ptr)
{
	guint result = 0U;
	gchar* str = NULL;
	gchar* _tmp0_;
	GHashFunc _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint _tmp4_;
	_tmp0_ = g_strdup ((const gchar*) ptr);
	str = _tmp0_;
	_tmp1_ = g_str_hash;
	_tmp2_ = g_utf8_collate_key (str, (gssize) -1);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp1_ (_tmp3_);
	_g_free0 (_tmp3_);
	result = _tmp4_;
	_g_free0 (str);
	return result;
}


guint
string_precollated_hash (void* ptr)
{
	guint result = 0U;
	GHashFunc _tmp0_;
	_tmp0_ = g_str_hash;
	result = _tmp0_ ((const gchar*) ptr);
	return result;
}


gint
string_collated_compare (void* a,
                         void* b)
{
	gint result = 0;
	gchar* astr = NULL;
	gchar* _tmp0_;
	gchar* bstr = NULL;
	gchar* _tmp1_;
	gint _result_ = 0;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_ = 0;
	gint _tmp5_;
	_tmp0_ = g_strdup ((const gchar*) a);
	astr = _tmp0_;
	_tmp1_ = g_strdup ((const gchar*) b);
	bstr = _tmp1_;
	_tmp2_ = astr;
	_tmp3_ = bstr;
	_result_ = g_utf8_collate (_tmp2_, _tmp3_);
	_tmp5_ = _result_;
	if (_tmp5_ != 0) {
		gint _tmp6_;
		_tmp6_ = _result_;
		_tmp4_ = _tmp6_;
	} else {
		GCompareFunc _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		_tmp7_ = g_strcmp0;
		_tmp8_ = astr;
		_tmp9_ = bstr;
		_tmp4_ = _tmp7_ (_tmp8_, _tmp9_);
	}
	result = _tmp4_;
	_g_free0 (bstr);
	_g_free0 (astr);
	return result;
}


gint
string_precollated_compare (const gchar* astr,
                            const gchar* akey,
                            const gchar* bstr,
                            const gchar* bkey)
{
	gint result = 0;
	gint _result_ = 0;
	GCompareFunc _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_;
	g_return_val_if_fail (astr != NULL, 0);
	g_return_val_if_fail (akey != NULL, 0);
	g_return_val_if_fail (bstr != NULL, 0);
	g_return_val_if_fail (bkey != NULL, 0);
	_tmp0_ = g_strcmp0;
	_result_ = _tmp0_ (akey, bkey);
	_tmp2_ = _result_;
	if (_tmp2_ != 0) {
		gint _tmp3_;
		_tmp3_ = _result_;
		_tmp1_ = _tmp3_;
	} else {
		GCompareFunc _tmp4_;
		_tmp4_ = g_strcmp0;
		_tmp1_ = _tmp4_ (astr, bstr);
	}
	result = _tmp1_;
	return result;
}


gboolean
string_collated_equals (void* a,
                        void* b)
{
	gboolean result = FALSE;
	result = string_collated_compare (a, b) == 0;
	return result;
}


gboolean
string_precollated_equals (const gchar* astr,
                           const gchar* akey,
                           const gchar* bstr,
                           const gchar* bkey)
{
	gboolean result = FALSE;
	g_return_val_if_fail (astr != NULL, FALSE);
	g_return_val_if_fail (akey != NULL, FALSE);
	g_return_val_if_fail (bstr != NULL, FALSE);
	g_return_val_if_fail (bkey != NULL, FALSE);
	result = string_precollated_compare (astr, akey, bstr, bkey) == 0;
	return result;
}



